/*------------------------------------------*/
/*  Strukturdefinitionen fuer PanPlot       */
/*  Dr. Rainer Sieger, AWI-Bremerhaven      */
/*------------------------------------------*/

#include "Win_Globals.h"

#define maxPTData								 2000
#define MAXSPLITNUMOFPARAMETERS   600
#define MAXNUMOFCOMMENTS				 1000
#define MAXNUMOFPARAMETERS    		256
#define MAXNUMOFCOLORS						256
#define MAXNUMOFBITMAPS						256
#define MAXNUMOFFILES        			200
#define MAXNUMOFCHAR       			10000
#define MAXNUMOFCCHAR							511
#define MAXNUMOFITEM  		        200

#define NUMTEXTDIALOG							511

//------------------------------------------------------------------
// Typedefinitionen

// Data Description
typedef struct{
			Str31		 Title;
			Str511	 Text;
} DDData;

// Comment
typedef struct{
			int    Parameter;			
			float	 Depth;
			Str80	 Text;
} CData;

// Metadaten
typedef struct{
      Str80  					Header;
			Str80  					GroupName;
			int							NumOfParametersInGroup;
      unsigned long		counts;
      int    					P[5];
      float  					K[5];
      float  					S[5];
      float  					min;
      float  					max;
      unsigned long   Offset;
} Container;

// Daten
typedef struct{
			int   F;  // Qualitiy flag
			long 	I;  // Index
      float	V;	// Value
} Data;

// Item
typedef struct{
      int     what;		// what
      int			Value;	// Item Value
			Str255  Text;		// Item Text
} DialogItem;

//  Steuerparameter
typedef struct{
      int      Parameter;
			Str31		 FormatStr;			
      int      Colorize;
			int      RGB;	
      int      PlotData;
      int      PlotLine;
      int      PlotCHistogramm;
      int      PlotLHistogramm;
      int      PlotOHistogramm;
      int      PlotOccurrence;
      int      PlotText;
      int      PlotComment;
			int			 PlotLitho;
			int			 PlotBounds;
      int      PlotCourse;
      int      PlotMarker;
      int			 PlotGroupname;
      int			 PlotParametername;
      float    Refline;
			int			 ShowValid;
			int			 ShowNotValid;
			int			 ShowUnknown;
			int			 ShowQuestionable;
      int      ShowMissingData;
      int      AddNext;
      int      MSymbol;
      int      MSize;
      int      MLineWidth;
      int      LineWidth;
      int      ColumnWidth;
      float    Tick_Increment;
      int      Tickline;
      int      Minor_Ticks;
      int      Minor_Tickline;
      int      BothSide;
      int      Inside;
			int			 ParameterTextOrientation;
      float    min;
      float    max;
      int      SetDefaultRange;
			int      ReverseRange;
			int      ParameterWidth;
      int      fixedParameterWidth;
      int			 GroupNo;      
      int      GPlotData;
      int      GMSymbol;
      int      GMSize;
      int      GLineWidth;
			float    GEpsilon;
			float    GRange;
      RGBColor Color;
      RGBColor GColor;
} Options;

// DefaultColor
typedef struct{
		  int			 Flag;
			Str80    Name;
      RGBColor Color;
} DefaultColor;