/*********************************************************************
*                                                                    *
*     ChangeHeader.c                                                 *
*                                                                    *
*     Programmautor: Rainer Sieger, Alfred-Wegener-Institut          *
*     Datei erstellt am: 26.09.2001                                  *
*     Letzte Aenderung: 01.08.2007                                   *
*                                                                    *
*********************************************************************/

#include <windows.h>
#include <string.h>
#include <stdio.h>
#include <time.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"

#include "ChangeHeader.h"
#include "replaceStr.h"

/*********************************************************************
**********************************************************************
*********************************************************************/

int ChangeHeader(int NumOfParameters)
{      
  int     err					= 0;
  int     j						= 0;
  int     m						= NumOfParameters;
   
	time_t	now;
	struct	tm *date;
  char    *p;

// **************
// Remove column "Event label"

	if ((!strcmp((char *) C[0].Header,"Event label")) || (!strcmp((char *) C[0].Header,"Event")))
	{
		for (j=1;j<=m;j++)
		{
	    memset((char *) C[j-1].Header, (int) '\0', 81);
			strcpy((char *) C[j-1].Header, (char *) C[j].Header); 
		}
		m--;
	}

// **************
// Remove column "Station"

	if (!strcmp((char *) C[0].Header,"Station"))
	{
		for (j=1;j<=m;j++)
		{
			memset((char *) C[j-1].Header, (int) '\0', 81);
			strcpy((char *) C[j-1].Header, (char *) C[j].Header); 
		}
		m--;
	}

// **************
// Remove column "LATITUDE"

	if ((!strcmp((char *) C[0].Header,"LATITUDE")) || (!strcmp((char *) C[0].Header,"Latitude")))
	{
		for (j=1;j<=m;j++)
		{
			memset((char *) C[j-1].Header, (int) '\0', 81);
			strcpy((char *) C[j-1].Header, (char *) C[j].Header); 
		}
		m--;
	}

// **************
// Remove column "LONGITUDE"

	if ((!strcmp((char *) C[0].Header,"LONGITUDE")) || (!strcmp((char *) C[0].Header,"Longitude")))
	{
		for (j=1;j<=m;j++)
		{
			memset((char *) C[j-1].Header, (int) '\0', 81);
			strcpy((char *) C[j-1].Header, (char *) C[j].Header); 
		}
		m--;
	}

// ******
// Korrektur des Promille-Zeichens

   for (j=0;j<=m;j++)
   {
   	   err = replaceStr((char *) C[j].Header,"","");	// Win
   	   err = replaceStr((char *) C[j].Header,"deg ","");	// Win   	   
   	   err = replaceStr((char *) C[j].Header,"%o","\x89");	// Win
   	   err = replaceStr((char *) C[j].Header,"per mil","\x89");	// Win

			 err = replaceStr((char *) C[j].Header,"Origin of Values","PANGAEA Dataset ID");
	 }

// ******
// RGB finden und setzen

 	 for (j=0;j<=m;j++)
	 {		 
	   strcpy((char *) InputStr,(char *) C[j].Header);
 	   err = replaceStr((char *) InputStr,"/","");
	   
	   if ((p = strstr((char *) InputStr, "RGB")) != NULL)
			 ST[j].RGB = 1;
 		 else
			 ST[j].RGB = 0;				 
	 }
	 
// ******
// Mode finden und setzen

   Mode = VerticalMode;

// ******
// Copyright text finden und setzen

	 now  = time(NULL);
	 date = localtime(&now);

   memset((char  *) strCRDateTime, '\0', 256);
	 strftime((char *) strCRDateTime, 32, "%Y-%m-%d %H:%M h", date );

   memset((char  *) strCRFilename, '\0', 512);
 	 strcpy((char *) strCRFilename, (char *) Name);
	 	 
   if ((p = strstr((char *) C[0].Header, "@")) != NULL)
   {
   	 strcpy((char *) Copyrighttext, p+1);
   	 *p = '\0';
	   if ((p = strstr((char *) Copyrighttext, " - ")) != NULL)
  	 {
	   	 strcpy((char *) strCRDateTime, p+3);
			 strcat((char *) strCRDateTime, " h");
	   	 *p = '\0';
	   	 strcpy((char *) strCRFilename, (char *) Copyrighttext);
	     memset((char  *) Copyrighttext, '\0', 256);
		 }
		 else
			 strcat((char *) Copyrighttext, "@");
   }

   return(NumOfParameters-m);
}

