/***********************************************************************
*                                                                      *
*    Datei                                                             *
*      Dialog.c                                                        *
*                                                                      *
************************************************************************
************************************************************************
*                                                                      *
*    Dr. Rainer Sieger                                                 *
*    letztes Editierdatum                                              *
*     19.07.2000                                                       *
***********************************************************************/

#include <windows.h>

#include <commctrl.h>
#include <commdlg.h>
#include <stdio.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Dialog.h"
#include "Version.h"   

#include "CreateFormat.h"
#include "replaceStr.h"

int Do_CautionAlert (HWND hwnd, short Dialog)
{
  char szBuffer[128];
  int err = bOK;

  switch (Dialog)
  {
  case rInfo:
      sprintf(szBuffer,"Number of columns: %d\nNumber of lines: %ld\nNumber of items: %ld", gNumOfParameters+1, C[0].counts, (gNumOfParameters+1)*C[0].counts);
      err = MessageBox (hwnd, szBuffer, szAppName, MB_OK | MB_ICONINFORMATION);
      break;
  case rVersion:
      sprintf(szBuffer,"Version number:\n%s",VersionNr);
      err = MessageBox (hwnd, szBuffer, szAppName, MB_OK | MB_ICONINFORMATION);
      break;
  }
  return 0;
}

BOOL CALLBACK AboutDlgProc (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch (iMsg)
			{
			case WM_INITDIALOG :
						SetFocus(hDlg);
						return FALSE;

			case WM_COMMAND :
						switch (LOWORD (wParam))
						{
							case IDOK :
									EndDialog (hDlg, TRUE);
									return TRUE;
						}
						break;
	          
			case WM_PAINT :
						break;
			}
	return FALSE;
}

void OkMessage (HWND hwnd, char *szMessage, char *szTitleName)
{
	char szBuffer[64 + _MAX_FNAME + _MAX_EXT];
	wsprintf (szBuffer, szMessage, szTitleName[0] ? szTitleName : UNTITLED);
	MessageBox (hwnd, szBuffer, szAppName, MB_OK | MB_ICONEXCLAMATION);
}

int AskAboutSave (HWND hwnd, char *szTitleName)
{
	char szBuffer[64 + _MAX_FNAME + _MAX_EXT];
	int  iReturn;

	wsprintf (szBuffer, "Save current changes in %s?", szTitleName[0] ? szTitleName : UNTITLED);

	iReturn = MessageBox (hwnd, szBuffer, szAppName, MB_YESNOCANCEL | MB_ICONQUESTION);

	if (iReturn == IDYES)
		if (!SendMessage (hwnd, WM_COMMAND, IDM_SAVE, 0L))
			iReturn = IDCANCEL;

	return iReturn;
}

int Do_Note_Dialog (HWND hwnd, short rID,unsigned long Zahl){return 0;}
int Do_Caution_Dialog (HWND hwnd, short rID,unsigned long Zahl){return 0;}
int Do_Caution_TextDialog (HWND hwnd, short Dialog, char Text1[], char Text2[]){return 0;}
int Do_StopAlert_Text (HWND hwnd, short Dialog, char Text[]){return 0;}

int Do_Error_Dialog (HWND hwnd, short Dialog, unsigned long Value)
{
  char szBuffer[128];
  int err = bOK;

  switch (Dialog)
  {
    case rMaxNumOfParametersOverflow:
      sprintf(szBuffer,"maxParameter overflow.\nmaxParameter = %ld\nUse Tools:Split data file",Value);
      err = MessageBox (hwnd, szBuffer, szAppName, MB_OK | MB_ICONSTOP);
      break;
    case rMaxDataOverflow:
			sprintf(szBuffer,"Maximum number of data items reached.\nUse the \"set memory\" function to extend\nthe memory.");
      err = MessageBox (hwnd, szBuffer, szAppName, MB_OK | MB_ICONSTOP);
      break;
  }
  return err;
}

int Do_StopAlert (HWND hwnd, short Dialog)
{
  char szBuffer[64];
  int err = bOK;

  switch (Dialog)
  {
    case rFileError:
      sprintf(szBuffer,"Could not open file:\n>%s<",FullName);
      err = MessageBox (hwnd, szBuffer, szAppName, MB_OK | MB_ICONSTOP);
      break;

		case rWrongData:
      sprintf(szBuffer,"Wrong format of data.");
      err = MessageBox (hwnd, szBuffer, szAppName, MB_OK | MB_ICONSTOP);
      break;

		case rVersion:
      sprintf(szBuffer,"Sorry, you can't use this old template.");
      err = MessageBox (hwnd, szBuffer, szAppName, MB_OK | MB_ICONSTOP);
      break;

		case rSaveGraphic:
      sprintf(szBuffer,"Save graphic as EMF formatted file before closing?");
      err = MessageBox (hwnd, szBuffer, szAppName, MB_YESNOCANCEL | MB_ICONQUESTION);
      break;

		default:
			break;
  }

  return err;
}

int Do_NoteAlert (HWND hwnd, short Dialog){return 0;}

void SetCheckButton(HWND hDlg, int IDC, int Mode, int *Flag)
{
  switch (Mode)
  {
		case Set:
			if (*Flag)
			{
				*Flag = 1;
				CheckDlgButton (hDlg, IDC, TRUE);
			}
			else
			{
				*Flag = 0;
				CheckDlgButton (hDlg, IDC, FALSE);
			}
			break;
	  
		case Change:
			if (*Flag)
			{
				*Flag = 0;
				CheckDlgButton (hDlg, IDC, FALSE);
			}
			else
			{
				*Flag = 1;
				CheckDlgButton (hDlg, IDC, TRUE);
			}
			break;

		default:
			break;
  }
}

int SetRadioButton(HWND hDlg, int Anzahl, int IDC_Radio[maxRadio+1], int CheckedButton)
{
	int i = 0;

	for (i=1;i<=Anzahl;i++)
    CheckDlgButton (hDlg, IDC_Radio[i], FALSE);

  CheckDlgButton (hDlg, IDC_Radio[CheckedButton], TRUE);

	return(CheckedButton);
}

BOOL ColorDialog (HWND hDlg, CHOOSECOLOR *cc, int Mode, RGBColor *Farbe)
{
	switch (Mode)
	{
		case Set:
			if ((Farbe->red == 0) && (Farbe->green == 0) && (Farbe->blue == 0))
			{
				Farbe->red   =  80;
				Farbe->green = 160;
				Farbe->blue  = 200;
			}
			if ((Farbe->red == 1) && (Farbe->green == 1) && (Farbe->blue == 1))
			{
				Farbe->red   = 0;
				Farbe->green = 0;
				Farbe->blue  = 0;
			}
			cc->lStructSize    = sizeof (CHOOSECOLOR);
			cc->hwndOwner      = hDlg;
			cc->hInstance      = NULL;
			cc->lpCustColors   = crCustColors;
			cc->Flags          = CC_RGBINIT | CC_FULLOPEN;
			cc->lCustData      = 0L;
			cc->lpfnHook       = NULL;
			cc->lpTemplateName = NULL;
			cc->rgbResult      = RGB (Farbe->red, Farbe->green, Farbe->blue);
			break;

		case Choose:       
			return ChooseColor (cc);
			break;

		case Change:
			Farbe->red   = GetRValue(cc->rgbResult);
			Farbe->green = GetGValue(cc->rgbResult);
			Farbe->blue  = GetBValue(cc->rgbResult);

			if ((Farbe->red == 0) && (Farbe->green == 0) &&(Farbe->blue == 0)) 
			{
				Farbe->red		= 1;
				Farbe->green = 1;
				Farbe->blue	= 1;
			}

		default:
			break;
	}

	return FALSE;
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

void PaintTheBlock (HWND hCtrl, DWORD Color)
{
	HBRUSH          hBrush;
	HDC             hdc;
	RECT            rect;

	InvalidateRect (hCtrl, NULL, TRUE);
	UpdateWindow (hCtrl);

	hdc = GetDC (hCtrl);
	GetClientRect (hCtrl, &rect);
	hBrush = CreateSolidBrush (Color);
	hBrush = (HBRUSH) SelectObject (hdc, hBrush);
	Rectangle (hdc, rect.left, rect.top, rect.right, rect.bottom);
	DeleteObject (SelectObject (hdc, hBrush));
	ReleaseDC (hCtrl, hdc);
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

int IntegerDialog(HWND hDlg, int IDC, int Mode, char *Format, int Value, BOOL err)
{
  int  dValue = 0;
  Str80 Dummy = " ";

  switch (Mode)
  {
    case Set:
      if (err)
        sprintf((char *) Dummy, Format, Value);
      SetDlgItemText(hDlg, IDC, (char *) Dummy);
      break;

    case Change:
      dValue = (int) GetDlgItemInt(hDlg, IDC, &err, TRUE);
      
			if (err)
        Value = dValue;        
      break;

		default:
			break;
  }

	return(Value);
}


/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

float FloatDialog(HWND hDlg, int IDC, int Mode, char *cFormatStr, float Value, BOOL err)
{
	int		dim1           = 0;
	int		dim2           = 0;
  char  Dummy[64]      = "";
	char  dFormatStr[32] = "";

  switch (Mode)
  {
    case Set:
      if (err)			
        sprintf(Dummy, cFormatStr, Value);

			SetDlgItemText(hDlg, IDC, Dummy);
      break;

		case Change:
      GetDlgItemText(hDlg, IDC, Dummy, 63);
      sscanf(Dummy, "%f", &Value);
			strcpy(dFormatStr, cFormatStr);
			replaceStr(dFormatStr, "%.","");
			replaceStr(dFormatStr, "f","");
			sscanf(dFormatStr,"%d",&dim1);
			dim2 = CreateFormat(Dummy, cFormatStr);

			if (dim1 > dim2)
				sprintf(cFormatStr, "%%.%df", dim1);			

			break;

		default:
			break;
  }

	return(Value);
}


/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

void TextDialog(HWND hDlg, int IDC, int Mode, char *Text)
{
  switch (Mode)
  {
    case Set:
      SetDlgItemText(hDlg, IDC, (char *) Text);
      break;

		case Change:
      GetDlgItemText(hDlg, IDC, (char *) Text, NUMTEXTDIALOG);
      break;

		default:
			break;
  }
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

void InitUpDownControl(HWND hDlg, int IDC,
                       int min, int max, int x,  
                       HWND *hUpDown, HWND *hEdit)
{
	char	DialogText[16] = "";

	*hEdit   = GetDlgItem(hDlg,IDC);
	*hUpDown = CreateUpDownControl( WS_CHILD | WS_BORDER | WS_VISIBLE | UDS_ALIGNRIGHT,
																						0, 0, 18, 25, hDlg, IDC_UPDOWN,
																						hInst, NULL,
																						max, min, x);
	SendMessage( *hUpDown, UDM_SETBUDDY, (WPARAM) *hEdit, 0 );
	sprintf(DialogText,"%d",x);
	SendMessage( *hEdit, WM_SETTEXT, 0, (LPARAM) DialogText);
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

void UpDown(HWND hUpDown, WPARAM wParam)
{
	HWND  	hBuddyWnd;
	TCHAR   szTmp[16];

	hBuddyWnd = (HWND)SendMessage( hUpDown, UDM_GETBUDDY, 0, 0 );
	wsprintf( szTmp, "%d", HIWORD( wParam ) );
	SendMessage( hBuddyWnd, WM_SETTEXT, 0, (LPARAM)szTmp );
	SendMessage( hBuddyWnd, EM_SETSEL, 0, -1 );
}

/***********************************************************************
************************************************************************
*     ZahlOk. berprft ob String eine Zahl reprsentiert.
************************************************************************
***********************************************************************/

int ZahlOk(char *p)      
{
	int len    = 0;
	int err    = 0;

	if ((len = (int) strlen((char *) p)) < 1) 
		return 0;

	while ((--len>=0) && (err == 0))
	{
		err = 1;
		if ((*p == 'e') || (*p == 'd') || (*p == 'D')) *p = 'E';
		if (*p == ',')  *p = '.';
		if (*p == '0')  err = 0;
		if (*p == '1')  err = 0;
		if (*p == '2')  err = 0;
		if (*p == '3')  err = 0;
		if (*p == '4')  err = 0;
		if (*p == '5')  err = 0;
		if (*p == '6')  err = 0;
		if (*p == '7')  err = 0;
		if (*p == '8')  err = 0;
		if (*p == '9')  err = 0;
		if (*p == '-')  err = 0;
		if (*p == '+')  err = 0;
		if (*p == 'E')  err = 0;
		if (*p == '.')  err = 0;
		if (err > 0) return err;
		p++;
	}

	return err;
}

BOOL CheckValue(HWND hDlg, int IDC)
{
  Str80 Dummy = "";

  GetDlgItemText(hDlg, IDC, (char *) Dummy, 80);

  if(strcmp((char *) Dummy, " "))
    return TRUE;

  if (strlen((char *) Dummy) > 0)
	{
		if (ZahlOk((char *) Dummy) < 1)
      return TRUE;
    else
      return FALSE;
	}
  else
	{
    return FALSE;
	}

	return FALSE;
}

