/*--------------------------------------------*/
/*  Do_NewModeDialog.c                        */
/*  Rainer Sieger, Universitaet Bremen        */
/*  31.01.99                                  */
/*  Windows only                            */
/*--------------------------------------------*/

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Do_NewModeDialog.h"
#include "Dialog.h"

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

CHOOSECOLOR cc;
BOOL        fColorDialog;

float	      dGRange;

int         dGLineWidth;
Str255      dLabel;

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_NewModeDialog (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
  char     iFormatStr[32] = "%d";
  char     fFormatStr[32] = "%.3f";

  int      i							= 0;

  BOOL     err						= TRUE;

// *************************************************************************

	switch (iMsg)
	{
		case WM_INITDIALOG :
			TextDialog(hDlg, IDC_GLABEL, Set, (char *) C[ItemNo].GroupName);
			NewColor     = ST[ItemNo].GColor; 
			fColorDialog = ColorDialog (hDlg, &cc, Set, &NewColor);
			dGLineWidth  = IntegerDialog(hDlg, IDC_MSIZE, Set, iFormatStr, ST[ItemNo].GLineWidth, err);
			dGRange			 = FloatDialog(hDlg, IDC_EPSILON, Set, fFormatStr, ST[ItemNo].GRange, err);
			SetFocus(hDlg);
			return FALSE;
			break;

		case WM_COMMAND :
			switch (LOWORD (wParam))
			{
				case IDOK :
					if (fColorDialog)
					{
						fColorDialog   = ColorDialog (hDlg, &cc, Change, &ST[ItemNo].GColor);
						GColor[ItemNo] = ST[ItemNo].GColor;
					}

					TextDialog(hDlg, IDC_GLABEL, Change, (char *) C[ItemNo].GroupName);
					ST[ItemNo].GLineWidth = IntegerDialog(hDlg, IDC_MSIZE, Change, iFormatStr, dGLineWidth, err);
					ST[ItemNo].GRange     = FloatDialog(hDlg, IDC_EPSILON, Change, fFormatStr, dGRange, err);
					EndDialog (hDlg, TRUE);
					return TRUE;
					break;

				case IDC_SETCOLOR :
					if ((fColorDialog = ColorDialog(hDlg, &cc, Choose, &NewColor)))
						useColor = 1;
					return TRUE;
					break;

				case IDC_MSIZE :
					if (!(err = CheckValue(hDlg, IDC_MSIZE)))
						dGLineWidth = IntegerDialog(hDlg, IDC_MSIZE, Set, iFormatStr, dGLineWidth, err);
					else
						dGLineWidth = IntegerDialog(hDlg, IDC_MSIZE, Change, iFormatStr, dGLineWidth, err);
					return TRUE;
					break;

				case IDC_EPSILON :
					if (!(err = CheckValue(hDlg, IDC_EPSILON)))
						dGRange = FloatDialog(hDlg, IDC_EPSILON, Set, fFormatStr, dGRange, err);
					else
						dGRange = FloatDialog(hDlg, IDC_EPSILON, Change, fFormatStr, dGRange, err);
					return TRUE;
					break;

				case IDC_PRE :
					if (fColorDialog)
					{
						fColorDialog   = ColorDialog(hDlg, &cc, Change, &ST[ItemNo].GColor);
						GColor[ItemNo] = ST[ItemNo].GColor;
					}

					TextDialog(hDlg, IDC_GLABEL, Change, (char *) C[ItemNo].GroupName);
					ST[ItemNo].GLineWidth = IntegerDialog(hDlg, IDC_MSIZE, Change, iFormatStr, dGLineWidth, err);

					if (ItemNo > 1) 
						ItemNo--;
	
					TextDialog(hDlg, IDC_GLABEL, Set, (char *) C[ItemNo].GroupName);
					NewColor     = ST[ItemNo].GColor; 
					fColorDialog = ColorDialog(hDlg, &cc, Set, &NewColor);
					dGLineWidth  = IntegerDialog(hDlg, IDC_MSIZE, Set, iFormatStr, ST[ItemNo].GLineWidth, err);
					dGRange			 = FloatDialog(hDlg, IDC_EPSILON, Set, fFormatStr, ST[ItemNo].GRange, err);
					return TRUE;
					break;

					case IDC_POST :
						if (fColorDialog)
						{
							fColorDialog   = ColorDialog(hDlg, &cc, Change, &ST[ItemNo].GColor);
							GColor[ItemNo] = ST[ItemNo].GColor;
						}

						TextDialog(hDlg, IDC_GLABEL, Change, (char *) C[ItemNo].GroupName);
						ST[ItemNo].GLineWidth   = IntegerDialog(hDlg, IDC_MSIZE, Change, iFormatStr, dGLineWidth, err);

						if (ItemNo < gNumOfGroups) 
							ItemNo++;
	
						TextDialog(hDlg, IDC_GLABEL, Set, (char *) C[ItemNo].GroupName);
						NewColor     = ST[ItemNo].GColor; 
						fColorDialog = ColorDialog (hDlg, &cc, Set, &NewColor);
						dGLineWidth  = IntegerDialog(hDlg, IDC_MSIZE, Set, iFormatStr, ST[ItemNo].GLineWidth, err);
						dGRange			 = FloatDialog(hDlg, IDC_EPSILON, Set, fFormatStr, ST[ItemNo].GRange, err);
						return TRUE;
						break;

					case IDCANCEL :
						EndDialog (hDlg, FALSE);
						return TRUE;
						break;

					default:
						break;
			}
			break;

		case WM_PAINT :
			break;

		default:
			break;
	}

	return FALSE;
}


