/*********************************************************************
*                                                                    *
*     Do_SetAllMenu                                                  *
*                                                                    *
*     Programmautor: Rainer Sieger, Alfred-Wegener-Institut          *
*     Datei erstellt am: 05.02.97                                    *
*     Letzte nderung: 22.05.2002                                    *
*                                                                    *
*********************************************************************/
      
#include <windows.h>
#include <stdio.h>

#include "Struct.h"
#include "Globals.h"

#include "SetMinMax.h"
#include "ColorConversion.h"
#include "Win_GUI.h"
#include "Do_YAxisDialog.h"
#include "Do_SetAllMenu.h"
#include "Dialog.h"
#include "SetMinMax.h"
#include "MinMax.h"
#include "replaceStr.h"

int ItemNo		 = 0;
int ChangeMode = 1;

// ******************************************************************

void Do_SetAllMenu(HWND hwnd, HINSTANCE hInst, int MenuItem)
{
	int         j = 0;
	
  CHOOSECOLOR cc;
  BOOL        fColorDialog;
  RGBColor    NewColor;
  
// ******************************************************************

  if (gSelectedNumOfParameters > 0)
	{
		switch (Mode)
		{
			case VerticalMode:
			case HorizontalMode:
				if (gNumOfParameters > gSelectedNumOfParameters)
					DialogBox (hInst, "CHANGEMODEDIALOG", hwnd, (DLGPROC) (DLGPROC) Do_ChangeModeDialog);
				else
					ChangeMode = 0;
					
				if (ChangeMode < 0)
				{
					ChangeMode = 1;
					return;
				}
				
				while (++j<=MAXNUMOFPARAMETERS)
				{
					if (ST[j].PlotData > 0)
					{
						ItemNo   = j;
						NewColor = ST[ItemNo].Color;
						j        = 2*MAXNUMOFPARAMETERS;					  	
					}
				}
				break;

			case TernaryMode:
			case PhaseMode:
 				while (++j<=MAXNUMOFPARAMETERS)
				{
					if (ST[j].GPlotData > 0)
					{
						ItemNo   = j;
						NewColor = ST[ItemNo].GColor;
						j        = 2*MAXNUMOFPARAMETERS;					  	
					}
				}
				break;

			default:
				break;
		}

		switch (MenuItem)
		{
		  case IDM_YAXIS_MAXAXISLENGTH : 
				switch (Mode)
				{
					case VerticalMode:
					case HorizontalMode:
						DialogBox (hInst, "YAXISDIALOGMAXAXISLENGTH", hwnd, (DLGPROC) Do_YAxisDialogMaxAxisLength);
						break;
				}
        break;

		  case IDM_YAXIS_ADDNEXT : 
        DialogBox (hInst, "YAXISDIALOGADDNEXT", hwnd, (DLGPROC) Do_YAxisDialogAddNext);
        break;

		  case IDM_YAXIS_RANGE : 
				switch (Mode)
				{
					case HorizontalMode:
					case VerticalMode:
            DialogBox (hInst, "YAXISDIALOGRANGE", hwnd, (DLGPROC) Do_YAxisDialogRange);
            break;
					case PhaseMode:
            DialogBox (hInst, "YAXISDIALOGPHASEMODERANGE", hwnd, (DLGPROC) Do_YAxisDialogPhaseModeRange);
            break;
        }
        break;

		  case IDM_YAXIS_TICKS : 
        DialogBox (hInst, "YAXISDIALOGTICKS", hwnd, (DLGPROC) Do_YAxisDialogTicks);
        break;

		  case IDM_YAXIS_PARAMETER_TEXT_ORIENTATION : 
        DialogBox (hInst, "YAXISDIALOGTEXTORIENTATION", hwnd, (DLGPROC) Do_YAxisDialogParameterTextOrientation);
        break;

		  case IDM_YAXIS_MARKER : 
				switch (Mode)
				{
					case VerticalMode:
					case HorizontalMode:
						DialogBox (hInst, "YAXISDIALOGMARKER", hwnd, (DLGPROC) Do_YAxisDialogMarker);
						break;
          case TernaryMode:
						DialogBox (hInst, "YAXISDIALOGGMARKER", hwnd, (DLGPROC) Do_YAxisDialogMarker);
						break;
				}
        break;

		  case IDM_YAXIS_OPTIONS : 
        DialogBox (hInst, "YAXISDIALOGOPTIONS", hwnd, (DLGPROC) Do_YAxisDialogOptions);
        break;

		  case IDM_YAXIS_QUALITY_FLAGS : 
        DialogBox (hInst, "YAXISDIALOGQUALITYFLAGS", hwnd, (DLGPROC) Do_YAxisDialogQualityFlags);
        MinMax();
 			  SetMinMax(1);  	
        break;

		  case IDM_YAXIS_COLOR : 
        fColorDialog = ColorDialog(hwnd, &cc, Set, &NewColor);
        fColorDialog = ColorDialog(hwnd, &cc, Choose, &NewColor);

				if (fColorDialog)
	      {
					useColor = 1;
          fColorDialog = ColorDialog(hwnd, &cc, Change, &NewColor);

					switch (Mode)
					{
						case VerticalMode:
						case HorizontalMode:
						  switch (ChangeMode)
						  {
						  	case 0:
									for (j=1;j<=MAXNUMOFPARAMETERS;j++)
										Color[j] = ST[j].Color = NewColor;
									break;
								case 1:	
									for (j=1;j<=gNumOfParameters;j++)
										if (ST[j].PlotData > 0)
											Color[j] = ST[j].Color = NewColor;
									break;
							}
							break;

						case TernaryMode:
						case PhaseMode:
							for (j=1;j<=MAXNUMOFPARAMETERS;j++)
								GColor[j] = ST[j].GColor = NewColor;
							break;
					}
	      }
        break;

		  case IDM_YAXIS_COLOR_MAPPING : 
        DialogBox (hInst, "COLORMAPPINGDIALOG", hwnd, (DLGPROC) Do_ColorMappingDialog);
        break;

		  case IDM_YAXIS_LINEWIDTH : 
        DialogBox (hInst, "YAXISDIALOGLINEWIDTH", hwnd, (DLGPROC) Do_YAxisDialogLineWidth);
        break;

		  case IDM_YAXIS_COLUMNWIDTH : 
        DialogBox (hInst, "YAXISDIALOGCOLUMNWIDTH", hwnd, (DLGPROC) Do_YAxisDialogColumnWidth);
        break;

      case IDM_GEPSILON :
        DialogBox (hInst, "EPSILONDIALOG", hwnd, (DLGPROC) Do_EpsilonDialog);
				break;

			default:
				break;
	   }	

	   SetMinMax(-1);
	 }     
} 

// *************************************************************************
// *************************************************************************
// *************************************************************************

BOOL CALLBACK Do_ColorMappingDialog (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	BOOL	err       = TRUE;

	int		j					= 0;
	int		d_hue			= 0;
	int		d_lum			= 0;
	int		d_sat			= 0;

	static CHOOSECOLOR ccfirstcolor;
	static CHOOSECOLOR cclastcolor;

	BOOL   firstColorDialog = FALSE;
	BOOL   lastColorDialog  = FALSE;

	DWORD	 dRGBColor;

	static HLSColor    FirstColorHLS;
	static HLSColor    LastColorHLS;

	static HWND hCtrlBlockFirstColor = NULL;
	static HWND hCtrlBlockLastColor  = NULL;

// *************************************************************************

  switch (iMsg)
  {
    case WM_INITDIALOG :
			firstColorDialog = ColorDialog(hDlg, &ccfirstcolor, Set, &FirstColor);
			lastColorDialog  = ColorDialog(hDlg, &cclastcolor, Set, &LastColor);
      hCtrlBlockFirstColor = GetDlgItem(hDlg, IDC_SETFIRSTCOLOR);
      hCtrlBlockLastColor = GetDlgItem(hDlg, IDC_SETLASTCOLOR);
      SetFocus(hDlg);
      return FALSE;
			break;

    case WM_COMMAND :
      switch (LOWORD (wParam))
      {
        case IDOK :
          EndDialog (hDlg, TRUE);
					useColor					= 1;
	  	    firstColorDialog  = ColorDialog(hDlg,&ccfirstcolor, Change, &FirstColor);
					lastColorDialog   = ColorDialog(hDlg,&cclastcolor, Change, &LastColor);
					dRGBColor 				= ccfirstcolor.rgbResult;
					switch (Mode)
					{
						case VerticalMode:
						case HorizontalMode:
							FirstColorHLS = RGBtoHLS(ccfirstcolor.rgbResult);
							LastColorHLS  = RGBtoHLS(cclastcolor.rgbResult);
							d_hue  			  = LastColorHLS.hue - FirstColorHLS.hue;
							d_lum				  = LastColorHLS.lum - FirstColorHLS.lum;
							d_sat				  = LastColorHLS.sat - FirstColorHLS.sat;								
											
							switch (ChangeMode)
							{								
								case 0:
									d_hue  /= (gNumOfParameters-1);
									d_lum  /= (gNumOfParameters-1);
									d_sat  /= (gNumOfParameters-1);
	
									for (j=1;j<=gNumOfParameters;j++)
									{
										Color[j].red   = ST[j].Color.red   = GetRValue(dRGBColor);
										Color[j].green = ST[j].Color.green = GetGValue(dRGBColor);
										Color[j].blue  = ST[j].Color.blue  = GetBValue(dRGBColor);

										FirstColorHLS.hue += (unsigned char) d_hue;
										FirstColorHLS.lum += (unsigned char) d_lum;
										FirstColorHLS.sat += (unsigned char) d_sat;
																				
										if (FirstColorHLS.hue < 0)   		FirstColorHLS.hue = 0;
										if (FirstColorHLS.lum < 0)   		FirstColorHLS.lum = 0;
										if (FirstColorHLS.sat < 0)   		FirstColorHLS.sat = 0;
										if (FirstColorHLS.hue > HLSMAX) FirstColorHLS.hue = HLSMAX;
										if (FirstColorHLS.lum > HLSMAX) FirstColorHLS.lum = HLSMAX;
										if (FirstColorHLS.sat > HLSMAX) FirstColorHLS.sat = HLSMAX;
				
										dRGBColor = HLStoRGB((WORD) FirstColorHLS.hue, (WORD) FirstColorHLS.lum, (WORD) FirstColorHLS.sat);
									}
									break;

								case 1:
									d_hue /= (gSelectedNumOfParameters-1);
									d_lum /= (gSelectedNumOfParameters-1);
									d_sat /= (gSelectedNumOfParameters-1);
		
									for (j=1;j<=gNumOfParameters;j++)
									{
										if (ST[j].PlotData > 0)
										{
											Color[j].red   = ST[j].Color.red   = GetRValue(dRGBColor);
											Color[j].green = ST[j].Color.green = GetGValue(dRGBColor);
											Color[j].blue  = ST[j].Color.blue  = GetBValue(dRGBColor);

											FirstColorHLS.hue += (unsigned char) d_hue;
											FirstColorHLS.lum += (unsigned char) d_lum;
											FirstColorHLS.sat += (unsigned char) d_sat;
														
											if (FirstColorHLS.hue < 0)   		FirstColorHLS.hue = 0;
											if (FirstColorHLS.lum < 0)   		FirstColorHLS.lum = 0;
											if (FirstColorHLS.sat < 0)   		FirstColorHLS.sat = 0;
											if (FirstColorHLS.hue > HLSMAX) FirstColorHLS.hue = HLSMAX;
											if (FirstColorHLS.lum > HLSMAX) FirstColorHLS.lum = HLSMAX;
											if (FirstColorHLS.sat > HLSMAX) FirstColorHLS.sat = HLSMAX;
				
											dRGBColor = HLStoRGB((WORD) FirstColorHLS.hue, (WORD) FirstColorHLS.lum, (WORD) FirstColorHLS.sat);
										}
									}
									break;

								default:
									break;
								}								
								break;

						case TernaryMode:
						case PhaseMode:
							for (j=1;j<=gNumOfParameters;j++)
								GColor[j] = ST[j].GColor = FirstColor;
							break;

						default:
							break;
					}
          
					return TRUE;
					break;

        case IDCANCEL :
          EndDialog (hDlg, FALSE);
          return TRUE;
					break;

        case IDC_SETFIRSTCOLOR :
					firstColorDialog = ColorDialog(hDlg, &ccfirstcolor, Choose, &FirstColor);

					if (firstColorDialog)
	      	{
     	    	firstColorDialog  = ColorDialog(hDlg, &ccfirstcolor, Change, &FirstColor);
						FirstColorHLS     = RGBtoHLS(ccfirstcolor.rgbResult);
          }

					PaintTheBlock (hCtrlBlockFirstColor, ccfirstcolor.rgbResult);
        	PaintTheBlock (hCtrlBlockLastColor, cclastcolor.rgbResult);
          return TRUE;
					break;
            
        case IDC_SETLASTCOLOR :
					lastColorDialog = ColorDialog(hDlg, &cclastcolor, Choose, &LastColor);

					if (lastColorDialog)
	      	{
     	    	lastColorDialog  = ColorDialog(hDlg, &cclastcolor, Change, &LastColor);
						LastColorHLS     = RGBtoHLS(cclastcolor.rgbResult);
          }

					PaintTheBlock (hCtrlBlockFirstColor, ccfirstcolor.rgbResult);
        	PaintTheBlock (hCtrlBlockLastColor, cclastcolor.rgbResult);
          return TRUE;
					break;

				default:
					break;
			}
			break;

    case WM_PAINT :
      PaintTheBlock (hCtrlBlockFirstColor, ccfirstcolor.rgbResult);
      PaintTheBlock (hCtrlBlockLastColor, cclastcolor.rgbResult);
      break;

		default:
			break;
  }

	return FALSE;
}
		
/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_YAxisDialogMaxAxisLength (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	char					fFormatStr[32]				= "%.1f";

	int						j											= 0;

	BOOL					err										= TRUE;

	static float	resParameterWidth			= 0.f;    
	static float	res										= 0.f;
	static int		dFixedParameterWidth	= 0;

// *************************************************************************

	res               = (float) cxDpi/2.54f;
	resParameterWidth = (float) ST[ItemNo].ParameterWidth/res;

	switch (iMsg)
	{
		case WM_INITDIALOG :
			dFixedParameterWidth = ST[ItemNo].fixedParameterWidth;
			SetCheckButton(hDlg, IDC_FIXEDPARAMETER, Set, &dFixedParameterWidth);
			resParameterWidth = FloatDialog(hDlg, IDC_PARAMETERWIDTH, Set, fFormatStr, resParameterWidth, err);
			SetFocus(hDlg);
			return FALSE;
			break;

		case WM_COMMAND :
			switch (LOWORD (wParam))
			{
				case IDOK :
					ST[ItemNo].fixedParameterWidth = dFixedParameterWidth;
					resParameterWidth         = FloatDialog(hDlg, IDC_PARAMETERWIDTH, Change, fFormatStr, resParameterWidth, err);
					ST[ItemNo].ParameterWidth = (int) (resParameterWidth*res);

					if (ST[ItemNo].ParameterWidth < 0)
					{
						ST[ItemNo].ParameterWidth			= 0;
						ST[ItemNo].fixedParameterWidth = 0;
					}

					EndDialog (hDlg, TRUE);
	          
					switch (ChangeMode)
					{
						case 0:
							for (j=1;j<=MAXNUMOFPARAMETERS;j++)
							{
								ST[j].ParameterWidth      = ST[ItemNo].ParameterWidth;
								ST[j].fixedParameterWidth = ST[ItemNo].fixedParameterWidth;
							}
							break;

						case 1:
							for (j=1;j<=gNumOfParameters;j++)
							{
								if (ST[j].PlotData > 0)
								{
									ST[j].ParameterWidth      = ST[ItemNo].ParameterWidth;
									ST[j].fixedParameterWidth = ST[ItemNo].fixedParameterWidth;
								}
							}
							break;
							
						default:
							break;
					}
					return TRUE;
					break;

				case IDC_FIXEDPARAMETER :
					SetCheckButton(hDlg, IDC_FIXEDPARAMETER, Change, &dFixedParameterWidth);
					return TRUE;
					break;

				case IDC_PARAMETERWIDTH :
					if (!(err = CheckValue(hDlg, IDC_PARAMETERWIDTH)))
						resParameterWidth = FloatDialog(hDlg, IDC_PARAMETERWIDTH, Set, fFormatStr, resParameterWidth, err);
					else
						resParameterWidth = FloatDialog(hDlg, IDC_PARAMETERWIDTH, Change, fFormatStr, resParameterWidth, err);
					return TRUE;
					break;

				case IDCANCEL :
					EndDialog (hDlg, FALSE);
					return TRUE;
					break;

				default:
					break;
			}
			break;

		case WM_PAINT :
			break;

		default:
			break;
	}

	return FALSE;
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_EpsilonDialog (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	char					fFormatStr[32]	= "%.3f";

	int						j								= 0;

	BOOL					err							= TRUE;

	static float	Epsilon					= 0.f;

// *************************************************************************

	switch (iMsg)
		{
			case WM_INITDIALOG :
				Epsilon = FloatDialog(hDlg, IDC_EPSILON, Set, fFormatStr, ST[ItemNo].GEpsilon, err);
				SetFocus(hDlg);
				return FALSE;
				break;

			case WM_COMMAND :
				switch (LOWORD (wParam))
				{
					case IDOK :
						ST[ItemNo].GEpsilon = FloatDialog(hDlg, IDC_EPSILON, Change, fFormatStr, Epsilon, err);
						EndDialog (hDlg, TRUE);
						for (j=1;j<=MAXNUMOFPARAMETERS;j++)
							ST[j].GEpsilon = ST[ItemNo].GEpsilon;
						return TRUE;
						break;

					case IDC_EPSILON :
						if (!(err = CheckValue(hDlg, IDC_EPSILON)))
							Epsilon = FloatDialog(hDlg, IDC_EPSILON, Set, fFormatStr, Epsilon, err);
						else
							Epsilon = FloatDialog(hDlg, IDC_EPSILON, Change, fFormatStr, Epsilon, err);
						return TRUE;
						break;

					case IDCANCEL :
						EndDialog (hDlg, FALSE);
						return TRUE;
						break;

					default:
						break;
				}
				break;

			case WM_PAINT :
				break;

			default:
				break;
		}

		return FALSE;
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_YAxisDialogPhaseModeRange (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
  char					fFormatStr[32]  = "%.3f";

  int						j								= 0;

  BOOL					err							= TRUE;

  static float	Range						= 0.f;

// *************************************************************************

  switch (iMsg)
  {
    case WM_INITDIALOG :
      Range = FloatDialog(hDlg, IDC_EPSILON, Set, fFormatStr, ST[ItemNo].GRange, err);
      SetFocus(hDlg);
      return FALSE;
			break;

    case WM_COMMAND :
      switch (LOWORD (wParam))
      {
        case IDOK :
          ST[ItemNo].GRange = FloatDialog(hDlg, IDC_EPSILON, Change, fFormatStr, Range, err);
          EndDialog (hDlg, TRUE);

					for (j=1;j<=MAXNUMOFPARAMETERS;j++)
            ST[j].GRange = ST[ItemNo].GRange;

					return TRUE;
					break;

        case IDC_EPSILON :
          if (!(err = CheckValue(hDlg, IDC_EPSILON)))
						Range = FloatDialog(hDlg, IDC_EPSILON, Set, fFormatStr, Range, err);
          else
						Range = FloatDialog(hDlg, IDC_EPSILON, Change, fFormatStr, Range, err);

					return TRUE;
					break;

        case IDCANCEL :
          EndDialog (hDlg, FALSE);
          return TRUE;
					break;

				default:
					break;
      }
      break;

    case WM_PAINT :
      break;

		default:
			break;
  }

	return FALSE;
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_YAxisDialogLineWidth (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	char        iFormatStr[32]	= "%d";

	int         j								= 0;

	BOOL        err							= TRUE;

	static int	LineWidth				= 0;

	static HWND hLineWidth   		= NULL;
	static HWND	hEditLineWidth	= NULL;

// *************************************************************************

	switch (iMsg)
	{
		case WM_INITDIALOG :
    	switch (Mode)
			{
				case VerticalMode:
				case HorizontalMode:
					LineWidth = IntegerDialog(hDlg, IDC_LINEWIDTH, Set, iFormatStr, ST[ItemNo].LineWidth, err);
					break;

				case PhaseMode:
					LineWidth = IntegerDialog(hDlg, IDC_LINEWIDTH, Set, iFormatStr, ST[ItemNo].GLineWidth, err);
					break;

				default:
					break;
			}

			InitUpDownControl(hDlg,IDC_LINEWIDTH,1,20,LineWidth,&hLineWidth,&hEditLineWidth);
			SetFocus(hDlg);
			return FALSE;
			break;

		case WM_VSCROLL :
 			if ((HWND) lParam == hLineWidth) 
				UpDown(hLineWidth,wParam);
			return FALSE;
			break;

		case WM_COMMAND :
			switch (LOWORD (wParam))
			{
				case IDOK :
    			switch (Mode)
		    	{
				    case VerticalMode:
						case HorizontalMode:
							ST[ItemNo].LineWidth = IntegerDialog(hDlg, IDC_LINEWIDTH, Change, iFormatStr, LineWidth, err);
							EndDialog (hDlg, TRUE);
			
							switch (ChangeMode)
							{
								case 0:
									for (j=1;j<=MAXNUMOFPARAMETERS;j++)
										ST[j].LineWidth = ST[ItemNo].LineWidth;
									break;	

								case 1:
									for (j=1;j<=gNumOfParameters;j++)
										if (ST[j].PlotData > 0)
											ST[j].LineWidth = ST[ItemNo].LineWidth;
									break;	

								default:
									break;
							}
							break;

						case PhaseMode:
							ST[ItemNo].GLineWidth = IntegerDialog(hDlg, IDC_LINEWIDTH, Change, iFormatStr, LineWidth, err);
							EndDialog (hDlg, TRUE);
							
							for (j=1;j<=MAXNUMOFPARAMETERS;j++)
								ST[j].GLineWidth = ST[ItemNo].GLineWidth;
							break;

						default:
							break;
					}
					return TRUE;
					break;

				case IDC_LINEWIDTH :
					if (!(err = CheckValue(hDlg, IDC_LINEWIDTH)))
						LineWidth = IntegerDialog(hDlg, IDC_LINEWIDTH, Set, iFormatStr, LineWidth, err);
					else
						LineWidth = IntegerDialog(hDlg, IDC_LINEWIDTH, Change, iFormatStr, LineWidth, err);
					return TRUE;
					break;

				case IDCANCEL :
					EndDialog (hDlg, FALSE);
					return TRUE;
					break;
				}
			break;

		case WM_PAINT :
			break;

		default:
			break;
	}

	return FALSE;
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_YAxisDialogColumnWidth (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	char        iFormatStr[32]		= "%d";

	int         j									= 0;

	BOOL        err								= TRUE;

	static int  ColumnWidth				= 0;
	static HWND hColumnWidth   		= NULL;
	static HWND hEditColumnWidth	= NULL;

// *************************************************************************

  switch (iMsg)
  {
		case WM_INITDIALOG :
			ColumnWidth = IntegerDialog(hDlg, IDC_LINEWIDTH, Set, iFormatStr, ST[ItemNo].ColumnWidth, err);
			InitUpDownControl(hDlg,IDC_LINEWIDTH,1,100,ColumnWidth,&hColumnWidth,&hEditColumnWidth);
			SetFocus(hDlg);
			return FALSE;
			break;

		case WM_VSCROLL :
			if ((HWND) lParam == hColumnWidth) 
				UpDown(hColumnWidth,wParam);
			return FALSE;
			break;

		case WM_COMMAND :
			switch (LOWORD (wParam))
			{
				case IDOK :
					ST[ItemNo].ColumnWidth = IntegerDialog(hDlg, IDC_LINEWIDTH, Change, iFormatStr, ColumnWidth, err);
					EndDialog (hDlg, TRUE);

					switch (ChangeMode)
					{
						case 0:
							for (j=1;j<=MAXNUMOFPARAMETERS;j++)
								ST[j].ColumnWidth = ST[ItemNo].ColumnWidth;
							break;

						case 1:
							for (j=1;j<=gNumOfParameters;j++)
								if (ST[j].PlotData > 0)
									ST[j].ColumnWidth = ST[ItemNo].ColumnWidth;
							break;

						default:
							break;
					}                           	 
					return TRUE;
					break;

				case IDC_LINEWIDTH :
					if (!(err = CheckValue(hDlg, IDC_LINEWIDTH)))
						ColumnWidth = IntegerDialog(hDlg, IDC_LINEWIDTH, Set, iFormatStr, ColumnWidth, err);
					else
						ColumnWidth = IntegerDialog(hDlg, IDC_LINEWIDTH, Change, iFormatStr, ColumnWidth, err);

					return TRUE;
					break;

				case IDCANCEL :
					EndDialog (hDlg, FALSE);
					return TRUE;
					break;

				default:
					break;
			}
			break;

		case WM_PAINT :
			break;

		default:
			break;
	}

	return FALSE;
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_YAxisDialogAddNext (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	char        iFormatStr[32]				= "%d";

	int         j											= 0;

	BOOL        err										= TRUE;

	static int  AddNext               = 0;
	static int  IDC_Radio[maxRadio+1] = {0,IDC_ADD,IDC_PLOT,0};
	static int	RadioButton						= 0;
	static HWND hAddNext		   				= NULL;
	static HWND hEditAddNext					= NULL;

// *************************************************************************

	switch (iMsg)
	{
		case WM_INITDIALOG :
			if (ST[ItemNo].AddNext >= 0)
			{
				AddNext			= IntegerDialog(hDlg, IDC_ADDNEXT, Set, iFormatStr, ST[ItemNo].AddNext, err);
				RadioButton = SetRadioButton(hDlg, 2, IDC_Radio, 1);
			}
			else
			{
				AddNext			= IntegerDialog(hDlg, IDC_ADDNEXT, Set, iFormatStr, -ST[ItemNo].AddNext, err);
				RadioButton = SetRadioButton(hDlg, 2, IDC_Radio, 2);
			}

			InitUpDownControl(hDlg,IDC_ADDNEXT,1,255,AddNext,&hAddNext,&hEditAddNext);
			SetFocus(hDlg);
			return FALSE;
			break;

		case WM_VSCROLL :
			if ((HWND) lParam == hAddNext)
				UpDown(hAddNext,wParam);
			return FALSE;
			break;

		case WM_COMMAND :
			switch (LOWORD (wParam))
			{
				case IDOK :
					ST[ItemNo].AddNext = IntegerDialog(hDlg, IDC_ADDNEXT, Change, iFormatStr, AddNext, err);
					EndDialog (hDlg, TRUE);
					
					if (ST[ItemNo].AddNext < 0)
						ST[ItemNo].AddNext = 0;	      
					
					if (RadioButton > 1)
						ST[ItemNo].AddNext = -ST[ItemNo].AddNext;
					
					switch (ChangeMode)
					{
						case 0:
							for (j=1;j<=MAXNUMOFPARAMETERS;j++)
    						ST[j].AddNext = ST[ItemNo].AddNext;
    					break;  
					
						case 1:
							for (j=1;j<=gNumOfParameters;j++)
							{
								if (ST[j].PlotData > 0)
	    						ST[j].AddNext = ST[ItemNo].AddNext;
							}
    					break;

						default:
							break;
    			}  

					return TRUE;
					break;

				case IDC_ADDNEXT :
					if (!(err = CheckValue(hDlg, IDC_ADDNEXT)))
						AddNext = IntegerDialog(hDlg, IDC_ADDNEXT, Set, iFormatStr, AddNext, err);
					else
						AddNext = IntegerDialog(hDlg, IDC_ADDNEXT, Change, iFormatStr, AddNext, err);

					return TRUE;
					break;

				case IDC_ADD :
					RadioButton = SetRadioButton(hDlg, 2, IDC_Radio, 1);
					return TRUE;
					break;

				case IDC_PLOT :
					RadioButton = SetRadioButton(hDlg, 2, IDC_Radio, 2);
					return TRUE;
					break;

				case IDCANCEL :
					EndDialog (hDlg, FALSE);
					return TRUE;
					break;

				default:
					break;
			}
			break;

		case WM_PAINT :
			break;

		default:
			break;
	}

	return FALSE;
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_YAxisDialogParameterTextOrientation (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
  int         j											= 0;

  BOOL        err										= TRUE;

	static int  IDC_Radio[maxRadio+1] = {0,IDC_0_DEG,IDC_45_DEG,IDC_90_DEG};
	static int	RadioButton						= 0;

// *************************************************************************

  switch (iMsg)
  {
    case WM_INITDIALOG :
			switch (ST[ItemNo].ParameterTextOrientation)
			{
				case 0:
					RadioButton = SetRadioButton(hDlg, 3, IDC_Radio, 1);
					break;

				case 45:
					RadioButton = SetRadioButton(hDlg, 3, IDC_Radio, 2);
					break;

				case 90:
					RadioButton = SetRadioButton(hDlg, 3, IDC_Radio, 3);
					break;

				default:
					break;
			}

      SetFocus(hDlg);
      return FALSE;
			break;

		case WM_COMMAND :
			switch (LOWORD (wParam))
			{
				case IDOK :
					EndDialog (hDlg, TRUE);

					switch (RadioButton)
					{
						case 1:
							ST[ItemNo].ParameterTextOrientation = 0;	      
					 		break;

						case 2:
							ST[ItemNo].ParameterTextOrientation = 45;	      
					 		break;

						case 3:
							ST[ItemNo].ParameterTextOrientation = 90;	      
					 		break;

						default:
							break;
					}

					switch (ChangeMode)
					{
						case 0:
							for (j=1;j<=MAXNUMOFPARAMETERS;j++)
			  				ST[j].ParameterTextOrientation = ST[ItemNo].ParameterTextOrientation;
			  			break;  

						case 1:
							for (j=1;j<=gNumOfParameters;j++)
							{
								if (ST[j].PlotData > 0)
				  				ST[j].ParameterTextOrientation = ST[ItemNo].ParameterTextOrientation;
							}
			  			break;

						default:
							break;
			  	}    
					return TRUE;
					break;

				case IDC_0_DEG :
					RadioButton = SetRadioButton(hDlg, 3, IDC_Radio, 1);
					return TRUE;
					break;

				case IDC_45_DEG :
					RadioButton = SetRadioButton(hDlg, 3, IDC_Radio, 2);
					return TRUE;
					break;

				case IDC_90_DEG :
					RadioButton = SetRadioButton(hDlg, 3, IDC_Radio, 3);
					return TRUE;
					break;

				case IDCANCEL :
					EndDialog (hDlg, FALSE);
					return TRUE;
					break;

				default:
					break;
			}
			break;

		case WM_PAINT :
			break;

		default:
			break;
	}

	return FALSE;
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_YAxisDialogMarker (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
  char        iFormatStr[32]		= "%d";

  int         j									= 0;
	int					PD								= 0;

  BOOL        err							  = TRUE;

	static int  PlotMarker				= 0;
	static int  MSymbol						= 0;
	static int  MSize							= 0;
	static int  dMarker						= 0;
	static HWND hMSize  	   			= NULL;
	static HWND hEditMSize   			= NULL;
	static HWND hMSymbol 	   			= NULL;
	static HWND hEditMSymbol 			= NULL;
		 
// *************************************************************************

	switch (iMsg)
	{
		case WM_INITDIALOG :
			switch (Mode)
			{
				case VerticalMode:
				case HorizontalMode:
					MSize   = IntegerDialog(hDlg, IDC_MSIZE, Set, iFormatStr, ST[ItemNo].MSize, err);
					MSymbol = IntegerDialog(hDlg, IDC_MSYMBOL, Set, iFormatStr, ST[ItemNo].MSymbol, err);
					break;

				case TernaryMode:
					MSize   = IntegerDialog(hDlg, IDC_MSIZE, Set, iFormatStr, ST[ItemNo].GMSize, err);
					MSymbol = IntegerDialog(hDlg, IDC_MSYMBOL, Set, iFormatStr, ST[ItemNo].GMSymbol, err);
					break;

				default:
					break;
			}

			InitUpDownControl(hDlg,IDC_MSIZE,1,20,MSize,&hMSize,&hEditMSize);
			InitUpDownControl(hDlg,IDC_MSYMBOL,1,10,MSymbol,&hMSymbol,&hEditMSymbol);
			dMarker = ST[ItemNo].PlotMarker;
			SetCheckButton(hDlg, IDC_MARKER, Set, &dMarker);
			SetFocus(hDlg);
			return FALSE;
			break;

		case WM_VSCROLL :
			if ((HWND) lParam == hMSize)
				UpDown(hMSize,wParam);

			if ((HWND) lParam == hMSymbol)
				UpDown(hMSymbol,wParam);
			
			return FALSE;
			break;
		
		case WM_COMMAND :
			switch (LOWORD (wParam))
			{
				case IDOK :
					switch (Mode)
					{
						case VerticalMode:
						case HorizontalMode:
							ST[ItemNo].MSize   = IntegerDialog(hDlg, IDC_MSIZE, Change, iFormatStr, MSize, err);
							ST[ItemNo].MSymbol = IntegerDialog(hDlg, IDC_MSYMBOL, Change, iFormatStr, MSymbol, err);
							
							if (ST[ItemNo].MSymbol < 1)
								ST[ItemNo].MSymbol = 1;
							
							if (ST[ItemNo].MSymbol > 8) 
								ST[ItemNo].MSymbol = 8;
							
							switch (ChangeMode)
   						{
								case 0:
									for (j=1;j<=MAXNUMOFPARAMETERS;j++)
									{
										ST[j].PlotMarker = dMarker;
										ST[j].MSymbol    = ST[ItemNo].MSymbol;
										ST[j].MSize      = ST[ItemNo].MSize;
									}
									break;
							
								case 1:
									for (j=1;j<=gNumOfParameters;j++)
									{
										if (ST[j].PlotData > 0)
										{
											ST[j].PlotMarker = dMarker;
											ST[j].MSymbol    = ST[ItemNo].MSymbol;
											ST[j].MSize      = ST[ItemNo].MSize;
										}
									}
									break;

								default:
									break;
							}
							break;

						case TernaryMode:
							ST[ItemNo].GMSize   = IntegerDialog(hDlg, IDC_MSIZE, Change, iFormatStr, MSize, err);
							ST[ItemNo].GMSymbol = IntegerDialog(hDlg, IDC_MSYMBOL, Change, iFormatStr, MSymbol, err);
							
							if (ST[ItemNo].GMSymbol < 1)
								ST[ItemNo].GMSymbol = 1;
							
							if (ST[ItemNo].GMSymbol > 8) 
								ST[ItemNo].GMSymbol = 8;
							
							for (j=1;j<=gNumOfGroups;j++)
							{
									ST[j].GMSymbol = ST[ItemNo].GMSymbol;
									ST[j].GMSize   = ST[ItemNo].GMSize;
							}
							break;

						default:
							break;
					}

					EndDialog (hDlg, TRUE);
					return TRUE;
					break;

				case IDC_MSIZE :
					if (!(err = CheckValue(hDlg, IDC_MSIZE)))
						MSize = IntegerDialog(hDlg, IDC_MSIZE, Set, iFormatStr, MSize, err);
					else
						MSize = IntegerDialog(hDlg, IDC_MSIZE, Change, iFormatStr, MSize, err);

					return TRUE;
					break;

				case IDC_MSYMBOL :
					if (!(err = CheckValue(hDlg, IDC_MSYMBOL)))
						MSymbol = IntegerDialog(hDlg, IDC_MSYMBOL, Set, iFormatStr, MSymbol, err);
					else
						MSymbol = IntegerDialog(hDlg, IDC_MSYMBOL, Change, iFormatStr, MSymbol, err);

					return TRUE;
					break;

				case IDC_MARKER :
					SetCheckButton(hDlg, IDC_MARKER, Change, &dMarker);
					return TRUE;
					break;

				case IDCANCEL :
					EndDialog (hDlg, FALSE);
					return TRUE;
					break;

				default:
					break;
			}
			break;

		case WM_PAINT :
			break;

		default:
			break;
	}

	return FALSE;
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_YAxisDialogOptions (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
  int         j									= 0;

  BOOL        err								= TRUE;

	static int  dLines       			= 0;
	static int  dColorize    			= 0;
	static int  dHistocol    			= 0;
	static int  dHistolin    			= 0;
	static int  dHistoout    			= 0;
	static int  dLitho						= 0;
	static int  dBoundary					= 0;
	static int  dText							= 0;
	static int  dComment     			= 0;
	static int  dOccurrence				= 0;
	static int  dCourse  					= 0;

// *************************************************************************

	switch (iMsg)
	{
		case WM_INITDIALOG :
			dLines						= ST[ItemNo].PlotLine;
			dColorize					= ST[ItemNo].Colorize;
			dHistocol					= ST[ItemNo].PlotCHistogramm;
			dHistolin					= ST[ItemNo].PlotLHistogramm;
			dHistoout					= ST[ItemNo].PlotOHistogramm;
			dLitho						= ST[ItemNo].PlotLitho;
			dBoundary					= ST[ItemNo].PlotBounds;
			dComment					= ST[ItemNo].PlotComment;
			dText							= ST[ItemNo].PlotText;
			dOccurrence				= ST[ItemNo].PlotOccurrence;
			dCourse   				= ST[ItemNo].PlotCourse;
			SetCheckButton(hDlg, IDC_LINES, Set, &dLines);
			SetCheckButton(hDlg, IDC_COLORIZE, Set, &dColorize);
			SetCheckButton(hDlg, IDC_HISTOCOL, Set, &dHistocol);
			SetCheckButton(hDlg, IDC_HISTOLIN, Set, &dHistolin);
			SetCheckButton(hDlg, IDC_HISTOOUT, Set, &dHistoout);
			SetCheckButton(hDlg, IDC_LITHO, Set, &dLitho);
			SetCheckButton(hDlg, IDC_BOUNDARY, Set, &dBoundary);
			SetCheckButton(hDlg, IDC_COMMENT, Set, &dComment);
			SetCheckButton(hDlg, IDC_OCCURRENCE, Set, &dOccurrence);
			SetCheckButton(hDlg, IDC_COURSE, Set, &dCourse);
			SetCheckButton(hDlg, IDC_TEXT, Set, &dText);
			SetFocus(hDlg);
			return FALSE;
			break;

		case WM_COMMAND :
			switch (LOWORD (wParam))
			{
				case IDOK :
					EndDialog (hDlg, TRUE);

					switch (ChangeMode)
					{
						case 0:
							for (j=1;j<=MAXNUMOFPARAMETERS;j++)
							{
								ST[j].PlotLine         = dLines;
								ST[j].Colorize         = dColorize;
								ST[j].PlotCHistogramm  = dHistocol;
								ST[j].PlotLHistogramm  = dHistolin;
								ST[j].PlotOHistogramm  = dHistoout;
								ST[j].PlotLitho				= dLitho;
								ST[j].PlotText         = dText;
								ST[j].PlotComment      = dComment;
								ST[j].PlotBounds       = dBoundary;
								ST[j].PlotOccurrence   = dOccurrence;
								ST[j].PlotCourse       = dCourse;
							}
							break;

						case 1:
							for (j=1;j<=gNumOfParameters;j++)
							{
								if (ST[j].PlotData > 0)
								{
									ST[j].PlotLine         = dLines;
									ST[j].Colorize         = dColorize;
									ST[j].PlotCHistogramm  = dHistocol;
									ST[j].PlotLHistogramm  = dHistolin;
									ST[j].PlotOHistogramm  = dHistoout;
									ST[j].PlotLitho				= dLitho;
									ST[j].PlotText         = dText;
									ST[j].PlotComment      = dComment;
									ST[j].PlotBounds       = dBoundary;
									ST[j].PlotOccurrence   = dOccurrence;
									ST[j].PlotCourse       = dCourse;
								}
							}
							break;

						default:
							break;
					}
					return TRUE;
					break;

				case IDC_LINES :
					SetCheckButton(hDlg, IDC_LINES, Change, &dLines);
					return TRUE;
					break;

				case IDC_COLORIZE :
					SetCheckButton(hDlg, IDC_COLORIZE, Change, &dColorize);
					return TRUE;
					break;

				case IDC_HISTOCOL :
					SetCheckButton(hDlg, IDC_HISTOCOL, Change, &dHistocol);
					return TRUE;
					break;

				case IDC_HISTOLIN :
					SetCheckButton(hDlg, IDC_HISTOLIN, Change, &dHistolin);
					return TRUE;
					break;

				case IDC_HISTOOUT :
					SetCheckButton(hDlg, IDC_HISTOOUT, Change, &dHistoout);
					return TRUE;
					break;

				case IDC_LITHO :
					SetCheckButton(hDlg, IDC_LITHO, Change, &dLitho);
					return TRUE;
					break;

				case IDC_BOUNDARY :
					SetCheckButton(hDlg, IDC_BOUNDARY, Change, &dBoundary);
					return TRUE;
					break;

				case IDC_COMMENT :
					SetCheckButton(hDlg, IDC_COMMENT, Change, &dComment);
					return TRUE;
					break;

				case IDC_TEXT :
					SetCheckButton(hDlg, IDC_TEXT, Change, &dText);
					return TRUE;
					break;

				case IDC_OCCURRENCE :
					SetCheckButton(hDlg, IDC_OCCURRENCE, Change, &dOccurrence);
					return TRUE;
					break;

				case IDC_COURSE :
					SetCheckButton(hDlg, IDC_COURSE, Change, &dCourse);
					return TRUE;
					break;

				case IDCANCEL :
					EndDialog (hDlg, FALSE);
					return TRUE;
					break;

				default:
					break;
			}
			break;

		case WM_PAINT :
			break;

		default:
			break;
	}

	return FALSE;
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_YAxisDialogTicks (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	char					iFormatStr[32]	= "%d";
	char					cFormatStr[32]	= "";

	int						j								= 0;
	int						dim							= 0;

	BOOL					err							= TRUE;

	static int		dBothSide       = 0;
	static int		dInside         = 0;
	static int		dTicklines      = 0;
	static int		dMTicklines     = 0;
	static int		MinorMarks      = 0;
	static float	TickInkrement   = 0.f;    
	static HWND		hMinorMarks 	  = NULL;
	static HWND		hEditMinorMarks	= NULL;

// *************************************************************************

  switch (iMsg)
  {
    case WM_INITDIALOG :
			strcpy(cFormatStr, (char *) ST[ItemNo].FormatStr);
			replaceStr(cFormatStr, "%.","");
			replaceStr(cFormatStr, "f","");
			sscanf(cFormatStr,"%d",&dim);
			dim++;
			sprintf(cFormatStr,"%%.%df", dim);

			TickInkrement = FloatDialog(hDlg, IDC_YTICKINCREMENT, Set, cFormatStr, ST[ItemNo].Tick_Increment, err);
			MinorMarks    = IntegerDialog(hDlg, IDC_YMINORMARKS, Set, iFormatStr, ST[ItemNo].Minor_Ticks, err);
			dBothSide     = ST[ItemNo].BothSide;
			dInside       = ST[ItemNo].Inside;
			dTicklines    = ST[ItemNo].Tickline;
			dMTicklines   = ST[ItemNo].Minor_Tickline;
			SetCheckButton(hDlg, IDC_YBOTHSIDE, Set, &dBothSide);
			SetCheckButton(hDlg, IDC_YINSIDE, Set, &dInside);
			SetCheckButton(hDlg, IDC_YTICKLINES, Set, &dTicklines);
			SetCheckButton(hDlg, IDC_MYTICKLINES, Set, &dMTicklines);
			InitUpDownControl(hDlg,IDC_YMINORMARKS,1,100,MinorMarks,&hMinorMarks,&hEditMinorMarks);
      SetFocus(hDlg);
      return FALSE;
			break;

		case WM_VSCROLL :
	    if ((HWND) lParam == hMinorMarks)
				UpDown(hMinorMarks,wParam);
      return FALSE;
			break;

    case WM_COMMAND :
      switch (LOWORD (wParam))
      {
				case IDOK :
					ST[ItemNo].Tick_Increment = FloatDialog(hDlg, IDC_YTICKINCREMENT, Change, cFormatStr, TickInkrement, err);
					ST[ItemNo].Minor_Ticks    = IntegerDialog(hDlg, IDC_YMINORMARKS, Change, iFormatStr, MinorMarks, err);
					ST[ItemNo].BothSide       = dBothSide;
					ST[ItemNo].Inside         = dInside;
					ST[ItemNo].Tickline       = dTicklines;
					ST[ItemNo].Minor_Tickline = dMTicklines;
					EndDialog (hDlg, TRUE);

					switch (ChangeMode)
					{
						case 0:
							for (j=1;j<=MAXNUMOFPARAMETERS;j++)
							{
								ST[j].Tick_Increment = ST[ItemNo].Tick_Increment;
								ST[j].Minor_Ticks    = ST[ItemNo].Minor_Ticks;
								ST[j].BothSide       = dBothSide;
								ST[j].Inside				 = dInside;
								ST[j].Tickline       = dTicklines;
								ST[j].Minor_Tickline = dMTicklines;
								strcpy((char *) ST[j].FormatStr, cFormatStr);
							}
							break;

						case 1:
							for (j=1;j<=gNumOfParameters;j++)
							{
								if (ST[j].PlotData > 0)
								{
								ST[j].Tick_Increment = ST[ItemNo].Tick_Increment;
								ST[j].Minor_Ticks    = ST[ItemNo].Minor_Ticks;
								ST[j].BothSide       = dBothSide;
								ST[j].Inside				 = dInside;
								ST[j].Tickline       = dTicklines;
								ST[j].Minor_Tickline = dMTicklines;
								strcpy((char *) ST[j].FormatStr, cFormatStr);
								}
							}
							break;

						default:
							break;
					}
					return TRUE;
					break;

				case IDC_YTICKINCREMENT :
					if (!(err = CheckValue(hDlg, IDC_YTICKINCREMENT)))
						TickInkrement = FloatDialog(hDlg, IDC_YTICKINCREMENT, Set, cFormatStr, TickInkrement, err);
					else
						TickInkrement = FloatDialog(hDlg, IDC_YTICKINCREMENT , Change, cFormatStr, TickInkrement, err);

					return TRUE;
					break;

				case IDC_YMINORMARKS :
					if (!(err = CheckValue(hDlg, IDC_YMINORMARKS)))
						MinorMarks = IntegerDialog(hDlg, IDC_YMINORMARKS, Set, iFormatStr, MinorMarks, err);
					else
						MinorMarks = IntegerDialog(hDlg, IDC_YMINORMARKS , Change, iFormatStr, MinorMarks, err);

					return TRUE;
					break;

				case IDC_YBOTHSIDE :
					SetCheckButton(hDlg, IDC_YBOTHSIDE, Change, &dBothSide);
					return TRUE;
					break;

				case IDC_YINSIDE :
					SetCheckButton(hDlg, IDC_YINSIDE, Change, &dInside);
					return TRUE;
					break;

				case IDC_YTICKLINES :
					SetCheckButton(hDlg, IDC_YTICKLINES, Change, &dTicklines);
					return TRUE;
					break;

				case IDC_MYTICKLINES :
					SetCheckButton(hDlg, IDC_MYTICKLINES, Change, &dMTicklines);
					return TRUE;
					break;

				case IDCANCEL :
					EndDialog (hDlg, FALSE);
					return TRUE;
					break;

				default:
					break;
      }
      break;

    case WM_PAINT :
      break;

		default:
			break;
  }

	return FALSE;
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_YAxisDialogRange (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	char					iFormatStr[32]	= "%d";
	char					cFormatStr[32]	= "";

	int						j								= 0;
	int						dim							= 0;

	BOOL					err							= TRUE;

	static float	Ymin						= 0.f;
	static float	Ymax						= 0.f;
	static float	Refline					= 0.f;

	static int		dYAuto					= 0;

// *************************************************************************

	switch (iMsg)
	{
		case WM_INITDIALOG :
			strcpy(cFormatStr, (char *) ST[ItemNo].FormatStr);
			replaceStr(cFormatStr, "%.","");
			replaceStr(cFormatStr, "f","");
			sscanf(cFormatStr,"%d",&dim);
			dim++;
			sprintf(cFormatStr,"%%.%df", dim);

			dYAuto  = ST[ItemNo].SetDefaultRange;
			SetCheckButton(hDlg, IDC_YAUTO, Set, &dYAuto);
			Ymin    = FloatDialog(hDlg, IDC_YMIN, Set, cFormatStr, ST[ItemNo].min, err);
			Ymax    = FloatDialog(hDlg, IDC_YMAX, Set, cFormatStr, ST[ItemNo].max, err);
			Refline = FloatDialog(hDlg, IDC_REFLINE, Set, cFormatStr, ST[ItemNo].Refline, err);
			SetFocus(hDlg);
			return FALSE;
			break;

		case WM_COMMAND :
			switch (LOWORD (wParam))
			{
				case IDOK :
					ST[ItemNo].SetDefaultRange = dYAuto;
					ST[ItemNo].min     = FloatDialog(hDlg, IDC_YMIN, Change, cFormatStr, Ymin, err);
					ST[ItemNo].max     = FloatDialog(hDlg, IDC_YMAX, Change, cFormatStr, Ymax, err);
					ST[ItemNo].Refline = FloatDialog(hDlg, IDC_REFLINE, Change, cFormatStr, Refline, err);
					EndDialog (hDlg, TRUE);

					switch (ChangeMode)
					{
						case 0:
							for (j=1;j<=MAXNUMOFPARAMETERS;j++)
							{
  							ST[j].SetDefaultRange = ST[ItemNo].SetDefaultRange;
								ST[j].min						 = ST[ItemNo].min;
								ST[j].max						 = ST[ItemNo].max;
								ST[j].Refline				 = ST[ItemNo].Refline;
								strcpy((char *) ST[j].FormatStr, cFormatStr);
							}
							break;

						case 1:
							for (j=1;j<=gNumOfParameters;j++)
							{
								if (ST[j].PlotData > 0)
								{
  							ST[j].SetDefaultRange = ST[ItemNo].SetDefaultRange;
								ST[j].min						 = ST[ItemNo].min;
								ST[j].max						 = ST[ItemNo].max;
								ST[j].Refline				 = ST[ItemNo].Refline;
								strcpy((char *) ST[j].FormatStr, cFormatStr);
								}
							}
							break;

						default:
							break;
					}
					return TRUE;
					break;

				case IDC_YAUTO :
					SetCheckButton(hDlg, IDC_YAUTO, Change, &dYAuto);
					return TRUE;
					break;

				case IDC_YMIN :
					if (!(err = CheckValue(hDlg, IDC_YMIN)))
						Ymin = FloatDialog(hDlg, IDC_YMIN, Set, cFormatStr, Ymin, err);
					else
						Ymin = FloatDialog(hDlg, IDC_YMIN, Change, cFormatStr, Ymin, err);
					return TRUE;
					break;

				case IDC_YMAX :
					if (!(err = CheckValue(hDlg, IDC_YMAX)))
						Ymax = FloatDialog(hDlg, IDC_YMAX, Set, cFormatStr, Ymax, err);
					else
						Ymax = FloatDialog(hDlg, IDC_YMAX , Change, cFormatStr, Ymax, err);
					return TRUE;
					break;

				case IDC_REFLINE :
					if (!(err = CheckValue(hDlg, IDC_REFLINE)))
						Refline = FloatDialog(hDlg, IDC_REFLINE, Set, cFormatStr, Refline, err);
					else
						Refline = FloatDialog(hDlg, IDC_REFLINE, Change, cFormatStr, Refline, err);
					return TRUE;
					break;

				case IDCANCEL :
					EndDialog (hDlg, FALSE);
					return TRUE;
					break;

				default:
					break;
			}
			break;

		case WM_PAINT :
			break;

		default:
			break;
	}

	return FALSE;
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_ChangeModeDialog (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	BOOL        err										= TRUE;

	static int	IDC_Radio[maxRadio+1] = {0,IDC_ALLPARAMETERS,IDC_SELECTEDPARAMETERS,0};
	static int	RadioButton						= 0;

// *************************************************************************

  switch (iMsg)
  {
    case WM_INITDIALOG :
			switch (ChangeMode)
			{
				case 0:
					RadioButton = SetRadioButton(hDlg, 2, IDC_Radio, 1);
					break;

				case 1:
					RadioButton = SetRadioButton(hDlg, 2, IDC_Radio, 2);
					break;

				default:
					break;
			}

      SetFocus(hDlg);
      return FALSE;
			break;

    case WM_COMMAND :
      switch (LOWORD (wParam))
      {
        case IDOK :
          EndDialog (hDlg, TRUE);
          ChangeMode = RadioButton-1;
          return TRUE;

				case IDC_ALLPARAMETERS :
					RadioButton = SetRadioButton(hDlg, 2, IDC_Radio, 1);
          return TRUE;

				case IDC_SELECTEDPARAMETERS :
					RadioButton = SetRadioButton(hDlg, 2, IDC_Radio, 2);
          return TRUE;

        case IDCANCEL :
          EndDialog (hDlg, FALSE);
          ChangeMode = -1;                         
          return TRUE;

				default:
					break;
      }
      break;

    case WM_PAINT :
      break;

		default:
			break;
  }

  return FALSE;
}

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_YAxisDialogQualityFlags (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	int         j									= 0;

	BOOL        err								= TRUE;

	static int  dShowValid				= 0;
	static int  dShowNotValid			= 0;
	static int  dShowUnknown			= 0;
	static int  dShowQuestionable	= 0;
	static int  dShowMissingData	= 0;

// *************************************************************************

  switch (iMsg)
  {
		case WM_INITDIALOG :
			dShowValid				= ST[ItemNo].ShowValid;
			dShowNotValid			= ST[ItemNo].ShowNotValid;
			dShowUnknown			= ST[ItemNo].ShowUnknown;
			dShowQuestionable	= ST[ItemNo].ShowQuestionable;
			dShowMissingData	= ST[ItemNo].ShowMissingData;
			
			SetCheckButton(hDlg, IDC_SHOWVALID,				Set, &dShowValid);
			SetCheckButton(hDlg, IDC_SHOWNOTVALID,			Set, &dShowNotValid);
			SetCheckButton(hDlg, IDC_SHOWUNKNOWN,			Set, &dShowUnknown);
			SetCheckButton(hDlg, IDC_SHOWQUESTIONABLE,	Set, &dShowQuestionable);
			SetCheckButton(hDlg, IDC_SHOWMISSVAL,			Set, &dShowMissingData);
			
      SetFocus(hDlg);
      return FALSE;
			break;

		case WM_COMMAND :
      switch (LOWORD (wParam))
      {
				case IDOK :
          EndDialog (hDlg, TRUE);

					switch (ChangeMode)
	        {
            case 0:
              for (j=1;j<=MAXNUMOFPARAMETERS;j++)
							{
								ST[j].ShowValid        = dShowValid;
								ST[j].ShowNotValid     = dShowNotValid;
								ST[j].ShowUnknown      = dShowUnknown;
								ST[j].ShowQuestionable = dShowQuestionable;
								ST[j].ShowMissingData  = dShowMissingData;
							}
							break;

						case 1:
              for (j=1;j<=gNumOfParameters;j++)
							{
                if (ST[j].PlotData > 0)
								{
									ST[j].ShowValid        = dShowValid;
									ST[j].ShowNotValid     = dShowNotValid;
									ST[j].ShowUnknown      = dShowUnknown;
									ST[j].ShowQuestionable = dShowQuestionable;
									ST[j].ShowMissingData  = dShowMissingData;
								}
							}
							break;

						default:
							break;
					}

          return TRUE;
					break;

				case IDC_SHOWVALID :
          SetCheckButton(hDlg, IDC_SHOWVALID, Change, &dShowValid);
          return TRUE;
					break;

				case IDC_SHOWNOTVALID :
          SetCheckButton(hDlg, IDC_SHOWNOTVALID, Change, &dShowNotValid);
          return TRUE;
					break;

				case IDC_SHOWUNKNOWN :
          SetCheckButton(hDlg, IDC_SHOWUNKNOWN, Change, &dShowUnknown);
          return TRUE;
					break;

				case IDC_SHOWQUESTIONABLE :
          SetCheckButton(hDlg, IDC_SHOWQUESTIONABLE, Change, &dShowQuestionable);
          return TRUE;
					break;

				case IDC_SHOWMISSVAL :
          SetCheckButton(hDlg, IDC_SHOWMISSVAL, Change, &dShowMissingData);
          return TRUE;
					break;

				case IDCANCEL :
          EndDialog (hDlg, FALSE);
          return TRUE;
					break;

				default:
					break;
      }
      break;

		case WM_PAINT :
      break;

		default:
			break;
  }

  return FALSE;
}

