/*--------------------------------------------*/
/*  Do_TernaryModeDialog.c                    */
/*  Rainer Sieger, Universitt Bremen         */
/*  14.01.2001                                */
/*  Windows only                              */
/*--------------------------------------------*/

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Do_TernaryModeDialog.h"
#include "Dialog.h"

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

CHOOSECOLOR cc;
BOOL        fColorDialog;

float	      Epsilon;

int         dGMSymbol;
int         dGMSize;
Str255      dLabel;

/*--------------------------------------------*/
/*--------------------------------------------*/
/*--------------------------------------------*/

BOOL CALLBACK Do_TernaryModeDialog (HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	char				iFormatStr[32]  = "%d";
	char				fFormatStr[32]  = "%.3f";

	int					i								= 0;
	int					j								= 0;
	int					k								= 1;

	BOOL				err							= TRUE;

	static HWND hCtrlBlock 			= NULL;
	static HWND hGMSize  	   		= NULL;
	static HWND hEditGMSize   	= NULL;
	static HWND hGMSymbol 	   	= NULL;
	static HWND hEditGMSymbol 	= NULL;

// *************************************************************************

  switch (iMsg)
  {
    case WM_INITDIALOG :
      for (i=1;i<ItemNo;i++)
        k += C[i].NumOfParametersInGroup;
			
			TextDialog(hDlg, IDC_GLABEL, Set, (char *) C[k].GroupName);
			NewColor      = ST[ItemNo].GColor; 
			fColorDialog  = ColorDialog(hDlg, &cc, Set, &NewColor);
			dGMSymbol     = IntegerDialog(hDlg, IDC_MSYMBOL, Set, iFormatStr, ST[ItemNo].GMSymbol, err);
			dGMSize       = IntegerDialog(hDlg, IDC_MSIZE, Set, iFormatStr, ST[ItemNo].GMSize, err);
      Epsilon				= FloatDialog(hDlg, IDC_EPSILON, Set, fFormatStr, ST[ItemNo].GEpsilon, err);
      hCtrlBlock    = GetDlgItem(hDlg, IDC_SETCOLOR);
			
			InitUpDownControl(hDlg,IDC_MSIZE,1,20,dGMSize,&hGMSize,&hEditGMSize);
			InitUpDownControl(hDlg,IDC_MSYMBOL,1,10,dGMSymbol,&hGMSymbol,&hEditGMSymbol);
      SetFocus(hDlg);
      return FALSE;
			break;

		case WM_VSCROLL :
		  if ((HWND) lParam == hGMSize)
				UpDown(hGMSize,wParam);

		  if ((HWND) lParam == hGMSymbol)
				UpDown(hGMSymbol,wParam);

      return FALSE;
			break;

    case WM_COMMAND :
      switch (LOWORD (wParam))
      {
				case IDOK :
					if (fColorDialog)
					{
						fColorDialog = ColorDialog(hDlg, &cc, Change, &ST[ItemNo].GColor);
						GColor[ItemNo] = ST[ItemNo].GColor;
					}

					for (i=1;i<ItemNo;i++)
						k += C[i].NumOfParametersInGroup;

					TextDialog(hDlg, IDC_GLABEL, Change, (char *) C[k].GroupName);
					ST[ItemNo].GMSymbol = IntegerDialog(hDlg, IDC_MSYMBOL, Change, iFormatStr, dGMSymbol, err);
					ST[ItemNo].GMSize   = IntegerDialog(hDlg, IDC_MSIZE, Change, iFormatStr, dGMSize, err);
					ST[ItemNo].GEpsilon = FloatDialog(hDlg, IDC_EPSILON, Change, fFormatStr, Epsilon, err);
					EndDialog (hDlg, TRUE);

					return TRUE;
					break;

				case IDC_SETCOLOR :
					if ((fColorDialog = ColorDialog(hDlg, &cc, Choose, &NewColor)))
					{
						PaintTheBlock (hCtrlBlock, cc.rgbResult);
						useColor = 1;
					}

					return TRUE;
					break;

				case IDC_MSYMBOL :
					if (!(err = CheckValue(hDlg, IDC_MSYMBOL)))
						dGMSymbol = IntegerDialog(hDlg, IDC_MSYMBOL, Set, iFormatStr, dGMSymbol, err);
					else
						dGMSymbol = IntegerDialog(hDlg, IDC_MSYMBOL, Change, iFormatStr, dGMSymbol, err);

					return TRUE;
					break;

				case IDC_MSIZE :
					if (!(err = CheckValue(hDlg, IDC_MSIZE)))
						dGMSize = IntegerDialog(hDlg, IDC_MSIZE, Set, iFormatStr, dGMSize, err);
					else
						dGMSize = IntegerDialog(hDlg, IDC_MSIZE, Change, iFormatStr, dGMSize, err);

					return TRUE;
					break;

				case IDC_EPSILON :
					if (!(err = CheckValue(hDlg, IDC_EPSILON)))
						Epsilon = FloatDialog(hDlg, IDC_EPSILON, Set, fFormatStr, Epsilon, err);
					else
						Epsilon = FloatDialog(hDlg, IDC_EPSILON, Change, fFormatStr, Epsilon, err);

					return TRUE;
					break;

				case IDC_PRE :
					if (fColorDialog)
					{
						fColorDialog = ColorDialog(hDlg, &cc, Change, &ST[ItemNo].GColor);
						GColor[ItemNo] = ST[ItemNo].GColor;
					}

					for (i=1;i<ItemNo;i++)
						k += C[i].NumOfParametersInGroup;

					TextDialog(hDlg, IDC_GLABEL, Change, (char *) C[k].GroupName);
					ST[ItemNo].GMSymbol = IntegerDialog(hDlg, IDC_MSYMBOL, Change, iFormatStr, dGMSymbol, err);
					ST[ItemNo].GMSize   = IntegerDialog(hDlg, IDC_MSIZE, Change, iFormatStr, dGMSize, err);

					if (ItemNo > 1) 
						ItemNo--;

					k = 1;  

					for (i=1;i<ItemNo;i++)
						k += C[i].NumOfParametersInGroup;

					TextDialog(hDlg, IDC_GLABEL, Set, (char *) C[k].GroupName);
					NewColor      = ST[ItemNo].GColor; 
					fColorDialog  = ColorDialog(hDlg, &cc, Set, &NewColor);
					dGMSymbol     = IntegerDialog(hDlg, IDC_MSYMBOL, Set, iFormatStr, ST[ItemNo].GMSymbol, err);
					dGMSize       = IntegerDialog(hDlg, IDC_MSIZE, Set, iFormatStr, ST[ItemNo].GMSize, err);
					PaintTheBlock (hCtrlBlock, RGB(ST[ItemNo].GColor.red,ST[ItemNo].GColor.green,ST[ItemNo].GColor.blue));

					return TRUE;
					break;

				case IDC_POST :
					if (fColorDialog)
					{
						fColorDialog = ColorDialog(hDlg, &cc, Change, &ST[ItemNo].GColor);
						GColor[ItemNo] = ST[ItemNo].GColor;
					}

					for (i=1;i<ItemNo;i++)
						k += C[i].NumOfParametersInGroup;

					TextDialog(hDlg, IDC_GLABEL, Change, (char *) C[k].GroupName);
					ST[ItemNo].GMSymbol = IntegerDialog(hDlg, IDC_MSYMBOL, Change, iFormatStr, dGMSymbol, err);
					ST[ItemNo].GMSize   = IntegerDialog(hDlg, IDC_MSIZE, Change, iFormatStr, dGMSize, err);

					if (ItemNo < gNumOfGroups) 
						ItemNo++;

					k = 1;  

					for (i=1;i<ItemNo;i++)
						k += C[i].NumOfParametersInGroup;

					TextDialog(hDlg, IDC_GLABEL, Set, (char *) C[k].GroupName);
					NewColor      = ST[ItemNo].GColor; 
					fColorDialog  = ColorDialog(hDlg, &cc, Set, &NewColor);
					dGMSymbol     = IntegerDialog(hDlg, IDC_MSYMBOL, Set, iFormatStr, ST[ItemNo].GMSymbol, err);
					dGMSize       = IntegerDialog(hDlg, IDC_MSIZE, Set, iFormatStr, ST[ItemNo].GMSize, err);
					PaintTheBlock (hCtrlBlock, RGB(ST[ItemNo].GColor.red,ST[ItemNo].GColor.green,ST[ItemNo].GColor.blue));

					return TRUE;
					break;

				case IDCANCEL :
					EndDialog (hDlg, FALSE);
					return TRUE;
					break;

				default:
					break;
      }
      break;

    case WM_PAINT :
			if (fColorDialog)
	      PaintTheBlock (hCtrlBlock, cc.rgbResult);
	    else  
	      PaintTheBlock (hCtrlBlock, RGB(ST[ItemNo].GColor.red,ST[ItemNo].GColor.green,ST[ItemNo].GColor.blue));
      break;

		default:
			break;
  }

	return FALSE;
}
