/*********************************************************************
*                                                                    *
*     Do_YAxis Menu                                                  *
*                                                                    *
*     Programmautor: Rainer Sieger, Universitt Bremen, SFB261       *
*     Datei erstellt am: 24.10.95                                    *
*     Letzte nderung: 21.06.99                                      *
*                                                                    *
*********************************************************************/
      
#include <windows.h>

#include "Struct.h"
#include "Globals.h"

#include "SetMinMax.h"
#include "Win_GUI.h"
#include "Do_YAxisMenu.h"
#include "Do_YAxisDialog.h"
#include "Do_SelectDialog.h"

void Do_YAxisMenu (HWND hwnd, HINSTANCE hInst, int MenuItem)
{
	int  j     = 0;
	int	 dummy = 0;
	
	switch (MenuItem)
	{
		case IDM_YAXIS_SELECTBYPARAMETERS: 
      SelectMode = useParameters;
      DialogBox (hInst, "SELECT", hwnd, (DLGPROC) Do_SelectDialog);
		  break;

		case IDM_YAXIS_SELECTBYGROUPS: 
      SelectMode = useGroups;
      DialogBox (hInst, "SELECT", hwnd, (DLGPROC) Do_SelectDialog);
		  break;

		case IDM_YAXIS_SELALL :           
		  gSelectedNumOfParameters = 0;

			switch (Mode)
			{
				case VerticalMode:
				case HorizontalMode:
	 				for (j=1;j<=gNumOfParameters;j++)
					{	 	  
            dummy  = ST[j].PlotMarker + ST[j].PlotLine + ST[j].Colorize;
            dummy += ST[j].PlotCHistogramm + ST[j].PlotLHistogramm;
						dummy += ST[j].PlotText + ST[j].PlotOccurrence + ST[j].PlotComment;

						if (dummy < 1)
						{
							if (C[j].counts > 0)
							{
								ST[j].PlotMarker  = 1;
								ST[j].PlotLine    = 1;
							}
							else
							{
								ST[j].PlotComment = 1;		            
							}
            }

            ST[j].PlotData = 1;
            gSelectedNumOfParameters++;
	 				}
					break;

				case TernaryMode:
				case PhaseMode:
	 				for (j=1;j<=gNumOfGroups;j++)
					{	 	  
						if ((C[j].counts > 0) && (C[j+1].counts > 0) && (C[j+2].counts > 0))
						{
	       			gSelectedNumOfParameters++;
	       			ST[j].GPlotData = 1;
	 					}  
	 				}
					break;

				default:
					break;
			}
      break;

		case IDM_YAXIS_SELNONE: 
			switch (Mode)
			{
				case VerticalMode:
				case HorizontalMode:
			 	  for (j=1;j<=MAXNUMOFPARAMETERS;j++)
				     ST[j].PlotData = 0;
					break;

				case TernaryMode:
				case PhaseMode:
			 	  for (j=1;j<=MAXNUMOFPARAMETERS;j++)
				     ST[j].GPlotData = 0;
					break;

				default:
					break;
			}

	 		gSelectedNumOfParameters = 0;
		  break;

		default:
			break;
	}	

	SetMinMax (-1);
} 
