/*-------------------------------------*/
/*  FileSystem.c                       */
/*  Dr. Rainer Sieger, AWI Bremerhaven */
/*  2007-08-03                         */
/*-------------------------------------*/

#include <windows.h>
#include <string.h>
#include <stdio.h>

#include "Struct.h"
#include "Globals.h"

#include "FileSystem.h"

FILE* openFile(char *fname, char *mode)
{
	FILE *fp;
	
  if ((fp = fopen(fname,mode)) == NULL)
		return(NULL);

	return(fp);
}

// ******************************************************************************************
// ******************************************************************************************
// ******************************************************************************************

void closeFile(FILE *fp)
{
	fclose(fp);
}

// ******************************************************************************************
// ******************************************************************************************
// ******************************************************************************************

FILE *openNewFile(char *Filename)
{
  return(fopen((char *) Filename,"w"));
}

// ******************************************************************************************
// ******************************************************************************************
// ******************************************************************************************

void writeFile(FILE *fp, char *OutputStr)
{
	fprintf(fp,"%s",OutputStr);
}

// ******************************************************************************************
// ******************************************************************************************
// ******************************************************************************************

long readFile(FILE *fin, char *InputStr, long NumOfChar)
{ 
	int     err    = 0;		
  long    length = 0;
  char    InputChar;
  
	memset(InputStr, (int) '\0', (unsigned long) (NumOfChar+1));
	
  while (!err)
  {
    if (++length > NumOfChar)
      return(-NumOfChar);
      
		if ((InputChar = (char) fgetc(fin)) == EOF)
			return(-length);
			
    if ((InputChar != 13) && (InputChar != 10))
		{
	    *InputStr++ = InputChar;
		}
	  else
    {
      if ((length == 1) && (InputChar == 10))
				length = readFile(fin,InputStr,NumOfChar);
		  return(length);				
    }
  } 

  return(0);
}     

