/*********************************************************************
*                                                                    *
*     FindItem                                                       *
*                                                                    *
*     Programmautor: Rainer Sieger, Universitaet Bremen, SFB261      *
*     Datei erstellt am: 24.10.95                                    *
*     Letzte Aenderung: 19.06.2000                                   *
*                                                                    *
*********************************************************************/
      
#include <windows.h>
#include "Win_GUI.h"

#include "Struct.h"
#include "Globals.h"

#include "FindItem.h"
#include "Font.h"

// *******************************************************************

int FindCheckBoxPhaseMode(int h_pos, int v_pos)
{
  int j 							= 0;
  int NumOfCheckboxes = 0;
  
	int px, py;
	int Abstand;

// *******************************************************************

	switch (SelectMode)
	{
	  case useParameters:
		  NumOfCheckboxes = gNumOfParameters;
		  break;

		case useGroups:
		  NumOfCheckboxes = gNumOfGroups;
		  break;		  

		default:
			break;
	}
  
	Abstand = xTitleHeight/2 - 1;

	if (((px = C[0].P[1]+C[0].P[3]/2+2*RLT) - Abstand) <= h_pos)
	{
		while (++j<=NumOfCheckboxes)
		{
			py = C[0].P[2]-C[0].P[4]/2+(int) (1.3 * (float) (j*xTitleHeight-Abstand));
	
			if ((py-Abstand <= v_pos) && (v_pos <= py+Abstand))
			{
				if ((px-Abstand <= h_pos) && (h_pos <= px+Abstand))
					return(0); // return(j);			

				if ((h_pos > px+Abstand))
					return(-j);			
			}
		}
	}

	return(0);
} 	

// *******************************************************************
// *******************************************************************
// *******************************************************************

int FindCheckBoxTernaryMode(int h_pos, int v_pos)
{
  int j 							= 0;
  int NumOfCheckboxes = 0;
  
	int px, py;
	int Abstand;

// *******************************************************************

	switch (SelectMode)
	{
	  case useParameters:
		  NumOfCheckboxes = gNumOfParameters;
		  break;

		case useGroups:
		  NumOfCheckboxes = gNumOfGroups;
		  break;		  

		default:
			break;
	}
  
	Abstand = xTitleHeight/2 - 1;

	if (((px = C[0].P[1]+C[0].P[3]+2*RLT) - Abstand) <= h_pos)
	{
		while (++j<=NumOfCheckboxes)
		{
			py = C[0].P[2]-C[0].P[4]+(int) (1.3 * (float) (j*xTitleHeight-Abstand));

			if ((py-Abstand <= v_pos) && (v_pos <= py+Abstand))
			{
				if ((px-Abstand <= h_pos) && (h_pos <= px+Abstand))
					return(0); // return(j);			

				if ((h_pos > px+Abstand))
					return(-j);			
			}
		}
	}

	return(0);
} 	

// *******************************************************************
// *******************************************************************
// *******************************************************************

int FindItem(int h_pos, int v_pos)
{
  int    j = 0;
	int    l = 0;

  int Item = 0;
      
  int Pos1 = 0;
  int Pos2 = 0;
  int Pos3 = 0;
  int Pos4 = 0;

// *******************************************************************

  if ((C[0].counts >= 2) && (gSelectedNumOfParameters > 0))
  {
		switch (Mode)
  	{
			case VerticalMode:
        while (++j <= MAXNUMOFPARAMETERS)
				{
          if (ST[j].PlotData > 0)
          {
            Pos1 = C[j].P[1];
            Pos2 = C[j].P[2];
            j    = MAXNUMOFPARAMETERS;
          }
				}

        j = MAXNUMOFPARAMETERS + 1;
        
				while (--j > 0)
				{
          if (ST[j].PlotData > 0)
          {
            Pos3 = C[j].P[1] + C[j].P[3];
            Pos4 = C[j].P[2] + C[j].P[4];
            j    = 0;
          }
				}

        if ((h_pos >= Pos1) && (h_pos <= Pos3) && (v_pos <= Pos4))
        {
	        j = 0;
	      
					while (++j <= MAXNUMOFPARAMETERS)
					{
	          if (ST[j].PlotData > 0)
						{
	            if (h_pos < (C[j].P[1]+C[j].P[3]))
	            {
	              Item = j;
	              j    = MAXNUMOFPARAMETERS;
	            }  
						}
					}
	    	}    
        else
        {
          if ((h_pos < Pos1) && (v_pos > Pos2)) Item = -2; // X_Axis
          if ((h_pos < Pos1) && (v_pos < Pos2)) Item = -1; // Graphic
          if (v_pos > Pos4) Item = -1;                     // Graphic
        }
        break;
        
  	  case HorizontalMode:
				while (++j <= MAXNUMOFPARAMETERS)
				{
					if (ST[j].PlotData > 0)
					{
							Pos1 = C[j].P[1];
							Pos2 = C[j].P[2] + C[j].P[4];
							j    = MAXNUMOFPARAMETERS;
					}
				}

				j = MAXNUMOFPARAMETERS + 1;
		
				while (--j > 0)
				{
					if (ST[j].PlotData > 0)
					{
							Pos3 = C[j].P[1] + C[j].P[3];
							Pos4 = C[j].P[2];
							j    = 0;
					}
				}

				if ((v_pos >= Pos2) && (v_pos <= Pos4) && (h_pos <= Pos3))
				{
					j = 0;
				
					while (++j <= MAXNUMOFPARAMETERS)
					{
						if (ST[j].PlotData > 0)
						{
							if (v_pos < C[j].P[2])
							{
									Item = j;
									j    = MAXNUMOFPARAMETERS;
							}  
						}
					}
    		}    
				else
				{
						if ((h_pos > Pos1) && (v_pos < Pos2)) Item = -2; // X_Axis
						if ((h_pos < Pos1) && (v_pos < Pos2)) Item = -1; // Graphic
						if (v_pos > Pos4) Item = -2;                     // X_Axis
						if (h_pos > Pos3) Item = -1;										 // Graphic          
				}
        break;        

			default:
				break;
    }   
  }

  return(Item);
}

