/*********************************************************************
*                                                                    *
*     Koordinatensystem                                              *
*                                                                    *
*     Programmautor: Rainer Sieger, Universitaet Bremen, SFB261      *
*     Datei erstellt am: 3.8.94                                      *
*     Letzte Aenderung: 11.01.2000                                   *
*     Macintosh                                                      *
*     Windows                                                        *
*                                                                    *
*********************************************************************/

#define Test  FALSE

#include <string.h>
#include <windows.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"

#include "Plotter.h"
#include "Graphic.h"
#include "Font.h"
#include "ForeColor.h"

void Koordinatensystem(HDC hdc, int PlotMode)
{
	int      l          = 0;
	int      Size       = 0;
	int      PointX     = 0;
	int      PointY     = 0;
	int      Breite     = 0;
	int      Hoehe      = 0;
	int      Scale      = 0;
	int      Textbreite = 0;

	int      j          = 0;
	int      pos        = 0;
	int      hoffset    = 0;
	int      voffset    = 0;
	int      L          = 0;

	float    F          = (float) 0.;

// *********
// * Fenstergroesse ermitteln (aus erstem dazustellenden Fenster)

	F = (float) cxDpi/ScreenDpi;

	while (++j <= MAXNUMOFPARAMETERS)
	{
		if (j > gNumOfParameters)
			return;
	  
		if (ST[j].PlotData > 0)
		{
			PointX    = C[j].P[1];
			Breite    = C[j].P[3];
			Hoehe     = C[j].P[4];
			j         = MAXNUMOFPARAMETERS;
		}
	}
      
// ********
// * Hoehe der Scale bestimmen

	Scale = CalcScale();

// ***********
// * Parameternamen und Uniten schreiben

	switch(Mode)
	{
		case HorizontalMode:
			WriteParameterNameH(hdc,Scale);
			break;

		case VerticalMode:
			WriteParameterNameV(hdc,Scale);
			break;

		case TernaryMode:
			WriteParameterNameT(hdc);
			break;

		case PhaseMode:
			WriteParameterNameP(hdc);
			break;

		default:
			break;
	}    

// ********
// *  Unit der X-Achse (Tiefe oder Zeit) schreiben

	switch(Mode)
	{
		case HorizontalMode:
			WriteXAxisH(hdc,Scale);
			break;

		case VerticalMode:
			WriteXAxisV(hdc,Scale);
			break;

		default:
			break;
	}    
      
// ********
// *  Copyright schreiben

	switch(Mode)
	{
		case VerticalMode:
			WriteCopyright(hdc);
			break;

		default:
			break;
	}    
			
// *********
// * Achsen skalieren

	switch(Mode)
	{
		case HorizontalMode:
			XSkalierungH(hdc,Scale);
			YSkalierungH(hdc,Scale);
			break;

		case VerticalMode:
			XSkalierungV(hdc,Scale);
			YSkalierungV(hdc,Scale);
			break;

		default:
			break;
	}    

// *********
// * FensterRahmen zeichnen

  if ((PlotMode != Export) && (PlotMode != ExportToFile) && (PlotMode != Print))
  {
		switch(Mode)
		{
			case VerticalMode:
      case HorizontalMode:	
	      for (j=1;j<=gNumOfParameters;j++)
  	      if (ST[j].PlotData > 0)
    	    {
      	    CLinie(hdc,C[j].P[1],C[j].P[2],C[j].P[1],C[j].P[2]+C[j].P[4],KoorLineWidth*(int) F,BLACK);
	        	CLinie(hdc,C[j].P[1],C[j].P[2]+C[j].P[4],C[j].P[1]+C[j].P[3],C[j].P[2]+C[j].P[4],KoorLineWidth*(int) F,BLACK);
  	        CLinie(hdc,C[j].P[1]+C[j].P[3],C[j].P[2]+C[j].P[4],C[j].P[1]+C[j].P[3],C[j].P[2],KoorLineWidth*(int) F,BLACK);
    	      CLinie(hdc,C[j].P[1]+C[j].P[3],C[j].P[2],C[j].P[1],C[j].P[2],KoorLineWidth*(int) F,BLACK);
      	  }
      	break;
      	
      case TernaryMode:
     	  CLinie(hdc,C[0].P[1],C[0].P[2],C[0].P[1]+C[0].P[3]/2,C[0].P[2]-C[0].P[4],KoorLineWidth*(int) F,BLACK);
	      CLinie(hdc,C[0].P[1]+C[0].P[3]/2,C[0].P[2]-C[0].P[4],C[0].P[1]+C[0].P[3],C[0].P[2],KoorLineWidth*(int) F,BLACK);
        CLinie(hdc,C[0].P[1]+C[0].P[3],C[0].P[2],C[0].P[1],C[0].P[2],KoorLineWidth*(int) F,BLACK);       	  	
      	break;

			default:
				break;
    }    
  }

// *********
// * TestRahmen zeichnen

	if (Test)
	{
		CLinie(hdc,1,1,gDataPlotWindowWidth-1,1,2,BLACK);
		CLinie(hdc,gDataPlotWindowWidth-1,1,gDataPlotWindowWidth-1,gDataPlotWindowHeight-1,2,BLACK);
		CLinie(hdc,gDataPlotWindowWidth-1,gDataPlotWindowHeight-1,1,gDataPlotWindowHeight-1,2,BLACK);
		CLinie(hdc,1,gDataPlotWindowHeight-1,1,1,2,BLACK);
	}
}


