/*---------------------------------------------
   PanPlot.C -- PanPlot

		Dr. Rainer Sieger, Universitaet Bremen
		20.10.2000

		Programmgerst: (c) Charles Petzold, 1996
  ---------------------------------------------*/

#include <windows.h>
#include <commdlg.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "Struct.h"
#include "Globals.h"

#include "WndProc.h"
#include "Win_GUI.h"
#include "Window.h"
#include "Fileselect.h"
#include "Do_FileMenu.h"
#include "PrintTools.h"

#include "ReadData.h"
#include "Initialize.h"
#include "Preferences.h"

//------------------------------------------------------------------
//------------------------------------------------------------------
//------------------------------------------------------------------
// globale Variablen

int             iTest											= 0;
int             Registriert								= 0;

char            szAppName[32]							= "PanPlot";

char						szFrameClass[]						= "MdiFrame";
char						szDataDescriptionClass[]	= "MdiDataDescriptionChild";
char						szDataPlotClass[]					= "MdiDataPlotChild";

HINSTANCE       hInst; 

HMENU						hMenuInit,						hMenuInitWindow;
HMENU						hMenuDataPlot,				hMenuDataPlotWindow;
HMENU						hMenuDataDescription, hMenuDataDescriptionWindow;

HMENU						hSubMenuFile, hSubMenuEdit;
HMENU						hSubMenuOptions, hSubMenuYAxis;
HMENU           hSubMenuSetAll;

HWND						hDlgModeless;

HFONT           hFont											= 0;
HDC						  hdc, Winhdc;
COLORREF        crCustColors[16];
PRINTDLG				pd;
PAGESETUPDLG    psd;
OPENFILENAME		ofn;
LOGFONT					lf;
DEVMODE					dm;

RGBColor        GRAY;
RGBColor        BLACK;
RGBColor        WHITE;
RGBColor        NewColor;
RGBColor				FirstColor;
RGBColor				LastColor;

Str31           Font											= "Arial";
Str31						TemplateVersion						= "";

StrFullName			Editor										= "Notepad.exe";
StrName  				EName											= "Notepad.exe";
StrPath					EPath											= "";

StrFullName     FullName									= "";
StrName					Name											= "";
StrPath         Path											= ""; 

StrFullName     DDFullName								= "";
StrName					DDName										= "";
StrPath         DDPath										= ""; 

StrFullName     TFullName									= "";
StrName					TName											= "";
StrPath       	TPath											= "";

StrFullName     PFullName									= "";
StrName					PName											= "";
StrPath       	PPath											= "";

StrPath       	BPath											= "";

int             FileExtension							= TAB;
int							AutoLoadData 							= 0;
int		          DataDescriptionSaved			= 0;
int					 		ChooseEditor							= 0;

float           cxDpi;
float           cyDpi;

int							gActivWindow;

int				 			gFrameWindowX												= -1;
int						 	gFrameWindowY												= -1;
int				 			gFrameWindowWidth										= -1;
int				 			gFrameWindowHeight									= -1;

int							gDataPlotWindow											= 0;
int           	gDataPlotWindowHeight								= -1;
int           	gDataPlotWindowWidth								= -1;

int							gDataDescriptionWindow							= 0;
int           	gDataDescriptionWindowHeight				= -1;
int           	gDataDescriptionWindowWidth					= -1;

int					 		gClientDataPlotWindowX							= -1;
int					 		gClientDataPlotWindowY							= -1;
int					 		gClientDataPlotWindowWidth			 		= -1;
int					 		gClientDataPlotWindowHeight					= -1;

int           	gClientDataDescriptionWindowX				= -1;
int           	gClientDataDescriptionWindowY				= -1;
int					 		gClientDataDescriptionWindowWidth		= -1;
int					 		gClientDataDescriptionWindowHeight	= -1;

int		          WindowOffset											= 0;

int             ScreenDpi													= 72;
int             dpcm															= 28;

int             Mode															= VerticalMode;
int             KoorLineWidth											= 0;
int   		      useColor													= 1;
int							useDefaultColor										= 0;
int       	    useTemplate												= 0;
int         		ClipCoorSys												= 0;
int         		AllInOne													= 0;
int             UnitFormat												= 1;
int             PlotAbsoluteScale									= 0;
int             TerIncrement											= 0;
int             GroupDistance											= 0;
int							TextOrientation										= 0;

RGBColor        *Color;
RGBColor        *GColor;
DefaultColor    *DColor;
char            *InputStr;
char            *TempStr;
char            *ReplaceTempStr;
char						*HeaderStr1;
char						*HeaderStr2;
DDData					*DataDescription;
StrName         *Filelist;
DialogItem      *Item;
Options         *ST;
Container       *C;
CData		        *T;
Data            *Q;
POINT           *PT;
BitmapPattern		*BitPattern;

int             ExternCopyright										= 0;
int             GroupTitles												= 0;
int							CRDateTime												= 0;
int							CRFilename												= 0;
Str255          Copyrighttext											= "";
Str255					strCRDateTime											= "";
Str511					strCRFilename											= "";

int             gSelectedNumOfParameters					= 0;
int             gNumOfParameters  								= 0;
int							gNumOfGroups											= 1;
int							gNumOfBitmaps											= 0;
int							gNumOfLines												= 0;
int							gActivWindow				 							= DataPlotWindowIsActiv;

int             Batch 														= 0;
int             Update 														= 1;

int							sorted														= 1;
int             SelectMode												= useGroups;
      
int             FontSize													= 10;
int             GFontSize													= 10;

int							GroupTitleHeight									= 0;
int             xTitleHeight											= 0;
int             xTitleWidth												= 0;
int             xUnitHeight												= 0;
int             xUnitWidth												= 0;
int							xValueHeight											= 0;
int             HxValueHeight											= 0;
int							xValueWidth												= 0;
int             yTitleHeight											= 0;
int             yTitleWidth												= 0;
int             yUnitHeight												= 0;
int             yUnitWidth												= 0;
int							yValueHeight											= 0;
int							yValueWidth												= 0;
int             InfoHeight												= 0;
int             InfoWidth													= 0;
int             CopyrightHeight										= 0;
int             CopyrightWidth										= 0;
int             BlankWidth												= 0;

int							RLT																= 5;  // Rand links zum Text
int							RRT																= 5;  // Rand rechts zum Text
int							ROT																= 5;  // Rand oben zum Text
int							RUT																=	5;  // Rand unten zum Text

float						DateOffset												= 0.f;
int							isDate														= 0;
int							isTime														= 0;

unsigned long   gNumOfComments										= 0;
unsigned long   gMaxCData													= 2000;
unsigned long   gMaxMData													= 100000;

//------------------------------------------------------------------
//------------------------------------------------------------------
//------------------------------------------------------------------

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
	int					err			= 0;

	long        hOffset	= 0;
	long        vOffset	= 0;

	HACCEL      hAccel;
	HWND        hwndFrame, hwndClient;
	MSG         msg;
	WNDCLASSEX  wndclass;

	char        *p;

//------------------------------------------------------------------
// Calculation of max window size, get window positions from preference file

	err = LoadWindowPreferences();

	if ( (err != 0 ) || (gFrameWindowWidth > GetSystemMetrics(SM_CXSCREEN)) || (gFrameWindowHeight > GetSystemMetrics(SM_CYSCREEN)) )
		InitWindows();

//------------------------------------------------------------------
// Initialisierung.

	Initialize();																	

//------------------------------------------------------------------
// Command line

	if ((p = strrchr(szCmdLine, (int) '"')) != NULL)
		*p = '\0';

	if ((p = strchr(szCmdLine, (int) '"')) != NULL)
		strncpy(szCmdLine,p+1,strlen(p));

	if ((p = strrchr(szCmdLine, (int) '\\')) != NULL)
	{
		strcpy((char *) FullName, (char *) szCmdLine);
		strncpy((char *) Path, (char *) szCmdLine, (unsigned int) (p+1-szCmdLine)); 
		strncpy(szCmdLine,p+1,(unsigned int) strlen(p));
		strcpy((char *) Name, (char *) szCmdLine); 
		AutoLoadData = 1;
	}

//------------------------------------------------------------------

	hInst = hInstance;

  if (!hPrevInstance) 
  {
// Register the frame window class
	  wndclass.cbSize        = sizeof (wndclass);
		wndclass.style         = CS_HREDRAW | CS_VREDRAW;
		wndclass.lpfnWndProc   = FrameWndProc;
		wndclass.cbClsExtra    = 0;
	  wndclass.cbWndExtra    = 0;
		wndclass.hInstance     = hInstance;
	  wndclass.hIcon         = LoadIcon (hInstance, szAppName);

		wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
	  wndclass.hbrBackground = (HBRUSH) (COLOR_APPWORKSPACE + 1);
		wndclass.lpszMenuName  = szAppName;
	  wndclass.lpszClassName = szFrameClass;
		wndclass.hIconSm       = LoadIcon (hInstance, szAppName);

		RegisterClassEx (&wndclass);

// Register the DataPlot child window class

	  wndclass.cbSize        = sizeof (wndclass);
		wndclass.style         = CS_HREDRAW | CS_VREDRAW;
		wndclass.lpfnWndProc   = DataPlotWndProc;
	  wndclass.cbClsExtra    = 0;
		wndclass.cbWndExtra    = sizeof (HANDLE);
		wndclass.hInstance     = hInstance;
	  wndclass.hIcon         = LoadIcon (hInstance, szAppName);
		wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
		wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH);
	  wndclass.lpszMenuName  = NULL;
		wndclass.lpszClassName = szDataPlotClass;
		wndclass.hIconSm       = LoadIcon (hInstance, szAppName);

	  RegisterClassEx (&wndclass);

// Register the Data Description child window class

	  wndclass.cbSize        = sizeof (wndclass);
		wndclass.style         = CS_HREDRAW | CS_VREDRAW;
		wndclass.lpfnWndProc   = DataDescriptionWndProc;
	  wndclass.cbClsExtra    = 0;
		wndclass.cbWndExtra    = sizeof (HANDLE);
		wndclass.hInstance     = hInstance;
	  wndclass.hIcon         = LoadIcon (hInstance, szAppName);
		wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW);
		wndclass.hbrBackground = (HBRUSH) GetStockObject (WHITE_BRUSH);
	  wndclass.lpszMenuName  = NULL;
		wndclass.lpszClassName = szDataDescriptionClass;
		wndclass.hIconSm       = LoadIcon (hInstance, szAppName);

	  RegisterClassEx (&wndclass);
	}

//------------------------------------------------------------------
// Handles to menus

  hMenuInit										= LoadMenu (hInst, "MdiMenuInit");
  hMenuDataPlot								= LoadMenu (hInst, "MdiMenuDataPlot");
  hMenuDataDescription				= LoadMenu (hInst, "MdiMenuDataDescription");

  hMenuInitWindow							= GetSubMenu (hMenuInit, 0);
  hMenuDataPlotWindow					= GetSubMenu (hMenuDataPlot, 3);
  hMenuDataDescriptionWindow  = GetSubMenu (hMenuDataDescription, 1);

	hSubMenuFile								= GetSubMenu (hMenuDataPlot, 0);
	hSubMenuEdit								= GetSubMenu (hMenuDataPlot, 1);
	hSubMenuOptions							= GetSubMenu (hMenuDataPlot, 2);

  hSubMenuYAxis								= GetSubMenu (hSubMenuOptions, 8);

  hSubMenuSetAll							= GetSubMenu (hSubMenuYAxis, 5);

//------------------------------------------------------------------
// Load accelerator table

  hAccel = LoadAccelerators (hInst, szAppName);

//------------------------------------------------------------------
// Create the frame window

	hwndFrame = CreateWindow (szFrameClass, szAppName,
														WS_OVERLAPPEDWINDOW | WS_CLIPCHILDREN,
														gFrameWindowX, gFrameWindowY, 
														gFrameWindowWidth, gFrameWindowHeight,
														NULL, hMenuInit, hInstance, NULL);

	hwndClient = GetWindow (hwndFrame, GW_CHILD);

	ShowWindow (hwndFrame, iCmdShow);
	UpdateWindow (hwndFrame);

//------------------------------------------------------------------

	InitPrinter (hwndFrame);

//------------------------------------------------------------------

  SendMessage (hwndFrame, WM_COMMAND, IDM_OPEN, 0);

//------------------------------------------------------------------

  while (GetMessage (&msg, NULL, 0, 0))
  {
    if (!TranslateMDISysAccel (hwndClient, &msg) && !TranslateAccelerator (hwndFrame, hAccel, &msg))
    {
      TranslateMessage (&msg);
      DispatchMessage (&msg);
    }
  }

	DestroyMenu (hMenuDataPlot);
  DestroyMenu (hMenuDataDescription);

  return((int) msg.wParam);
}




