/*********************************************************************
*                                                                    *
*     PlotHistogrammColumn.c - Plot Histogrammsaeulen                *
*                                                                    *
*     Programmautor: Rainer Sieger, Universitaet Bremen              *
*     Datei erstellt am: 10.02.98                                    *
*     Letzte Aenderung: 03.04.99                                     *
*                                                                    *
*********************************************************************/

#include <string.h>
#include <stdio.h>

#include <windows.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"

#include "SetMouseCursor.h"
#include "Plotter.h"
#include "SetPoint.h"
#include "PutText.h"
#include "Font.h"
#include "Graphic.h"
#include "CalcValue.h"

void PlotHistogramColumnV(HDC hdc, int PlotMode, int j, int m, float F)
{
  unsigned long  i     = 0;    
  unsigned long  k     = 0;
  unsigned long  e     = 0;
	unsigned long  index = 0;
  
  int   l     = 0;
  int   P1    = 0;
  int   P2    = 0;
  int   P13   = 0;
  int   P24   = 0;
  int   px    = 0;
  int   py    = 0;
  int   pyo   = 0;
  int   pyu   = 0;
  int   nl    = 0;
  
  int   MSize      = 0;
  int   MLineWidth = 0;
	
  int   PlotData   = 0;
  int   add				 = 0;

  float   dpy      = (float) 0.;
  float   Wert     = (float) 0.;
		
// ***********************************************

	SetWaitMouseCursor();

	P1  = C[j].P[1];
	P2  = C[j].P[2];
	P13 = P1+C[j].P[3];
	P24 = P2+C[j].P[4];
	nl  = (int) xinpx(C[j].K[1],C[j].K[2],ST[j].Refline);
	if (nl < P1)  nl = P1;
	if (nl > P13) nl = P13;
	  
	dpy  = yinpy(C[j].K[3],C[j].K[4],Q[Q[C[j].Offset+C[j].counts].I].V);
	dpy -= yinpy(C[j].K[3],C[j].K[4],Q[Q[C[j].Offset+1].I].V);
	dpy /= 2;
	dpy /= (float) C[j].counts;

	while (--m >= 0)
	{
		if (ST[j].AddNext < 0)
			add = -m;                       
		else      
			add = m;                       

		if (ST[j+m].PlotCHistogramm > 0)
		{
			k = C[j+m].Offset + 1;
			e = C[j+m].counts;

			i = 0;

			while (++i <= e)
			{
				Wert = CalcValue(i,j,add,&index,&PlotData);

				if ((Q[index].I > 0) && (PlotData == 1))
				{
					px  = (int) xinpx(C[j].K[1],C[j].K[2],Wert);

					if (Q[index].I >= 0)
						py  = (int) yinpy(C[j].K[3],C[j].K[4],Q[Q[index].I].V);

					if (ST[j+m].ColumnWidth > 0)
					{
						pyo = py - ST[j+m].ColumnWidth/2*(int) F;
						pyu = py + ST[j+m].ColumnWidth/2*(int) F; 
					}
					else
					{
						pyo = py - (int) (F*(dpy + (float) 0.5));
						pyu = py + (int) (F*(dpy + (float) 0.5));
					}

					if (pyo < P2)  pyo = P2;
					if (pyu > P24) pyu = P24;
					
					if (px < P1+1)   px = P1;
					if (px > P13-1)  px = P13;
	    
					if ((py >= P2) && (py <= P24))
					{
						if (nl < px)
						{
							if ((ST[j+m].Color.red == 0) && (ST[j+m].Color.green == 0) && (ST[j+m].Color.blue == 0))
								CFillRechteck(hdc,nl,pyo,px,pyu,(int) F,GRAY);
							else
								CFillRechteck(hdc,nl,pyo,px,pyu,(int) F,ST[j+m].Color);

							if ((PlotMode == NoInit) || (PlotMode == Init) || (PlotMode == Print)) 
								CRechteck(hdc,nl,pyo,px,pyu,(int) F,BLACK);
						}   
						else
						{
							if ((ST[j+m].Color.red == 0) && (ST[j+m].Color.green == 0) && (ST[j+m].Color.blue == 0))
								CFillRechteck(hdc,px,pyo,nl,pyu,(int) F,GRAY);
							else
								CFillRechteck(hdc,px,pyo,nl,pyu,(int) F,ST[j+m].Color);

							if ((PlotMode == NoInit) || (PlotMode == Init) || (PlotMode == Print)) 
								CRechteck(hdc,px,pyo,nl,pyu,(int) F,BLACK);
						}   
					}  
					else
					{
						if (py > P24) i = k + C[j+m].counts + 1;
					}
				}
			}
		}
	}

	SetDefaultMouseCursor();
}

// ***********************************************
// ***********************************************
// ***********************************************

void PlotHistogramColumnH(HDC hdc, int PlotMode, int j, int m, float F)
{
  unsigned long  i     = 0;    
  unsigned long  k     = 0;
  unsigned long  e     = 0;
	unsigned long  index = 0;
  
  int   l     = 0;
  int   P1    = 0;
  int   P2    = 0;
  int   P13   = 0;
  int   P24   = 0;
  int   px    = 0;
  int   py    = 0;
  int   pxl   = 0;
  int   pxr   = 0;
  int   nl    = 0;
  
  int   MSize      = 0;
  int   MLineWidth = 0;
	
  int   PlotData   = 0;
  int   add				 = 0;

  float   dpx      = (float) 0.;
  float   Wert     = (float) 0.;
		
// ***********************************************
    
	SetWaitMouseCursor();

	P1  = C[j].P[1];
	P2  = C[j].P[2];
	P13 = C[j].P[1]+C[j].P[3];
	P24 = C[j].P[2]+C[j].P[4];
	nl  = (int) yinpy(C[j].K[3],C[j].K[4],ST[j].Refline);
	if (nl > P2)  nl = P2;
	if (nl < P24) nl = P24;
	  
	dpx  = xinpx(C[j].K[1],C[j].K[2],Q[Q[C[j].Offset+C[j].counts].I].V);
	dpx -= xinpx(C[j].K[1],C[j].K[2],Q[Q[C[j].Offset+1].I].V);
	dpx /= 2;
	dpx /= (float) C[j].counts;

	while (--m >= 0)
	{
		if (ST[j].AddNext < 0)
			add = -m;                       
		else      
			add = m;                       

		if (ST[j+m].PlotCHistogramm > 0)
		{
			k = C[j+m].Offset + 1;
			e = C[j+m].counts;

			i = 0;

			while (++i <= e)
			{
				Wert = CalcValue(i,j,add,&index,&PlotData);

				if ((Q[index].I > 0) && (PlotData == 1))
				{
					if (Q[index].I >= 0)
						px  = (int) xinpx(C[j].K[1],C[j].K[2],Q[Q[index].I].V);
					py  = (int) yinpy(C[j].K[3],C[j].K[4],Wert);

					if (ST[j+m].ColumnWidth > 0)
					{
						pxl = px - ST[j+m].ColumnWidth/2*(int) F;
						pxr = px + ST[j].ColumnWidth/2*(int) F;
					}
					else
					{
						pxl = px - (int) (F*(dpx + (float) 0.5));
						pxr = px + (int) (F*(dpx + (float) 0.5));
					}

					if (pxl < P1)  pxl = P1;
					if (pxr > P13) pxr = P13;
					
					if (py > P2+1)   py = P2;
					if (py < P24+1)  py = P24;
	    
					if ((px >= P1) && (px <= P13))
					{
						if (nl < py)
						{
							if ((ST[j+m].Color.red == 0) && (ST[j+m].Color.green == 0) && (ST[j+m].Color.blue == 0))
								CFillRechteck(hdc,pxl,nl,pxr,py,(int) F,GRAY);
							else
								CFillRechteck(hdc,pxl,nl,pxr,py,(int) F,ST[j+m].Color);

							if ((PlotMode == NoInit) || (PlotMode == Init) || (PlotMode == Print)) 
								CRechteck(hdc,pxl,nl,pxr,py,(int) F,BLACK);
						}   
						else
						{
							if ((ST[j+m].Color.red == 0) && (ST[j+m].Color.green == 0) && (ST[j+m].Color.blue == 0))
								CFillRechteck(hdc,pxl,py,pxr,nl,(int) F,GRAY);
							else
								CFillRechteck(hdc,pxl,py,pxr,nl,(int) F,ST[j+m].Color);

							if ((PlotMode == NoInit) || (PlotMode == Init) || (PlotMode == Print)) 
								CRechteck(hdc,pxl,py,pxr,nl,(int) F,BLACK);
						}   
					}  
					else
					{
						if (px > P13) i = k + C[j+m].counts + 1;
					}
				}          
			}
		}
	}

	SetDefaultMouseCursor();
}

