/*********************************************************************
*                                                                    *
*     PlotHistogramOutline.c - Plot Linienhistogramm                 *
*                                                                    *
*     Programmautor: Rainer Sieger, Alfred-Wegener-Institut          *
*     Datei erstellt am: 10.02.98                                    *
*     Letzte Aenderung: 30.5.2002                                    *
*                                                                    *
*********************************************************************/

#include <string.h>
#include <stdio.h>
#include <windows.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"

#include "SetMouseCursor.h"
#include "Plotter.h"
#include "SetPoint.h"
#include "PutText.h"
#include "Font.h"
#include "Graphic.h"
#include "CalcValue.h"

void PlotHistogramLineV(HDC hdc, float F)
{
  unsigned long  i     = 0;    
  unsigned long  k     = 0;
  
  int   l     = 0;
	int		j			= 0;
  int   P1    = 0;
  int   P2    = 0;
  int   P13   = 0;
  int   P24   = 0;
  int   px    = 0;
  int   py    = 0;
	int   nl    = 0;		
  
  int   MSize      = 0;
  int   MLineWidth = 0;
		
// ***********************************************

	SetWaitMouseCursor();
    
  while (++j<=MAXNUMOFPARAMETERS)
  {
    if ((ST[j].PlotLHistogramm > 0) && (C[j].counts > 0))
    {
      k   = C[j].Offset;
      P1  = C[j].P[1];
      P2  = C[j].P[2];
      P13 = P1+C[j].P[3];
      P24 = P2+C[j].P[4];
      nl  = (int) xinpx(C[j].K[1],C[j].K[2],ST[j].Refline);
      if (nl < P1)  nl = P1;
      if (nl > P13) nl = P13;
        
      for (i=k+1;i<=k+C[j].counts;i++)
			{
        if ((Q[i].I > 0) && (PlotDataFlag(j,Q[i].F) == 1))
        {
          px  = (int) xinpx(C[j].K[1],C[j].K[2],Q[i].V);
       
					if (Q[i].I >= 0)
            py  = (int) yinpy(C[j].K[3],C[j].K[4],Q[Q[i].I].V);
          
          if (px < P1+1)   px = P1;
          if (px > P13-1)  px = P13;
          
          if ((py >= P2) && (py <= P24))
            CLinie(hdc,nl,py,px,py,ST[j].LineWidth*(int) F,ST[j].Color);
          else
					{
            if (py > P24) 
              i = k + C[j].counts + 1;
					}
        }
			}
    }

		if (++l >= gNumOfParameters)
			j = MAXNUMOFPARAMETERS;
	}

	SetDefaultMouseCursor();
}


// ***********************************************
// ***********************************************
// ***********************************************

void PlotHistogramLineH(HDC hdc, float F)
{
  unsigned long  i     = 0;    
  unsigned long  k     = 0;
  
  int   l     = 0;
	int		j			= 0;
  int   P1    = 0;
  int   P2    = 0;
  int   P13   = 0;
  int   P24   = 0;
  int   px    = 0;
  int   py    = 0;
	int   nl    = 0;		
  
  int   MSize      = 0;
  int   MLineWidth = 0;
		
// ***********************************************

  SetWaitMouseCursor();

  while (++j<=MAXNUMOFPARAMETERS)
  {
    if ((ST[j].PlotLHistogramm > 0) && (C[j].counts > 0))
    {
      k   = C[j].Offset;
      P1  = C[j].P[1];
      P2  = C[j].P[2];
      P13 = C[j].P[1]+C[j].P[3];
      P24 = C[j].P[2]+C[j].P[4];
      nl  = (int) yinpy(C[j].K[3],C[j].K[4],ST[j].Refline);
      if (nl > P2)  nl = P2;
      if (nl < P24) nl = P24;
        
      for (i=k+1;i<=k+C[j].counts;i++)
			{
        if ((Q[i].I > 0) && (PlotDataFlag(j,Q[i].F) == 1))
        {
          if (Q[i].I >= 0)
            px  = (int) xinpx(C[j].K[1],C[j].K[2],Q[Q[i].I].V);
       
					py  = (int) yinpy(C[j].K[3],C[j].K[4],Q[i].V);
          
          if (py > P2+1)   py = P2;
          if (py < P24+1)  py = P24;
          
          if ((px >= P1) && (px <= P13))
            CLinie(hdc,px,nl,px,py,ST[j].LineWidth*(int) F,ST[j].Color);
          else
					{
            if (px > P13) 
              i = k + C[j].counts + 1;
					}
        }  
			}
    }

		if (++l >= gNumOfParameters)
			j = MAXNUMOFPARAMETERS;
	}

	SetDefaultMouseCursor();
}

