/*********************************************************************
*                                                                    *
*     PlotLitho.c - Plot Litho                                       *
*                                                                    *
*     Programmautor: Rainer Sieger, Universitaet Bremen              *
*     Datei erstellt am: 14.04.98                                    *
*     Letzte Aenderung: 03.04.99                                     *
*                                                                    *
*********************************************************************/

#include <string.h>
#include <stdio.h>
#include <windows.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"

#include "SetMouseCursor.h"
#include "Plotter.h"
#include "SetPoint.h"
#include "PutText.h"
#include "Font.h"
#include "Graphic.h"

void PlotLithoV(HDC hdc)
{
  unsigned long  i     = 0;    
  unsigned long  k     = 0;

  int   BitmapNr	= 0;
  int   l					= 0;
	int   j					= 0;
  int   Group			= 0;
  int   P1				= 0;
  int   P2				= 0;
  int   P13				= 0;
  int   P24				= 0;
  int   px				= 0;
  int   py				= 0;
  int   pyo				= 0;
  int   pyu				= 0;
  int   nl				= 0;
    
// ***********************************************

	SetWaitMouseCursor();

  while (++j<=MAXNUMOFPARAMETERS)
  {
    if (ST[j].PlotLitho > 0) 
    {
      if (C[j].counts > 0)
			{	
				k		= C[j].Offset;
				P1  = C[j].P[1];
				P2  = C[j].P[2];
				P13 = P1+C[j].P[3];
				P24 = P2+C[j].P[4];
				pyo = P2;
        
				for (i=k+1;i<=k+C[j].counts;i++)
				{
					if (Q[i].I > 0)
					{
						pyu  = (int) yinpy(C[j].K[3],C[j].K[4],Q[Q[i].I].V);
						if ((P2 <= pyo) && (pyu <= P24) && (pyo < pyu))
						{
							CFillPatternRechteck(hdc,P1,pyo,P13,pyu,(int) Q[i].V);
						}
						else
						{
							if (pyu > P24) 
								i = k + C[j].counts + 1;
						}
						pyo = pyu;
					}
				}
			}
			else
			{
			  if (gNumOfComments > 0)
				{
					i = 0;
    			
					while (++i<=gNumOfComments)
    			{
						if (T[i].Parameter == j)
						{
							P1  = C[j].P[1];
							P2  = C[j].P[2];
							P13 = P1+C[j].P[3];
							P24 = P2+C[j].P[4];
							pyo = P2;
							i   = gNumOfComments;
						}
					}

					i = 0;
    			
					while (++i<=gNumOfComments)
					{
						if (T[i].Parameter == j)
						{
							pyu  = (int) yinpy(C[j].K[3],C[j].K[4],T[i].Depth);
					
							if ((P2 <= pyo) && (pyu <= P24) && (pyo < pyu))
							{
								k = 0;

								while (++k <= (unsigned long) gNumOfBitmaps)
								{
									if (!strcmp((char *) T[i].Text, (char *) BitPattern[k].Text))
									{
										BitmapNr = (int) k;
										k = (unsigned long) gNumOfBitmaps;
									}
								}

								CFillPatternRechteck(hdc,P1,pyo,P13,pyu,(int) BitmapNr);
							}
							else
							{
								if (pyu > P24) 
									i = gNumOfComments+1;
							}

							pyo = pyu;
						}
					}
   			}		
   		}	
    }

		if (++l >= gNumOfParameters)
			j = MAXNUMOFPARAMETERS;
	}

	SetDefaultMouseCursor();
}

// ***********************************************
// ***********************************************
// ***********************************************

void PlotLithoH(HDC hdc)
{
  unsigned long i = 0;    
  unsigned long k = 0;
  
  int   BitmapNr	= 0;
	int   l					= 0;
	int   j					= 0;
  int   P1				= 0;
  int   P2				= 0;
  int   P13				= 0;
  int   P24				= 0;
  int   px				= 0;
  int   py				= 0;
  int   pxl				= 0;
  int   pxr				= 0;
  int   nl				= 0;
		
// ***********************************************
    
	SetWaitMouseCursor();

	while (++j<=MAXNUMOFPARAMETERS)
  {
    if (ST[j].PlotLitho > 0)
    {
      if (C[j].counts > 0)
			{	
	      k   = C[j].Offset;
		    P1  = C[j].P[1];
			  P2  = C[j].P[2];
				P13 = C[j].P[1]+C[j].P[3];
	      P24 = C[j].P[2]+C[j].P[4];
				pxl = P1;
			
				for (i=k+1;i<=k+C[j].counts;i++)
				{
					if (Q[i].I > 0)
					{
						pxr = (int) xinpx(C[j].K[1],C[j].K[2],Q[Q[i].I].V);

						if ((P1 <= pxl) && (pxr <= P13) && (pxl < pxr))
						{
							CFillPatternRechteck(hdc,pxl,P24,pxr,P2,(int) Q[i].V);
						}
						else
						{
							if (pxr > P13) 
								i = k + C[j].counts + 1;
						}

						pxl = pxr;
					}          
				}
			}
			else
			{
			  if (gNumOfComments > 0)
				{
					i = 0;

    			while (++i<=gNumOfComments)
    			{
						if (T[i].Parameter == j)
						{
							P1  = C[j].P[1];
							P2  = C[j].P[2];
							P13 = P1+C[j].P[3];
							P24 = P2+C[j].P[4];
							pxl = P1;
							i   = gNumOfComments;
						}
					}

					i = 0;
    			
					while (++i<=gNumOfComments)
					{
						if (T[i].Parameter == j)
						{
							pxr = (int) xinpx(C[j].K[1],C[j].K[2],T[i].Depth);
							if ((P1 <= pxl) && (pxr <= P13) && (pxl < pxr))
							{
								k = 0;
					
								while (++k <= (unsigned long) gNumOfBitmaps)
								{
									if (!strcmp((char *) T[i].Text, (char *) BitPattern[k].Text))
									{
										BitmapNr = (int) k;
										k = (unsigned long) gNumOfBitmaps;
									}
								}

								CFillPatternRechteck(hdc,pxl,P24,pxr,P2,(int) BitmapNr);
							}
							else
							{
								if (pxr > P13) 
									i = gNumOfComments+1;
							}

							pxl = pxr;
						}
					}
				}
			}
    }

		if (++l >= gNumOfParameters)
			j = MAXNUMOFPARAMETERS;
	}

	SetDefaultMouseCursor();
}

