/*********************************************************************
*                                                                    *
*     PlotOccurrence.c - Plot Vorkommen                              *
*                                                                    *
*     Programmautor: Rainer Sieger, Alfred-Wegener-Institut          *
*     Datei erstellt am: 10.02.98                                    *
*     Letzte Aenderung: 30.05.2002                                   *
*     Macintosh                                                      *
*     Windows                                                        *
*                                                                    *
*********************************************************************/

#include <string.h>
#include <stdio.h>

#include <windows.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"

#include "SetMouseCursor.h"
#include "Plotter.h"
#include "SetPoint.h"
#include "PutText.h"
#include "Font.h"
#include "CalcValue.h"

void PlotOccurrenceV(HDC hdc, float F)
{
  unsigned long  i     = 0;    
  unsigned long  k     = 0;
  
  int   l     = 0;
	int		j			= 0;
  int   P1    = 0;
  int   P2    = 0;
  int   P24   = 0;
  int   px    = 0;
  int   py    = 0;
  
  int   MSize      = 0;
  int   MLineWidth = 0;
		
// ***********************************************
    
	SetWaitMouseCursor();

	while (++j<=MAXNUMOFPARAMETERS)
  {
    if ((ST[j].PlotOccurrence > 0) && (C[j].counts > 0))
    {
      MSize      = (int) F * ST[j].MSize; 
      MLineWidth = (int) F * ST[j].MLineWidth;

      P1  = C[j].P[1];
      P2  = C[j].P[2];
      px  = C[j].P[1]+C[j].P[3]/2;
      P24 = C[j].P[2]+C[j].P[4];
        
      k = C[j].Offset;
      
			for (i=k+1;i<=k+C[j].counts;i++)
			{
        if ((Q[i].I > 0) && (Q[i].V != 0.) && (PlotDataFlag(j,Q[i].F) == 1))
        {
          py = (int) yinpy(C[j].K[3],C[j].K[4],Q[Q[i].I].V);
          
          if (py == P2-1)  py = P2;
          if (py == P24+1) py = P24;
    
					if ((py >= P2) && (py <= P24))
            CPlotMarker(hdc,px,py,ST[j].Color,MSize,MLineWidth,ST[j].MSymbol);
          else
            if (py > P24) i = k + C[j].counts + 1;
        }  
			}
    }

		if (++l >= gNumOfParameters)
			j = MAXNUMOFPARAMETERS;
	}

	SetDefaultMouseCursor();
}

// ***********************************************
// ***********************************************
// ***********************************************

void PlotOccurrenceH(HDC hdc, float F)
{
  unsigned long  i     = 0;    
  unsigned long  k     = 0;
  
  int   l     = 0;
	int		j			= 0;
  int   P1    = 0;
  int   P2    = 0;
  int   P4    = 0;
	
  int   P13   = 0;
  int   P24   = 0;
  int   px    = 0;
  int   py    = 0;
  
  int   MSize      = 0;
  int   MLineWidth = 0;
		
// ***********************************************
    
	SetWaitMouseCursor();

	while (++j<=MAXNUMOFPARAMETERS)
  {
    if ((ST[j].PlotOccurrence > 0) && (C[j].counts > 0))
    {
      MSize      = (int) F * ST[j].MSize; 
      MLineWidth = (int) F * ST[j].MLineWidth;

      P1  = C[j].P[1];
    	P2  = C[j].P[2];
      P4  = C[j].P[4];
      P13 = C[j].P[1]+C[j].P[3];
      P24 = C[j].P[2]+C[j].P[4];            
      py = P2+P4/2;
      
      k = C[j].Offset;

			for (i=k+1;i<=k+C[j].counts;i++)
			{
        if ((Q[i].I > 0) && (Q[i].V != 0.) && (PlotDataFlag(j,Q[i].F) == 1))
        {
          px = (int) xinpx(C[j].K[1],C[j].K[2],Q[Q[i].I].V);
          
          if (px == P1-1)  px = P1;
          if (px == P13+1) px = P13;
    
					if ((px >= P1) && (px <= P13))
            CPlotMarker(hdc,px,py,ST[j].Color,MSize,MLineWidth,ST[j].MSymbol);
          else
            if (px > P13) 
              i = k + C[j].counts + 1;
        }  
			}
    }

		if (++l >= gNumOfParameters)
			j = MAXNUMOFPARAMETERS;
	}

	SetDefaultMouseCursor();
}

