/*********************************************************************
*                                                                    *
*     PlotT.c - Plot fuer Terdarstellung                             *
*                                                                    *
*     Programmautor: Rainer Sieger, Universitaet Bremen, SFB261      *
*     Datei erstellt am: 28.04.97                                    *
*     Letzte Aenderung: 03.04.99                                     *
*     Macintosh                                                      *
*     Windows                                                        *
*                                                                    *
*********************************************************************/

#define fiftyPercent 1

#include <math.h>
#include <windows.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"

#include "SetMouseCursor.h"
#include "Graphic.h"
#include "Plotter.h"

void PlotT(HDC hdc)
{
  unsigned long  	i     = 0;
  unsigned long  	k     = 0;
  unsigned long  	k1    = 0;
  unsigned long  	k2    = 0;
  unsigned long  	k3    = 0;

  int     j     = 0;
	int     l     = 0;

	int			l1, l2, l3, lend;
	
	int			g 		= 0;
	
	int     Ux    = 0;
	int 		Uy    = 0;
	int     b     = 0;
	int     h     = 0;

	int     px 		= 0;
	int			py 		= 0;

	int     x1    = 0;
	int     y1    = 0;
	int     x2    = 0;
	int     y2    = 0;
	
  int     GMSize     = 0;
  int     GLineWidth = 0;

  float   F   	= (float) 0.;
  
  float   P1    = (float) 0.;
  float   P2    = (float) 0.;
  float   P3    = (float) 0.;

  float   D     = (float) 0.;

	float   b2    = (float) 0.;		
	float   b100  = (float) 0.;
	float   h100  = (float) 0.;

	int			m[MAXNUMOFPARAMETERS + 1];
		
// ***********************************************

  SetWaitMouseCursor();

  F = (float) cxDpi/ScreenDpi;

	Ux    = C[0].P[1];
	Uy    = C[0].P[2];
	b     = C[0].P[3];
	h     = C[0].P[4];
	b2    = (float) b/(float) 2.;
	b100  = (float) b2/(float) 100.;
	h100  = (float) h/(float) 100.;

	l = TerIncrement;
	
	for (j=l;j<=100-l;j+=l)
	{
		x1 = (int) (((float) j)*b100 - (float) 0.*b100 + b2) + Ux;
		y1 = Uy - (int) (((float) 100.-((float) j))*h100);
		x2 = (int) (((float) j)*b100 - ((float) 100.-((float) j))*b100 + b2) + Ux;
		y2 = Uy - (int) ((float) 0.*h100);		
   	CLinie(hdc,x1,y1,x2,y2,ST[0].LineWidth*(int) F,ST[0].Color);
	}

	for (j=l;j<=100-l;j+=l)
	{
		x1 = (int) ((float) 0.*b100 - ((float) j)*b100 + b2) + Ux;
		y1 = Uy - (int) (((float) 100. - ((float) j))*h100);
		x2 = (int) (((float) 100.-((float) j))*b100 - ((float) j)*b100 + b2) + Ux;
		y2 = Uy - (int) ((float) 0.*h100);		
   	CLinie(hdc,x1,y1,x2,y2,ST[0].LineWidth*(int) F,ST[0].Color);
	}

	for (j=l;j<=100-l;j+=l)
	{
		x1 = (int) ((float) 0.*b100 - ((float) j)*b100 + b2) + Ux;
		y1 = Uy - (int) (((float) 100. - ((float) j))*h100);
		x2 = (int) (((float) j)*b100 - (float) 0.*b100 + b2) + Ux;
		y2 = y1;		
   	CLinie(hdc,x1,y1,x2,y2,ST[0].LineWidth*(int) F,ST[0].Color);
	}

	if (fiftyPercent)
	{
		x1 = (int) ((float) 50.*b100 + b2) + Ux;
		y1 = Uy - (int) ((float) 50.*h100);
		x2 = (int) (b2) + Ux;
		y2 = Uy;		
	  CLinie(hdc,x1,y1,x2,y2,ST[0].LineWidth*(int) F,BLACK);
		x1 = (int) (b2 - (float) 50.*b100) + Ux;
		y1 = Uy - (int) ((float) 50.*h100);
		x2 = (int) (b2) + Ux;
		y2 = Uy;		
	 	CLinie(hdc,x1,y1,x2,y2,ST[0].LineWidth*(int) F,BLACK);
		x1 = (int) (b2 - (float) 50.*b100) + Ux;
		y1 = Uy - (int) ((float) 50.*h100);
		x2 = (int) ((float) 50.*b100 + b2) + Ux;
		y2 = y1;		
	 	CLinie(hdc,x1,y1,x2,y2,ST[0].LineWidth*(int) F,BLACK);
  }	

  switch (SelectMode)
  {
   	case useGroups:
			l = 1;
		  for (j=1;j<=gNumOfGroups;j++)
		  {
		    if ((ST[j].GPlotData > 0) && (l+2 <= gNumOfParameters))
		    {
	        GMSize      = (int) F * ST[j].GMSize; 
	        GLineWidth  = (int) F * ST[j].GLineWidth;
		      k   = C[l].Offset;
	        k1  = C[l].Offset;
	        k2  = C[l+1].Offset;
	        k3  = C[l+2].Offset;
	        for (i=k+1;i<=k+C[l].counts;i++)
	        {
	          k1++; k2++; k3++;
	          if ((Q[k1].I > 0) && (Q[k2].I > 0) && (Q[k3].I > 0))
	          {
	            P1 = Q[k1].V;
	            P2 = Q[k2].V;
	            P3 = Q[k3].V;
		              
							if ((P1 >= 0) && (P2 >= 0) && (P3 >= 0))
							{
								D  = P1 + P2 + P3;
								if (fabs(D - (float) 100.) <= ST[j].GEpsilon)
								{
									P1 = P1/D*(float) 100.;
									P2 = P2/D*(float) 100.;
									P3 = P3/D*(float) 100.;
	            
									px = (int) (P3*b100 - P1*b100 + b2) + Ux;
									py = Uy - (int) (P2*h100);
		            
									CPlotMarker(hdc,px,py,ST[j].GColor,GMSize,1,ST[j].GMSymbol);
								}
							}
	          }
	        }   
		    }
				l += C[j].NumOfParametersInGroup;
			}
			break;
			
		case useParameters:	
			for (j=0;j<=MAXNUMOFPARAMETERS;j++)
				m[j] = 0;				
				
			for (j=1;j<=gNumOfParameters;j++)
			{
				if (ST[j].PlotData > 0)
					m[++m[0]] = j;						
				else
					m[++m[0]] = 0;						
			}
					
			g = 0;
			l = 1;
			while (l<=m[0])
			{
				g++;
				lend = l+C[g].NumOfParametersInGroup-1;
				l1	 = l;
				l2   = 1;
				l3	 = 1;

				while ((m[l1] < l) && (l1 < lend))
					l1++;
				if (l1 < lend)
				{
					l2 = l1+1;
					while ((m[l2] < l1) && (l2 < lend))
						l2++;
					if (l2 < lend)
					{
						l3 = l2+1;
						while ((m[l3] < l2) && (l3 <= lend))
							l3++;
						if (l3 <= lend)
						{
				      k  = C[m[l1]].Offset;
				      k1 = C[m[l1]].Offset;
						  k2 = C[m[l2]].Offset;
							k3 = C[m[l3]].Offset;

				      GMSize     = (int) F * ST[g].GMSize; 
				      GLineWidth = (int) F * ST[g].GLineWidth;
						  for (i=k+1;i<=k+C[0].counts;i++)
							{
		         		k1++; k2++; k3++;
								if ((Q[k1].I > 0) && (Q[k2].I > 0) && (Q[k3].I > 0))
								{
									P1 = Q[k1].V;
									P2 = Q[k2].V;
				          P3 = Q[k3].V;
		              
									if ((P1 >= 0) && (P2 >= 0) && (P3 >= 0))
									{
										D  = P1 + P2 + P3;
										if (fabs(D - (float) 100.) <= ST[g].GEpsilon)
										{
											P1 = P1/D*(float) 100.;
											P2 = P2/D*(float) 100.;
											P3 = P3/D*(float) 100.;
		            
											px = (int) (P3*b100 - P1*b100 + b2) + Ux;
											py = Uy - (int) (P2*h100);
		            
											CPlotMarker(hdc,px,py,ST[g].GColor,GMSize,1,ST[g].GMSymbol);
										}
									}
								}
							}
		        }   
					}
				}

				l+=C[g].NumOfParametersInGroup;
			}
			break;			

		default:
			break;
	}

// *********
// * FensterRahmen zeichnen
 
  CLinie(hdc,C[0].P[1],C[0].P[2],C[0].P[1]+C[0].P[3]/2,C[0].P[2]-C[0].P[4],KoorLineWidth*(int) F,BLACK);
 	CLinie(hdc,C[0].P[1]+C[0].P[3]/2,C[0].P[2]-C[0].P[4],C[0].P[1]+C[0].P[3],C[0].P[2],KoorLineWidth*(int) F,BLACK);
  CLinie(hdc,C[0].P[1]+C[0].P[3],C[0].P[2],C[0].P[1],C[0].P[2],KoorLineWidth*(int) F,BLACK);       	  	

	SetDefaultMouseCursor();
}

