/*********************************************************************
*                                                                    *
*     PrintRecord                                                    *
*                                                                    *
*     Programmautor: Rainer Sieger, Universitt Bremen			         *
*     Datei erstellt am: 13.11.96                                    *
*     Letzte Aenderung: 25.07.2000                                   *
*                                                                    *
*********************************************************************/

#include <windows.h>
#include <string.h>

#include "Struct.h"
#include "Globals.h"

#include "PrintTools.h"

// ------------------------------------------------------------------------------------------------
// InitPrinter intialisiert den Drucker.
// ------------------------------------------------------------------------------------------------

void InitPrinter(HWND hwnd)
{
  memset ((void *) &psd, 0, sizeof(PAGESETUPDLG));

  psd.lStructSize			= sizeof(PAGESETUPDLG);
  psd.hwndOwner				= hwnd;
  psd.hDevMode				= NULL;//GlobalAlloc(GHND, sizeof(DEVMODE));
  psd.hDevNames				= NULL;//GlobalAlloc(GHND, sizeof(DEVNAMES));
	psd.rtMargin.top		= 2500;
	psd.rtMargin.left   = 2500;
	psd.rtMargin.bottom = 2500;
	psd.rtMargin.right  = 2500;
  psd.Flags						= PSD_RETURNDEFAULT | PSD_MARGINS | PSD_INHUNDREDTHSOFMILLIMETERS;

	PageSetupDlg (&psd);

  return;
}

// *******************************************************************
// *******************************************************************
// *******************************************************************

HDC GetPrinterDC(PAGESETUPDLG psd)
{
  LPDEVNAMES pn = (LPDEVNAMES) 0;    
  
  pn = (LPDEVNAMES) GlobalLock(psd.hDevNames);   
  
  if (pn == (LPDEVNAMES) NULL) 
    return 0;     
    
  GlobalUnlock(psd.hDevNames); 	

	return(CreateDC(NULL, (LPTSTR) pn + pn->wDeviceOffset, NULL,NULL));
}	

// *******************************************************************
// *******************************************************************
// *******************************************************************

HDC GetDefaultPrinterDC(void)
{
	PRINTER_INFO_5	pinfo5[3];
	DWORD						dwNeeded, dwReturned;
	
	if (EnumPrinters(PRINTER_ENUM_DEFAULT, NULL, 5, (LPBYTE) pinfo5, sizeof(pinfo5), &dwNeeded, &dwReturned))
		return(CreateDC(NULL, pinfo5[0].pPrinterName, NULL,NULL));
			
	return 0;
}	
