/*********************************************************************
*                                                                    *
*     ReadData                                                       *
*                                                                    *
*     Programmautor: Rainer Sieger, Universitaet Bremen, SFB261      *
*     Datei erstellt am: 24.10.95                                    *
*     Letzte Aenderung: 08.01.2001                                   *
*                                                                    *
*********************************************************************/

#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "Struct.h"
#include "Globals.h"

#include "Dialog.h"
#include "Win_GUI.h"
#include "Window.h"
#include "FileSystem.h"
#include "Preferences.h"
#include "Templates.h"
#include "SetMouseCursor.h"
#include "CalcNumOfParameters.h"
#include "CalcNumOfGroups.h"
#include "ExtractHeader.h"
#include "ExtractData.h"
#include "Initialize.h"
#include "CheckData.h"
#include "ReadData.h"
#include "SplitHeader.h"
#include "TestMetadata.h"
#include "ChangeHeader.h"
#include "replaceStr.h"
#include "SetMinMax.h"

int ReadData(HWND hwnd)
{
	unsigned long i									= 0;
	unsigned long j									= 0;
	unsigned long k									= 0;

	unsigned long	maxNumOfDataLines	= 0;

	int			err											= 0;

	int     l												= 0;
	int     m												= 0;

	int     HeaderMode							= 0;
	int			Metadata  							= 1;
	int			EL											= 0;

	long					length						= 0;
	long					Clength						= 0;

	FILE          *fin  						= NULL;

	char          *p								= 0;
	char					No[5]							= "";
	Str4				  DDbegin						= "/*";
	Str4					DDend   					= "*/";
	Str4					DDDelim						= " *";
				
	StrFullName		Filename					= "";

	Str80					Group  						= "";
	Str80					Title							= "";
	Str80					Unit							= "";

	Str511				FirstGroup				= "";

	unsigned long Start 						= 0;
			
// ********************************************************************

	SetWaitMouseCursor();

	strcpy((char *) Filename, (char *) Path);
	strcat((char *) Filename, (char *) Name);

	memset((char *) HeaderStr1, (int) '\0', MAXNUMOFCHAR+1);
	memset((char *) HeaderStr2, (int) '\0', MAXNUMOFCHAR+1);

	for (i=0;i<=MAXNUMOFCOMMENTS;i++)
	{
		memset((char *) DataDescription[i].Title, (int) '\0', 32);
		memset((char *) DataDescription[i].Text, (int) '\0', MAXNUMOFCCHAR+1);
	}

	gNumOfLines = 0;
				
	if ((fin = openFile((char *) Filename, "rb")) != NULL)
	{
		while (Metadata)
		{
			if ((length = readFile(fin,HeaderStr2,MAXNUMOFCHAR)) < 0)
			{
				closeFile(fin);
				return(-2);
			}
			else
			{
				if (strstr((char *) HeaderStr2, (char *) DDbegin))
				{
					if (!strcmp((char *) HeaderStr2, "/* DATA DESCRIPTION:"))
					{
						if ((length = readFile(fin,HeaderStr2,MAXNUMOFCHAR)) < 0)
						{
							closeFile(fin);
							return(-2);
						}
					}

					gNumOfLines = 0;
						
					while (!strstr((char *) HeaderStr2, (char *) DDend))
					{
						if (++gNumOfLines > 1)
						{
							if ((length = readFile(fin,HeaderStr2,MAXNUMOFCHAR)) < 0)
							{
								closeFile(fin);
								return(-2);
							}
						}
						
						if (gNumOfLines <= MAXNUMOFCOMMENTS)
						{
							if ((p = strchr((char *) HeaderStr2, (int) '\t')) != NULL)
							{
								if ((length = (int) (p-HeaderStr2)) > 31)
									length = 31;

								strncpy((char *) DataDescription[gNumOfLines].Title, (char *) HeaderStr2, (unsigned int) length);

								if ((length = (long) strlen(p)) > MAXNUMOFCCHAR)
									length = MAXNUMOFCCHAR;

								strncpy((char *) DataDescription[gNumOfLines].Text,p+1,(unsigned int) length);				
							}
							else
							{
								if (strlen((char *) HeaderStr2) < 31)
									strncpy((char *) DataDescription[gNumOfLines].Title, (char *) HeaderStr2, 31);
								else	
									strncpy((char *) DataDescription[gNumOfLines].Text, (char *) HeaderStr2, MAXNUMOFCCHAR);
							}
						}
					}

					replaceStr((char *) DataDescription[1].Title, "/* ","");
					replaceStr((char *) DataDescription[gNumOfLines].Title, "*/","");
					
					replaceStr((char *) DataDescription[1].Text, "/* ","");
					replaceStr((char *) DataDescription[gNumOfLines].Text, "*/","");
					
					if ((strlen((char *) DataDescription[gNumOfLines].Title) < 1) && (strlen((char *) DataDescription[gNumOfLines].Text) < 1))
						gNumOfLines--;
						
					memset((char *) HeaderStr2, (int) '\0', MAXNUMOFCHAR+1);
				}

				if (TestMetadata(HeaderStr2))
					strcpy((char *) HeaderStr1, (char *) HeaderStr2);
				else
					Metadata = 0;
			}
		}

	// **************
	// First Event

		i = 0;

		while (++i<=MAXNUMOFCOMMENTS)				
		{
			if (!strcmp((char *) DataDescription[i].Title, "Event:"))
			{
				strcpy((char *) FirstGroup, (char *) DataDescription[i].Text);

				if ((p = strstr((char *) FirstGroup, (char *) DDDelim)))
				{
					p--;
					*p = '\0';
				}
			}
		}
		
	// **************
	// Anzahl der Parameter ermitteln

		if ((gNumOfParameters = CalcNumOfParameters(HeaderStr2)-1) <= 0)
		{
			closeFile(fin);
			SetDefaultMouseCursor();
			return(-2);
		} 
		else
		{
			if (gNumOfParameters > MAXNUMOFPARAMETERS)
			{
				err              = Do_Error_Dialog(hwnd,rMaxNumOfParametersOverflow,MAXNUMOFPARAMETERS);
 				gNumOfParameters = MAXNUMOFPARAMETERS;
			}

	// **************
	// Steuerparameter intialisieren

			InitD();
			InitST();

	// **************
	// Header zerlegen

			if (strlen(HeaderStr1) > 0)
				err = ExtractHeader(gNumOfParameters,HeaderStr1);

			err = ExtractHeader(gNumOfParameters,HeaderStr2);

			EL = ChangeHeader(gNumOfParameters);
			gNumOfParameters -= EL;

	// **************
	// Datenarray loeschen

			maxNumOfDataLines = (unsigned long) gMaxMData;
			maxNumOfDataLines = maxNumOfDataLines/((unsigned long) gNumOfParameters + 1);

			for (j=0;j<=(unsigned long) gNumOfParameters;j++)  
			{
				C[j].Offset      = j*maxNumOfDataLines;
				Q[C[j].Offset].I = 0;
			}    		

			maxNumOfDataLines -= 2;

			gNumOfComments = 0;		        

			for (j=0;j<=gMaxCData;j++)  
			{
				T[j].Parameter = 0;		        	
				T[j].Depth     = (float) -999.99;
				memset((char *) T[j].Text, (int) '\0', 81);		          
			}  
			    
	// **************
	// Daten einlesen

			i 				 = 0;
			DateOffset = (float) 0.;
	      
			while((length > 0) && (++i <= (unsigned long) maxNumOfDataLines))
			{
				length = readFile(fin,InputStr,MAXNUMOFCHAR);
				m      = ExtractData(gNumOfParameters,EL,i);

				if (m == -1)
					i--;
				else
   				C[0].counts++;
			}

			closeFile(fin);
		}  
	}
	else
	{
		SetDefaultMouseCursor();
		return(-1);  // Can't open file
	} 
	      
	if (C[0].counts >= maxNumOfDataLines)
		err = Do_Error_Dialog(hwnd,rMaxDataOverflow,maxNumOfDataLines);

	if (C[0].counts < 1)
	{
		SetDefaultMouseCursor();
		return(-2);
	}

	m						  = 1;
	GroupTitles   = 0;
	gNumOfGroups	= CalcNumOfGroups(gNumOfParameters);

	for (j=1;j<=(unsigned long) gNumOfParameters;j++)
	{
		ST[j].PlotGroupname = 0;
		SplitHeader((char *) C[j].Header, (char *) C[j].GroupName, (char *) Title, (char *) Unit); 

		if (strlen((char *) C[j].GroupName) > 0)
			GroupTitles++;
	}

	if ((GroupTitles == 0) && (strlen((char *) FirstGroup) > 0))
	{
		strcpy((char *) C[1].GroupName, (char *) FirstGroup);
		GroupTitles = 1;
	}
				  
	for (j=1;j<=(unsigned long) gNumOfGroups;j++)
	{
		ST[m].PlotGroupname = 1;
		m += C[j].NumOfParametersInGroup;
	}

	for (j=1;j<=(unsigned long) gNumOfParameters;j++)
	{
		if ((p = strchr((char *) C[j].Header, (int) '@')) != NULL)
			*p = '\0';

		if (strlen((char *) C[j].Header) == 0)
		{
			sprintf((char *) No, "%d", j);							
			strcpy((char *) C[j].Header, "Parameter ");
			strcat((char *) C[j].Header, (char *) No);
		}  
	}

	SetPreferences();

	if ((useTemplate == 1) && (C[0].counts > 1))
		err = LoadTemplates();
			
  if ((gNumOfParameters > 0) && (C[0].counts >= 1))
  {
    for (j=1;j<=(unsigned long) gNumOfParameters;j++)  
			ST[j].PlotParametername = 1;
	}
	
	if (GroupTitles > 0)
	{
		l = 0; j = 1; k = 1;

		while (++l<=gNumOfGroups)
		{
			j = k - 1;

			while (++j<=k+C[l].NumOfParametersInGroup-1)
			{
 				if ((ST[j].PlotData > 0))
				{  
          ST[j].PlotGroupname = 1;
					j = MAXNUMOFPARAMETERS;
				}
			}

			k += (unsigned long) C[l].NumOfParametersInGroup;

			if (AllInOne > 0)
				l = gNumOfGroups + 1;
		}
	}

	SetDefaultMouseCursor();

  return(gNumOfParameters);
}      

// ********************************************************************
// ********************************************************************
// ********************************************************************

int ReloadDataDescription(void)
{
	unsigned long i					= 0;
	unsigned long j					= 0;
	unsigned long k					= 0;

	int			err							= 0;

	int     l								= 0;
	int     m               = 0;


	long					length		= 0;

	FILE          *fin  		= NULL;

	char          *p				= 0;
	char					No[5]			= "";
				
	StrFullName		Filename	= "";
			
// ********************************************************************

	strcpy((char *) Filename, (char *) DDPath);
	strcat((char *) Filename, (char *) DDName);

	memset((char *) HeaderStr1, (int) '\0', MAXNUMOFCHAR+1);
	memset((char *) HeaderStr2, (int) '\0', MAXNUMOFCHAR+1);

	for (i=0;i<=MAXNUMOFCOMMENTS;i++)
	{
		memset((char *) DataDescription[i].Title, (int) '\0', 32);
		memset((char *) DataDescription[i].Text, (int) '\0', MAXNUMOFCCHAR+1);
	}

	gNumOfLines = 0;
				
  if ((fin = openFile((char *) Filename, "rb")) != NULL)
	{
		while ((length = readFile(fin,HeaderStr2,MAXNUMOFCHAR)) > 0)
		{
			if (++gNumOfLines <= MAXNUMOFCOMMENTS)
			{
				if ((p = strchr((char *) HeaderStr2, (int) '\t')) != NULL)
				{
					if ((length = (int) (p-HeaderStr2)) > 31)
						length = 31;

					strncpy((char *) DataDescription[gNumOfLines].Title,	(char *) HeaderStr2, (unsigned int) length);

					if ((length = (long) strlen(p)) > MAXNUMOFCCHAR)
						length = MAXNUMOFCCHAR;

					strncpy((char *) DataDescription[gNumOfLines].Text,p+1,(unsigned int) length);				
				}
				else
				{
					if (strlen((char *) HeaderStr2) < 31)
						strncpy((char *) DataDescription[gNumOfLines].Title, (char *) HeaderStr2, 31);
					else	
						strncpy((char *) DataDescription[gNumOfLines].Text, (char *) HeaderStr2, MAXNUMOFCCHAR);
				}
			}
		}

		replaceStr((char *) DataDescription[1].Title, "/* ","");
		replaceStr((char *) DataDescription[gNumOfLines].Title, "*/","");
		
		replaceStr((char *) DataDescription[1].Text, "/* ","");
		replaceStr((char *) DataDescription[gNumOfLines].Text, "*/","");
		
		if ((strlen((char *) DataDescription[gNumOfLines].Title) < 1) && (strlen((char *) DataDescription[gNumOfLines].Text) < 1))
			gNumOfLines--;
			
		closeFile(fin);
	}

	return(0);
}
