// SaveFile.c
// Dr. Rainer Sieger, Universitaet Bremen
// 23.04.2001 (Krankenhaus Seepark)

#include <windows.h>
#include <string.h>
#include <stdio.h>

#include "Struct.h"
#include "Globals.h"

#include "FileSystem.h"
#include "SetMouseCursor.h"
#include "SaveFile.h"

int SaveDataDescriptionFile(char *FilenameOut)
{
  FILE          *fout;
  
	int 					i							= 0;
	int						j							= 0;
	
// *******************************************************************

  if ((fout = openNewFile((char *) FilenameOut)) == NULL) 
		return(-1);  

 	for (i=1;i<=gNumOfLines;i++)
 	{
  	writeFile(fout,(char *) DataDescription[i].Title);
  	writeFile(fout,"\t");
  	writeFile(fout,(char *) DataDescription[i].Text);
  	writeFile(fout,"\n");
  }
  closeFile(fout);
  
  return(0);
}

// *******************************************************************
// *******************************************************************
// *******************************************************************

int SaveFile(char *FilenameIn, char *FilenameOut)
{
  FILE          *fin, *fout;
  
	int 					i							= 0;
	int						j							= 0;
	
// *******************************************************************

  if (!strcmp((char *) FilenameIn,(char *) FilenameOut))
		return(-1);

	if ((fin = openFile((char *) FilenameIn, "r")) == NULL) 
		return(-2);

	if ((fout = openNewFile((char *) FilenameOut)) == NULL) 
	{
		closeFile(fin);;
		return(-3);  
  }

// Data Description
	if (gNumOfLines > 0)
	{
  	writeFile(fout,"/* ");

		for (i=1;i<=gNumOfLines;i++)
  	{
	  	writeFile(fout,(char *) DataDescription[i].Title);
	  	writeFile(fout,"\t");
	  	writeFile(fout,(char *) DataDescription[i].Text);
	  	writeFile(fout,"\n");
	  }

		writeFile(fout,"*/\n");

		while(strcmp((char *) InputStr,"*/") != 0)
	  	readFile(fin,InputStr,MAXNUMOFCHAR);	  	
  }
  else
	{
  	writeFile(fout,"/* Data Description\n");
  	writeFile(fout,"*/\n");
	}  
  
// Groups  
  if (strlen((char *) C[1].GroupName) > 0)
  {
  	for (j=1;j<=gNumOfParameters;j++)
  	{
	  	writeFile(fout,"\t");
	  	writeFile(fout,(char *) C[j].GroupName);	
	  }

		writeFile(fout,"\n");
  	readFile(fin,InputStr,MAXNUMOFCHAR);	  	
	}
	  	
// Header	  	
 	writeFile(fout,(char *) C[0].Header);
 	writeFile(fout,"@");
 	writeFile(fout,(char *) Copyrighttext);

	for (j=1;j<=gNumOfParameters;j++)
 	{
  	writeFile(fout,"\t");
  	writeFile(fout,(char *) C[j].Header);
  }

	writeFile(fout,"\n");
 	readFile(fin,InputStr,MAXNUMOFCHAR);	  	

// Data
  SetWaitMouseCursor();    

	while(readFile(fin,InputStr,MAXNUMOFCHAR) > 0L)
  {
    writeFile(fout,InputStr);
    writeFile(fout,"\n");
  }  

	SetDefaultMouseCursor();

	closeFile(fin);
  closeFile(fout);
  
  return(0);
}


