/*********************************************************************
*                                                                    *
*     SetPositionV.c                                                 *
*     Bildschirmkoordinaten der einzelnen Plots (14.9.95)            *
*                                                                    *
*     Programmautor: Rainer Sieger, Universitaet Bremen              *
*     Datei erstellt am: 13.11.95                                    *
*     Letzte Aenderung: 05.01.2001                                   *
*                                                                    *
*********************************************************************/

#include <windows.h>
#include <string.h>
#include <stdio.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Ezfont.h"

#include "SplitHeader.h"
#include "Plotter.h"
#include "Font.h"
#include "floattostr.h"
#include "PutText.h"

int SetPositionV(HDC hdc)
{
	int     i										= 0;
	int     j										= 0;
	int     l										= 1;

	int     t_border						= 0;
	int     b_border						= 0;
	int     l_border						= 0;
	int     r_border						= 0;

	int     P1									= 0;
	int			P2									= 0;
	int     P3									= 0;
	int			P4									= 0;

	int     maxj								= 0;

	int     NumOfUnfixedPar     = 0;
	int			fixedParameterWidth = 0;		
	int     ParameterWidth			= 0;
	int			Scale									= 0;

	float   F										= (float) 0.;
	float		length							= 0;
	float		maxlength						= 0;
	      
	Str31   Text								= "";
	Str31   minText							= "";
	Str31   maxText							= "";
	Str31   CmaxText						= "";

	Str80   Group								= "";
	Str80   Title								= "";
	Str80   Unit								= "";
	Str255  Header							= "";

// *****************************************************************************
// *****************************************************************************

	if (gSelectedNumOfParameters < 1)
		return(0);

// *****************************************************************************

	F	= (float) cxDpi/ScreenDpi;

// *****************************************************************************

  SetFont(hdc,(char *) Font,FontSize,NORMAL,0);

// *****************************************************************************

	j = 0; l = 1;			

	while (++j<=MAXNUMOFPARAMETERS)  
	{
		if (ST[j].PlotData > 0)
		{
			if (ST[j].fixedParameterWidth < 1)
				NumOfUnfixedPar++;
			else
				fixedParameterWidth += ST[j].ParameterWidth;

			if (ST[j].ParameterTextOrientation != 0)
			{
				SplitHeader((char *) C[j].Header, (char *) Group, (char *) Title, (char *) Unit);
				strcpy((char *) Header, (char *) Title);
				strcat((char *) Header, " ");
				strcat((char *) Header, (char *) Unit);
				length = (float) CalcTextWidth(hdc, (char *) Header,0,(int) strlen((char *) Header));

				if (ST[j].ParameterTextOrientation == 45)
					length = length/(float) 1.3;

				if (length > maxlength)
				{
					maxlength = length;
					maxj			= j;
				}
			}

			if (++l > gSelectedNumOfParameters)
			{
				sprintf((char *) CmaxText,(char *) ST[j].FormatStr,ST[j].max);
				strcat((char *) CmaxText,"W");
				j = MAXNUMOFPARAMETERS + 1;
			}
		}
	}
			
// *****************************************************************************

	Scale = CalcScale();
 	SetFont(hdc,(char *) Font,FontSize+2,BOLD,0);
	GroupTitleHeight = FontHeight(hdc);

 	SetFont(hdc,(char *) Font,FontSize,BOLD,0);
 	xTitleHeight  = FontHeight(hdc);
 	yTitleHeight  = FontHeight(hdc);

  SetFont(hdc,(char *) Font,FontSize,NORMAL,0);
 	xUnitHeight   = FontHeight(hdc);

 	SetFont(hdc,(char *) Font,FontSize-2,NORMAL,0);
	xValueHeight  = FontHeight(hdc);
	yValueHeight  = FontHeight(hdc);
  yUnitHeight   = FontHeight(hdc);
 	InfoHeight    = FontHeight(hdc);
	HxValueHeight = FontHeight(hdc)/2;

 	SetFont(hdc,(char *) Font,FontSize-4,NORMAL,0);
 	CopyrightHeight = FontHeight(hdc);

// *****************************************************************************
// calculate l_border = first window position      

	SetFont(hdc,(char *) Font,FontSize-2,NORMAL,0);

	if ((!isDate) && (!isTime))
	{
		sprintf((char *) Text,(char *) ST[0].FormatStr,ST[0].min);
		xValueWidth = CalcTextWidth(hdc, (char *) Text,0,(int) strlen((char *) Text));			
		sprintf((char *) Text,(char *) ST[0].FormatStr,ST[0].max);
		l_border = CalcTextWidth(hdc, (char *) Text,0,(int) strlen((char *) Text));

		if (l_border > xValueWidth)
			xValueWidth = l_border;
	}		
	else
	{
		if (isDate)
		{
			sprintf((char *) Text," 1997-06-26");
			xValueWidth = CalcTextWidth(hdc, (char *) Text,0,(int) strlen((char *) Text));			
		}	

		if (isTime)
		{
			sprintf((char *) Text," 14:25:58");
			xValueWidth = CalcTextWidth(hdc, (char *) Text,0,(int) strlen((char *) Text));			
		}

		if ((isDate) && (isTime))
		{
			sprintf((char *) Text," 1997-06-26 14:25:58");
			xValueWidth = CalcTextWidth(hdc, (char *) Text,0,(int) strlen((char *) Text));			
		}
	}

	l_border = RLT + xTitleHeight + 2*ATE + xValueWidth + 2*ATE + MSL;

// *****************************************************************************
// calculate r_border = last window position      

	r_border = CalcTextWidth(hdc, (char *) CmaxText,0,(int) strlen((char *) CmaxText))/2;
	if (r_border < RRT) 
		r_border = RRT;

// *****************************************************************************
// calculate t_border      

	if (maxj > 0)
	{
		if (GroupTitles > 0)
			t_border = ROT + GroupTitleHeight + ATE+ (int) maxlength + ATE + yUnitHeight + ATE + MSL;
		else
			t_border = ROT + (int) maxlength + ATE + yUnitHeight + ATE + 2*MSL;
	}
	else
	{
		if (GroupTitles > 0)
	  	t_border = ROT + GroupTitleHeight + ATE + yTitleHeight + ATE + yUnitHeight + ATE + yValueHeight + MSL;
		else
			t_border = ROT                          + yTitleHeight + ATE + yUnitHeight + ATE + yValueHeight + ATE + 2*MSL;
	}


// *****************************************************************************
// calculate b_border

  b_border = RUT + 2*xTitleHeight;

// *****************************************************************************

	if ((WindowOffset > 0) || (AllInOne == 1))
	{
		j = 0; l = 0;			

		while (++j<=MAXNUMOFPARAMETERS)  
		{
			if (ST[j].PlotData > 0)
			{
		    if (++l >= gSelectedNumOfParameters)
				{
					floattostr(ST[j].max,(char *) ST[j].FormatStr,(char *) CmaxText);
	        j = MAXNUMOFPARAMETERS + 1;
				}
			}
		}
  }                    
      
// *****************************************************************************
// Set positions

	if ((NumOfUnfixedPar > 0) && (AllInOne == 0))
	{
		ParameterWidth  = gDataPlotWindowWidth - fixedParameterWidth - l_border - r_border - WindowOffset*(int) F*(gSelectedNumOfParameters-1);
		ParameterWidth /= NumOfUnfixedPar;

		if (ParameterWidth < 0)
			ParameterWidth = 0;
	}

	if (AllInOne == 1)
		ParameterWidth = gDataPlotWindowWidth - l_border - r_border;

	P1 = l_border;
	P2 = t_border;
	P3 = ParameterWidth + WindowOffset*(int) F;

	if (ST[0].fixedParameterWidth < 1)
		P4 = gDataPlotWindowHeight - t_border - b_border - Scale;
	else
		P4 = ST[0].ParameterWidth;

	j  = 0; l  = 1;			

	while (++j<=MAXNUMOFPARAMETERS)  
	{
		if (ST[j].PlotData > 0) 
		{
			if (AllInOne == 1)
			{
				C[j].P[1]  = P1;
			  C[j].P[2]  = P2;
				C[j].P[3]  = ParameterWidth;
 	    	C[j].P[4]  = P4; 
			}
			else
			{
				if (ST[j].fixedParameterWidth < 1)
				{
					C[j].P[1]  = P1;
				  C[j].P[2]  = P2;
					C[j].P[3]  = ParameterWidth;
   	    	C[j].P[4]  = P4; 
					P1				+= P3;
				}
				else
				{
					C[j].P[1]  = P1;
					C[j].P[2]  = P2;
        	C[j].P[3]  = ST[j].ParameterWidth;
   	    	C[j].P[4]  = P4; 
					P1        += ST[j].ParameterWidth + WindowOffset*(int) F;
				}
			}

			if (++l > gSelectedNumOfParameters)
		    j = MAXNUMOFPARAMETERS + 1;
		}    
	}

	SplitHeader((char *) C[0].Header, (char *) Group, (char *) Title, (char *) Unit); 

  SetFont(hdc,(char *) Font,FontSize,BOLD,0);
  xTitleWidth = CalcTextWidth(hdc, (char *) Title,0,(int) strlen((char *) Title));

  SetFont(hdc,(char *) Font,FontSize,NORMAL,0);
  xUnitWidth = CalcTextWidth(hdc, (char *) Unit,0,(int) strlen((char *) Unit));

  BlankWidth = CalcTextWidth(hdc," ",0,1);

  return(FontSize);
}
      