/*********************************************************************
*                                                                    *
*     Templates                                                      *
*                                                                    *
*     Programmautor: Rainer Sieger, Universitaet Bremen, SFB261      *
*     Datei erstellt am: 24.10.95                                    *
*     Letzte Aenderung: 18.07.2001                                   *
*     Macintosh                                                      *
*     Windows                                                        *
*                                                                    *
*********************************************************************/
      
#include <windows.h>
#include <ctype.h>
#include <stdio.h>
#include <string.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "FileSystem.h"
#include "Color.h"
#include "CheckData.h"
#include "Templates.h"
#include "Version.h"
#include "replaceStr.h"
#include "SetMouseCursor.h"

/*********************************************************************
**********************************************************************
*********************************************************************/
      
int LoadTemplates(void)
{ 
	int     			i     = 0;
	int     			j     = 0;
	int     			n     = 0;
	int						dummy = 0;

	int     			iDummy[20];
	float   			fDummy[20];
	char    			sDummy[20];

	char    			*p;
	FILE    			*fin;

/*--------------------------------------------*/

	SetWaitMouseCursor();

	if ((fin = openFile((char *) TFullName, "rb")) == NULL)
		return(0);
     
// ******
// Zeile H1 einlesen

	if (readFile(fin,InputStr,80) == 0L)  
		return(-3);

	if (strcmp((char *) InputStr, (char *) Version))
	{
		closeFile(fin);
		return(-2);
	}

// ******
// Zeile H2 einlesen (VersionNr)

	if (readFile(fin,InputStr,80) == 0L)  
		return(-1);

	if ((p = strstr((char *) InputStr, "Version")) == NULL)
		strcpy((char *) InputStr, " unknown");     

	if ((p = strchr((char *) InputStr, (int) ' ')) != NULL)
		strcpy((char *) TemplateVersion, p+1);     
     
// ******
// Zeile H3 einlesen (Font)

	if (readFile(fin,(char *) InputStr,80) == 0)  
		return(-3);
	else
	{
		replaceStr((char *) InputStr,"Font: ","");
		memset ((char *) Font, (int) '\0', 32);
		strncpy((char *) Font,(char *) InputStr,31);
	}	
	 
// ******
// Zeile H4 einlesen (Copyrighttext)

	if (readFile(fin,(char *) InputStr,255) == 0)  
		return(-3);
	else
	{
		replaceStr((char *) InputStr,"Copyrighttext: ","");
		memset ((char *) Copyrighttext, (int) '\0', 256);
		strncpy((char *) Copyrighttext,(char *) InputStr,255);
	}	

// ******
// Zeile H5 einlesen (global options)

	if (readFile(fin,InputStr,80) == 0L)  
	{
		closeFile(fin);
		return(-4);
	}

	i = 1;
	if ((p = strchr(InputStr, (int) '\t')) != NULL)
	{
 		if ((p-InputStr) > 0)
			sscanf(InputStr, "%d", &iDummy[i++]); 
	}

	while (p != NULL)
	{
		strcpy(InputStr,p+1);
	
		if ((p = strchr(InputStr, (int) '\t')) != NULL)
		{
 	 		if ((p-InputStr) > 0)
				sscanf(InputStr, "%d", &iDummy[i++]); 
		}

		if (i > 5)
		{
			closeFile(fin);
			return(-5);
		}
	}

	if (strlen((char *) InputStr) > 0)
		sscanf(InputStr, "%d", &iDummy[i]); 
	  
	Mode  				= iDummy[1]; 	 	 
	useColor      = iDummy[2];
	AllInOne      = iDummy[3];
	ClipCoorSys   = iDummy[4];
	KoorLineWidth = iDummy[5];
   
// ******
// Zeile H6 einlesen (global options)

	if (readFile(fin,InputStr,80) == 0L)  
	{
		closeFile(fin);
		return(-6);
	}

	i = 1;

	if ((p = strchr(InputStr, (int) '\t')) != NULL)
	{
 		if ((p-InputStr) > 0)
			sscanf(InputStr, "%d", &iDummy[i++]); 
	}

	while (p != NULL)
	{
		strcpy(InputStr,p+1);

		if ((p = strchr(InputStr, (int) '\t')) != NULL)
		{
			if ((p-InputStr) > 0)
				sscanf(InputStr, "%d", &iDummy[i++]); 
		}

		if (i > 15)
		{
			closeFile(fin);
			return(-7);
		}
	}

	if (strlen((char *) InputStr) > 0)
		sscanf(InputStr, "%d", &iDummy[i]); 
	  
	useTemplate               = iDummy[1];
	gSelectedNumOfParameters  = iDummy[2]; 
	gDataPlotWindowWidth      = iDummy[3]; 
	gDataPlotWindowHeight     = iDummy[4]; 
	WindowOffset              = iDummy[5]; 
	PlotAbsoluteScale         = iDummy[6];
	TerIncrement              = iDummy[7];
	FontSize                  = iDummy[8];
	GFontSize                 = iDummy[9];
	GroupDistance             = iDummy[10];
	SelectMode                = iDummy[11];
	CRDateTime                = iDummy[12];
	CRFilename                = iDummy[13];
	UnitFormat                = iDummy[14];
	TextOrientation			 			= iDummy[15];
	 
// ******
// Parameter
     
  j = -1;

	while(++j <= gNumOfParameters)
  {

// ******
// 1. Zeile einlesen

		if (readFile(fin,InputStr,80) == 0L)  
		{
			closeFile(fin);
			return(-8);
		}

		if (strlen((char *) InputStr) > 1)
			sscanf(InputStr, "%s %d", sDummy, &iDummy[0]); 

		if (readFile(fin,(char *) InputStr,MAXNUMOFCHAR) == 0L)  
		{
			closeFile(fin);
			return(-8);
		}
		else
		{
			replaceStr((char *) InputStr,"Name: ","");
			memset ((char *) C[iDummy[0]].Header, (int) '\0', 81);
			strncpy((char *) C[iDummy[0]].Header,(char *) InputStr,80);
		}	

		if (readFile(fin,(char *) InputStr,MAXNUMOFCHAR) == 0L)  
		{
			closeFile(fin);
			return(-8);
		}
		else
		{
			replaceStr((char *) InputStr,"Groupname: ","");
			memset ((char *) C[iDummy[0]].GroupName, (int) '\0', 81);
			strncpy((char *) C[iDummy[0]].GroupName,(char *) InputStr,80);
		}	

  	if (readFile(fin,(char *) InputStr,MAXNUMOFCHAR) == 0L)  
	 	{
			closeFile(fin);
			return(-8);
		}
		else
		{
			replaceStr((char *) InputStr,"Format: ","");
	   	memset ((char *) ST[iDummy[0]].FormatStr, (int) '\0', 31);
	   	strncpy((char *) ST[iDummy[0]].FormatStr,(char *) InputStr,32);
	 	}	

      
// ******
// 2. Zeile einlesen

    if (readFile(fin,InputStr,80) == 0L)  
	 	{
			closeFile(fin);
			return(-9);
		}

    if (strlen((char *) InputStr) > 1)
    {
      j = iDummy[0];

			if ((p = strchr(InputStr, (int) '\t')) != NULL)
			{
	 		  if ((p-InputStr) > 0)
          sscanf(InputStr, "%hu", &Color[j].red); 
			}

      while (p != NULL)
      {
        strcpy(InputStr,p+1);

        if ((p = strchr(InputStr, (int) '\t')) != NULL)
				{
					if ((p-InputStr) > 0)
            sscanf(InputStr, "%hu", &Color[j].green); 
				}
      }
  
      if (strlen((char *) InputStr) > 0)
        sscanf(InputStr, "%hu", &Color[j].blue); 
    }
      
// ******
// 3. Zeile einlesen

    if (readFile(fin,InputStr,80) == 0L)  
	 	{
			closeFile(fin);
			return(-10);
		}

    if (strlen((char *) InputStr) > 1)
    {
      i = 1;

      if ((p = strchr(InputStr, (int) '\t')) != NULL)
			{
	 		  if ((p-InputStr) > 0)
          sscanf(InputStr, "%d", &iDummy[i++]); 
			}

      while (p != NULL)
      {
        strcpy(InputStr,p+1);

        if ((p = strchr(InputStr, (int) '\t')) != NULL)
				{
					if ((p-InputStr) > 0)
            sscanf(InputStr, "%d", &iDummy[i++]); 
				}
      }
  
      if (strlen((char *) InputStr) > 0)
        sscanf(InputStr, "%d", &iDummy[i]); 
       
      j                      	= iDummy[0];
      ST[j].PlotData         	= iDummy[1];
      ST[j].PlotMarker       	= iDummy[2];
      ST[j].PlotLine         	= iDummy[3];
      ST[j].PlotCHistogramm  	= iDummy[4];
      ST[j].PlotLHistogramm  	= iDummy[5];
      ST[j].PlotOHistogramm  	= iDummy[6];
		  ST[j].PlotText         	= iDummy[7];
		  ST[j].PlotOccurrence	 	= iDummy[8];
		  ST[j].PlotCourse  		 	= iDummy[9];
		  ST[j].PlotComment 		 	= iDummy[10];
		  ST[j].PlotLitho   	   	= iDummy[11];
      ST[j].PlotParametername	= iDummy[12];
      ST[j].PlotGroupname			= iDummy[13];
		  ST[j].PlotBounds   	   	= iDummy[14];
      ST[j].LineWidth        	= iDummy[15];
    }
      
// ******
// 4. Zeile einlesen

    if (readFile(fin,InputStr,80) == 0L)  
	 	{
			closeFile(fin);
			return(-11);
		}

    if (strlen((char *) InputStr) > 1)
    {
      i = 1;

			if ((p = strchr(InputStr, (int) '\t')) != NULL)
			{
			  if ((p-InputStr) > 0)
          sscanf(InputStr, "%d", &iDummy[i++]); 
			}

      while (p != NULL)
      {
        strcpy(InputStr,p+1);

        if ((p = strchr(InputStr, (int) '\t')) != NULL)
				{
					if ((p-InputStr) > 0)
            sscanf(InputStr, "%d", &iDummy[i++]); 
				}
      }
  
      if (strlen((char *) InputStr) > 0)
        sscanf(InputStr, "%d", &iDummy[i]); 
      
      j                         = iDummy[0];
      ST[j].fixedParameterWidth = iDummy[1];
      ST[j].ParameterWidth      = iDummy[2];
      ST[j].AddNext             = iDummy[3];
      ST[j].Colorize            = iDummy[4];
      ST[j].ShowValid	          = iDummy[5];
      ST[j].ShowNotValid        = iDummy[6];
      ST[j].ShowUnknown         = iDummy[7];
      ST[j].ShowQuestionable    = iDummy[8];
      ST[j].ShowMissingData     = iDummy[9];
    }
      
// ******
// 5. Zeile einlesen

    if (readFile(fin,InputStr,80) == 0L)  
	 	{
			closeFile(fin);
			return(-12);
		}

    if (strlen((char *) InputStr) > 1)
    {
      i = 1;

			if ((p = strchr(InputStr, (int) '\t')) != NULL)
			{
	 		  if ((p-InputStr) > 0)
          sscanf(InputStr, "%d", &iDummy[i++]); 
			}

      while (p != NULL)
      {
        strcpy(InputStr,p+1);

        if ((p = strchr(InputStr, (int) '\t')) != NULL)
				{
					if ((p-InputStr) > 0)
            sscanf(InputStr, "%d", &iDummy[i++]); 
				}
      }
  
      if (strlen((char *) InputStr) > 0)
        sscanf(InputStr, "%d", &iDummy[i]); 
      
      j																= iDummy[0];
      ST[j].BothSide									= iDummy[1];
      ST[j].Inside										= iDummy[2];
      ST[j].ParameterTextOrientation	= iDummy[3];
      ST[j].MSymbol										= iDummy[4];
      ST[j].MSize											= iDummy[5];
    }
      
// ******
// 6. Zeile einlesen

    if (readFile(fin,InputStr,80) == 0L)  
	 	{
			closeFile(fin);
			return(-13);
		}

    if (strlen((char *) InputStr) > 1)
    {
      i = 1;
      if ((p = strchr(InputStr, (int) '\t')) != NULL)
			{
				if ((p-InputStr) > 0)
          sscanf(InputStr, "%d", &iDummy[i++]); 
			}

      while (p != NULL)
      {
        strcpy(InputStr,p+1);
      
				if ((p = strchr(InputStr, (int) '\t')) != NULL)
				{
					if ((p-InputStr) > 0)
            sscanf(InputStr, "%d", &iDummy[i++]); 
				}
      }
  
      if (strlen((char *) InputStr) > 0)
        sscanf(InputStr, "%d", &iDummy[i]); 
      
      j                      = iDummy[0];
      ST[j].Minor_Ticks      = iDummy[1];
      ST[j].Tickline         = iDummy[2];
      ST[j].Minor_Tickline   = iDummy[3];
      ST[j].ColumnWidth      = iDummy[4];
      ST[j].SetDefaultRange  = iDummy[5];
    }

// ******
// 7. Zeile einlesen

    if (readFile(fin,InputStr,80) == 0L)  
	 	{
			closeFile(fin);
			return(-14);
		}

    if (strlen((char *) InputStr) > 1)
    {
      i = 1;

			if ((p = strchr(InputStr, (int) '\t')) != NULL)
			{
		    if ((p-InputStr) > 0)
          sscanf(InputStr, "%d", &iDummy[i++]); 
			}

      while (p != NULL)
      {
        strcpy(InputStr,p+1);

        if ((p = strchr(InputStr, (int) '\t')) != NULL)
				{
					if ((p-InputStr) > 0)
            sscanf(InputStr, "%d", &iDummy[i++]); 
				}
      }
  
      if (strlen((char *) InputStr) > 0)
        sscanf(InputStr, "%d", &iDummy[i]); 
      
      j                 = iDummy[0];
			ST[j].GPlotData		= iDummy[1];
			ST[j].GMSymbol		= iDummy[2];
			ST[j].GMSize			= iDummy[3];
			ST[j].GLineWidth  = iDummy[4];
		}

// ******
// 8. Zeile einlesen

    if (readFile(fin,InputStr,80) == 0L)  
	 	{
			closeFile(fin);
			return(-15);
		}

    if (strlen((char *) InputStr) > 1)
    {
      j = iDummy[0];

			if ((p = strchr(InputStr, (int) '\t')) != NULL)
			{
	  	  if ((p-InputStr) > 0)
          sscanf(InputStr, "%hu", &GColor[j].red); 
			}
  
      while (p != NULL)
      {
        strcpy(InputStr,p+1);

        if ((p = strchr(InputStr, (int) '\t')) != NULL)
				{
					if ((p-InputStr) > 0)
            sscanf(InputStr, "%hu", &GColor[j].green); 
				}
      }
  
      if (strlen((char *) InputStr) > 0)
        sscanf(InputStr, "%hu", &GColor[j].blue); 
    }
      

// ******
// 9. Zeile einlesen

    if (readFile(fin,InputStr,80) == 0L)  
	 	{
			closeFile(fin);
			return(-16);
		}

    if (strlen((char *) InputStr) > 1)
    {
      i = 1;

			if ((p = strchr(InputStr, (int) '\t')) != NULL)
			{
			  if ((p-InputStr) > 0)
          sscanf(InputStr, "%f", &fDummy[i++]); 
			}

      while (p != NULL)
      {
        strcpy(InputStr,p+1);

        if ((p = strchr(InputStr, (int) '\t')) != NULL)
				{
					if ((p-InputStr) > 0)
            sscanf(InputStr, "%f", &fDummy[i++]); 
				}
      }
  
      if (strlen((char *) InputStr) > 0)
        sscanf(InputStr, "%d", &iDummy[i]); 
      
      j                     = iDummy[0];
      ST[j].min             = fDummy[1];
      ST[j].max             = fDummy[2];
			ST[j].GRange          = fDummy[3];
			ST[j].ReverseRange		= iDummy[4];
    }
      
// ******
// 10. Zeile einlesen

    if (readFile(fin,InputStr,80) == 0L)  
	 	{
			closeFile(fin);
			return(-17);
		}

    if (strlen((char *) InputStr) > 1)
    {
      i = 1;

			if ((p = strchr(InputStr, (int) '\t')) != NULL)
			{
			  if ((p-InputStr) > 0)
          sscanf(InputStr, "%f", &fDummy[i++]); 
			}

      while (p != NULL)
      {
        strcpy(InputStr,p+1);

        if ((p = strchr(InputStr, (int) '\t')) != NULL)
				{
					if ((p-InputStr) > 0)
            sscanf(InputStr, "%f", &fDummy[i++]); 
				}
      }
  
      if (strlen((char *) InputStr) > 0)
        sscanf(InputStr, "%f", &fDummy[i]); 
      
      j                     = iDummy[0];
      ST[j].Refline         = fDummy[1];
      ST[j].Tick_Increment  = fDummy[2];
    }

  }    

	closeFile(fin);

	if (UnitFormat == 1)
	{
		for (j=0;j<=gNumOfParameters;j++)
		{
			replaceStr((char *) C[j].Header,"[","(");
			replaceStr((char *) C[j].Header,"]",")");
		}
	}
	else
	{
		for (j=0;j<=gNumOfParameters;j++)
		{
			replaceStr((char *) C[j].Header,"(","[");
			replaceStr((char *) C[j].Header,")","]");
		}
	}

	for (j=gNumOfParameters+1;j<=MAXNUMOFPARAMETERS;j++)
		ST[j].PlotData = 0;
	  
	if ((useColor) && (useDefaultColor))
		SetColor(MAXNUMOFPARAMETERS,Color,GColor,DColor,set);
	else  
		SetBlack ();

	SetDefaultMouseCursor();
	
	return(0);
}      
      
/*********************************************************************
**********************************************************************
*********************************************************************/

int SaveTemplates(void)
{      
  FILE          *fout;

  OSErr        	err   = 0;
  int           j			= 0;

  Str4     			Dummy = "";

// *******************************************************************

  SetWaitMouseCursor();

  if ((fout = openNewFile((char *) TFullName)) != NULL)
  {
  	sprintf(TempStr,"%s\n",									Version);																																					writeFile(fout,TempStr); // version number																														   // H1   
  	sprintf(TempStr,"Version: %s\n",				VersionNr);																																				writeFile(fout,TempStr); // H2   
		sprintf(TempStr,"Font: %s\n",						Font);																																						writeFile(fout,TempStr); // Font
  	sprintf(TempStr,"Copyrighttext: %s\n",	Copyrighttext);																																		writeFile(fout,TempStr); // Copyrighttext														   // H2
    sprintf(TempStr,"%d\t%d\t%d\t%d\t%d\n",	Mode,useColor,AllInOne,ClipCoorSys,KoorLineWidth);																writeFile(fout,TempStr);			   // H3
    sprintf(TempStr,"%d\t%d\t%d\t%d\t",			useTemplate,gSelectedNumOfParameters,gDataPlotWindowWidth,gDataPlotWindowHeight); writeFile(fout,TempStr);
    sprintf(TempStr,"%d\t%d\t%d\t",					WindowOffset,PlotAbsoluteScale,TerIncrement);																			writeFile(fout,TempStr);
    sprintf(TempStr,"%d\t%d\t%d\t%d\t",			FontSize,GFontSize,GroupDistance,SelectMode);																			writeFile(fout,TempStr);
    sprintf(TempStr,"%d\t%d\t%d\t%d\n",			CRDateTime,CRFilename,UnitFormat,TextOrientation);																writeFile(fout,TempStr);        // H4
    
    for (j=0;j<=MAXNUMOFPARAMETERS;j++)
    {
      	sprintf(TempStr,"Parameter: %d\n",	j);								writeFile(fout,TempStr);																					//  1.
      	sprintf(TempStr,"Name: %s\n",				C[j].Header);			writeFile(fout,TempStr);																					//  1.
      	sprintf(TempStr,"Groupname: %s\n",	C[j].GroupName);	writeFile(fout,TempStr);																					//  1.
      	sprintf(TempStr,"Format: %s\n",			ST[j].FormatStr); writeFile(fout,TempStr);																					//  1.
		    
        sprintf(TempStr,"%hu\t",			ST[j].Color.red);				writeFile(fout,TempStr);
        sprintf(TempStr,"%hu\t",			ST[j].Color.green);			writeFile(fout,TempStr);
				sprintf(TempStr,"%hu\n",			ST[j].Color.blue);			writeFile(fout,TempStr);																					//  2.
        
        sprintf(TempStr,"%d\t%d\t", 	ST[j].PlotData,					ST[j].PlotMarker); writeFile(fout,TempStr);
        sprintf(TempStr,"%d\t%d\t", 	ST[j].PlotLine,					ST[j].PlotCHistogramm);	writeFile(fout,TempStr);
        sprintf(TempStr,"%d\t%d\t",		ST[j].PlotLHistogramm, 	ST[j].PlotOHistogramm); writeFile(fout,TempStr);
		    sprintf(TempStr,"%d\t%d\t", 	ST[j].PlotText,					ST[j].PlotOccurrence); writeFile(fout,TempStr);
		    sprintf(TempStr,"%d\t", 	    ST[j].PlotCourse);			writeFile(fout,TempStr);
		    sprintf(TempStr,"%d\t%d\t",		ST[j].PlotComment,			ST[j].PlotLitho);	writeFile(fout,TempStr);
		    sprintf(TempStr,"%d\t%d\t",		ST[j].PlotParametername,ST[j].PlotGroupname);	writeFile(fout,TempStr);
		    sprintf(TempStr,"%d\t%d\n",		ST[j].PlotBounds,				ST[j].LineWidth);	writeFile(fout,TempStr);		  	//  3.
        
        sprintf(TempStr,"%d\t%d\t",		ST[j].fixedParameterWidth, ST[j].ParameterWidth); writeFile(fout,TempStr);
        sprintf(TempStr,"%d\t%d\t",		ST[j].AddNext,					ST[j].Colorize); writeFile(fout,TempStr);
        sprintf(TempStr,"%d\t%d\t",		ST[j].ShowValid,				ST[j].ShowNotValid); writeFile(fout,TempStr);				//  4.
        sprintf(TempStr,"%d\t%d\t",		ST[j].ShowUnknown,			ST[j].ShowQuestionable); writeFile(fout,TempStr);				//  4.
        sprintf(TempStr,"%d\n",		    ST[j].ShowMissingData); writeFile(fout,TempStr);				//  4.
        
        sprintf(TempStr,"%d\t%d\t",		ST[j].BothSide,					ST[j].Inside); writeFile(fout,TempStr); 
        sprintf(TempStr,"%d\t",				ST[j].ParameterTextOrientation); writeFile(fout,TempStr); 
        sprintf(TempStr,"%d\t%d\n",		ST[j].MSymbol,					ST[j].MSize); writeFile(fout,TempStr); 						//  5.
        
        sprintf(TempStr,"%d\t%d\t",		ST[j].Minor_Ticks,			ST[j].Tickline); writeFile(fout,TempStr);
        sprintf(TempStr,"%d\t%d\t",		ST[j].Minor_Tickline,		ST[j].ColumnWidth); writeFile(fout,TempStr);
        sprintf(TempStr,"%d\n",				ST[j].SetDefaultRange); writeFile(fout,TempStr);		    						//  6.
  				
				sprintf(TempStr,"%d\t%d\t",		ST[j].GPlotData,				ST[j].GMSymbol); writeFile(fout,TempStr);					//  7.
				sprintf(TempStr,"%d\t%d\n",		ST[j].GMSize,						ST[j].GLineWidth); writeFile(fout,TempStr);

        sprintf(TempStr,"%hu\t",			ST[j].GColor.red); writeFile(fout,TempStr);
        sprintf(TempStr,"%hu\t%hu\n",	ST[j].GColor.green, ST[j].GColor.blue);	writeFile(fout,TempStr);					//  8.

        sprintf(TempStr,"%f\t%f\t",		ST[j].min,							ST[j].max);	writeFile(fout,TempStr);							//  9.
				sprintf(TempStr,"%f\t%d\n",		ST[j].GRange,						ST[j].ReverseRange); writeFile(fout,TempStr);
        
        sprintf(TempStr,"%f\t%f\n",		ST[j].Refline,					ST[j].Tick_Increment); writeFile(fout,TempStr);		// 10.
    }

		closeFile(fout);

		SetDefaultMouseCursor();

		return(0);
  }
	else
	{
		SetDefaultMouseCursor();
		return(-1);
	}
}  
