/* Dr. Rainer Sieger, AWI Bremerhaven        /
/  letztes Editierdatum: 24.04.2001         */

#include <string.h>

#include <windows.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Ezfont.h"
#include "Font.h"
#include "FindGroup.h"
#include "Plotter.h"
#include "PutText.h"
#include "SplitHeader.h"

void WriteParameterNameH(HDC hdc, int Scale)
{
	int			j								= 0;
	int     k								= 0;
	int			l								= 0;

	int			length					= 0;

	int			vpos						= 0;
	int			hpos						= 0;

	int			GroupTitleWidth = 0;
	int			TitleWidth			= 0;
	int			UnitWidth				= 0;

	Str80   Group						= "";
	Str80   Title						= "";
	Str80   Unit						= "";
			      
// *******************************************************************

	if (GroupTitles > 0)
	{
		l = 0; j = 0;

		while (++j<=gNumOfParameters)
		{
 			if (ST[j].PlotData > 0)
			{
				SplitHeader((char *) C[j].Header, (char *) Group, (char *) Title, (char *) Unit); 

				if (ST[j].PlotGroupname > 0)
				{
					if (ST[j].ParameterTextOrientation == 90)
					{
						SetFont(hdc,(char *) Font,FontSize+2,BOLD,90);
						GroupTitleWidth = CalcTextWidth(hdc, (char *) C[j].GroupName,0,(int) strlen((char *) C[j].GroupName));
						PutTextR(hdc,(char *) C[j].GroupName, RLT, C[j].P[2]+C[j].P[4]/2+GroupTitleWidth/2,0,LEFT);
					}
					else
					{
						SetFont(hdc,(char *) Font,FontSize+2,BOLD,0);
						PutText(hdc,(char *) C[j].GroupName, RLT, C[j].P[2]+C[j].P[4]-GroupTitleHeight/2,GroupTitleHeight,LEFT);
					}
				}

				if (ST[j].ParameterTextOrientation == 90)
				{
					SetFont(hdc,(char *) Font,FontSize,BOLD,90);
					yTitleWidth = CalcTextWidth(hdc, (char *) Title,0,(int) strlen((char *) Title));			
					hpos = C[j].P[1] - Scale - 2*ATE - yValueWidth - 2*ATE - yUnitHeight - ATE - yTitleHeight;
					vpos = C[j].P[2]+C[j].P[4]/2 + yTitleWidth/2;
					PutTextR(hdc,(char *) Title, hpos, vpos,0,LEFT);

					if (strlen((char *) Unit) > 2)
					{
						SetFont(hdc,(char *) Font,FontSize-2,NORMAL,90);
						yUnitWidth = CalcTextWidth(hdc, (char *) Unit,0,(int) strlen((char *) Unit));			
						hpos += yTitleHeight + ATE;
						vpos = C[j].P[2]+C[j].P[4]/2 + yUnitWidth/2;
						PutTextR(hdc,(char *) Unit,hpos,vpos,0,LEFT);
					}
				}
				else
				{
					SetFont(hdc,(char *) Font,FontSize,NORMAL,0);
					strcat((char *) Title," "); strcat((char *) Title,(char *) Unit);

					if ((length = (int) strlen((char *) Title)) > 1)
						PutText(hdc,(char *) Title, RLT, C[j].P[2]+C[j].P[4]+yTitleHeight,yTitleHeight,LEFT);
				}

				if (++l > gSelectedNumOfParameters) 
					j = MAXNUMOFPARAMETERS;

				if (AllInOne > 0)
					j = MAXNUMOFPARAMETERS;
			}
		}
	}
	else  // GroupsTitle = 0
	{
		while (++j<=gNumOfParameters)
		{
			if (ST[j].PlotData > 0)
			{
				SplitHeader((char *) C[j].Header, (char *) Group, (char *) Title, (char *) Unit); 

				if (ST[j].ParameterTextOrientation == 90)
				{
					hpos = C[j].P[1] - Scale - 2*ATE - yValueWidth - 2*ATE - yUnitHeight - ATE - yTitleHeight;
					SetFont(hdc,(char *) Font,FontSize,BOLD,90);
					yTitleWidth = CalcTextWidth(hdc, (char *) Title,0,(int) strlen((char *) Title));			
					vpos = C[j].P[2]+C[j].P[4]/2 + yTitleWidth/2;
					PutTextR(hdc,(char *) Title, hpos, vpos,0,LEFT);

					if (strlen((char *) Unit) > 2)
					{
						hpos += yTitleHeight + ATE;
						SetFont(hdc,(char *) Font,FontSize-2,NORMAL,90);
						yUnitWidth = CalcTextWidth(hdc,(char *) Unit,0,(int) strlen((char *) Unit));			
						vpos = C[j].P[2]+C[j].P[4]/2 + yUnitWidth/2;
						PutTextR(hdc,(char *) Unit,hpos,vpos,0,LEFT);
					}
				}
				else
				{
					SetFont(hdc,(char *) Font,FontSize,NORMAL,0);
					strcat((char *) Title," "); strcat((char *) Title,(char *) Unit);

					if ((length = (int) strlen((char *) Title)) > 1)
						PutText(hdc,(char *) Title, RLT, C[j].P[2]+C[j].P[4]+yTitleHeight,yTitleHeight,LEFT);
				}

				if (AllInOne > 0)
					j = MAXNUMOFPARAMETERS;

				if (++l > gSelectedNumOfParameters) 
					j = MAXNUMOFPARAMETERS;
			}
		}
	}
}



