/* Dr. Rainer Sieger, Universitaet Bremen   /
/  letztes Editierdatum: 20.01.2001        */

#include <windows.h>
#include <string.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Ezfont.h"

#include "Font.h"
#include "SetMouseCursor.h"
#include "Graphic.h"
#include "Plotter.h"
#include "PutText.h"
#include "SplitHeader.h"

void WriteParameterNameT(HDC hdc)
{
	int			i				= 0;			
	int			j       = 0;
	int			k				= 1;
	int     l       = 0;
	int			g				= 0;			
	int			d				= 0;
	int			l1, l2, l3, lend;

	int     px, py;

	int			m[MAXNUMOFPARAMETERS + 1];

	int     GMSize							 = 0;
	int     GLineWidth					 = 0;
	int     Abstand							 = 0;

	float   F   	= (float) 0.;

	Str80   Group  = "";
	Str80   Title   = "";
	Str80   Unit = "";

	Str255  NewGroupName = "";			
			
// *******************************************************************
			
	F = (float) cxDpi/ScreenDpi;

	SetFont(hdc,(char *) Font,GFontSize,NORMAL,0);
	memset((char  *) TempStr, '\0', MAXNUMOFCHAR+1);				

	d = CRFilename + 2*CRDateTime;

	switch (d)
	{
		case 1:
			strcat((char  *) TempStr, " ");
			strcat((char  *) TempStr, (char *) strCRFilename);
			break;

		case 2:
			strcat((char  *) TempStr, " ");
			strcat((char  *) TempStr, (char *) strCRDateTime);
			break;

		case 3:
			strcat((char  *) TempStr, " ");
			strcat((char  *) TempStr, (char *) strCRFilename);
			strcat((char  *) TempStr, " - ");
			strcat((char  *) TempStr, (char *) strCRDateTime);

		default:
			break;
	}		

	PutText(hdc,(char *) TempStr,C[0].P[1]+C[0].P[3]/2,C[0].P[2]+(int)((float) 3.*xTitleHeight),xTitleHeight,CENTER);

	SetFont(hdc,(char *) Font,GFontSize,BOLD,0);  

	switch (SelectMode)
	{
		case useGroups:
			SplitHeader((char *) C[1].Header, (char *) Group, (char *) Title, (char *) Unit); 
			PutText(hdc,(char *) Title,C[0].P[1],C[0].P[2]+2*xTitleHeight,xTitleHeight,LEFT);
			SplitHeader((char *) C[2].Header, (char *) Group, (char *) Title, (char *) Unit); 
			PutText(hdc,(char *) Title,C[0].P[1]+C[0].P[3]/2,C[0].P[2]-C[0].P[4]-xTitleHeight,xTitleHeight,CENTER);
			SplitHeader((char *) C[3].Header, (char *) Group, (char *) Title, (char *) Unit); 
			PutText(hdc,(char *) Title,C[0].P[1]+C[0].P[3],C[0].P[2]+2*xTitleHeight,xTitleHeight,RIGHT);
			SetFont(hdc,(char *) Font,GFontSize,NORMAL,0);
	
			for(j=1;j<=gNumOfGroups;j++)
			{
				px = C[0].P[1]+C[0].P[3]+2*RLT;
				py = C[0].P[2]-C[0].P[4]+(int) ((float) 1.3*(float) (j*xTitleHeight));
				GMSize     = (int) F * ST[j].GMSize; 
				GLineWidth = (int) F * ST[j].GLineWidth;

				Abstand = xTitleHeight/2 - (int) F;

				PutText(hdc,(char *) C[k].GroupName,px+5*Abstand,py,xTitleHeight,LEFT);
				k += C[j].NumOfParametersInGroup;

				if (ST[j].GPlotData > 0)
					CPlotMarker(hdc,px+3*Abstand,py-xTitleHeight/2,ST[j].GColor,3,1,ST[j].GMSymbol);			
			}  
			break;
			
		case useParameters:	
			for (j=0;j<=MAXNUMOFPARAMETERS;j++)
				m[j] = 0;				
			
			for (j=1;j<=gNumOfParameters;j++)
			{
				if (ST[j].PlotData > 0)
					m[++m[0]] = j;						
				else
					m[++m[0]] = 0;						
			}
			
			lend = C[1].NumOfParametersInGroup;
			l1	 = 1;
			l2   = 1;

			while ((m[l1] < 1) && (l1 < lend))
				l1++;

			if (l1 < lend)
			{
		 		SplitHeader((char *) C[m[l1]].Header, (char *) Group, (char *) Title, (char *) Unit); 
				PutText(hdc,(char *) Title,C[0].P[1],C[0].P[2]+2*xTitleHeight,xTitleHeight,LEFT);

				l2 = l1+1;

				while ((m[l2] < l1) && (l2 <= lend))
					l2++;

				if (l2 <= lend)
				{
					SplitHeader((char *) C[m[l2]].Header, (char *) Group, (char *) Title, (char *) Unit); 
					PutText(hdc,(char *) Title,C[0].P[1]+C[0].P[3]/2,C[0].P[2]-C[0].P[4]-xTitleHeight,xTitleHeight,CENTER);

					l3 = l2+1;

					while ((m[l3] < l2) && (l3 <= lend))
							l3++;

					if (l3 <= lend)
					{
						SplitHeader((char *) C[m[l3]].Header, (char *) Group, (char *) Title, (char *) Unit); 
						PutText(hdc,(char *) Title,C[0].P[1]+C[0].P[3],C[0].P[2]+2*xTitleHeight,xTitleHeight,RIGHT);
					}
					else
					{
						PutText(hdc,"????",C[0].P[1]+C[0].P[3],C[0].P[2]+2*xTitleHeight,xTitleHeight,RIGHT);
					}
				}
				else
				{
					PutText(hdc,"????",C[0].P[1]+C[0].P[3],C[0].P[2]+2*xTitleHeight,xTitleHeight,RIGHT);
					PutText(hdc,"????",C[0].P[1]+C[0].P[3],C[0].P[2]+2*xTitleHeight,xTitleHeight,RIGHT);
				}
			}

			SetFont(hdc,(char *) Font,GFontSize,NORMAL,0);

			g = 0;
			l = 1;

			while (l<=m[0])
			{
				g++;

				if ((g <= gNumOfGroups) && (C[g].NumOfParametersInGroup >= 3))
				{
					px = C[0].P[1]+C[0].P[3]+2*RLT;
					py = C[0].P[2]-C[0].P[4]+(int) ((float) 1.3 * (float) (g*xTitleHeight));
					GMSize     = (int) F * ST[g].GMSize; 
					GLineWidth = (int) F * ST[g].GLineWidth;

					Abstand = xTitleHeight/2 - (int) F;

					lend = l+C[g].NumOfParametersInGroup-1;
					l1	 = l;
					l2   = 1;

					while ((m[l1] < l) && (l1 < lend))
						l1++;

					if (l1 < lend)
					{
			 			SplitHeader((char *) C[m[l1]].Header, (char *) Group, (char *) Title, (char *) Unit); 
						strcpy((char *) NewGroupName,(char *) Title);			        
						strcat((char *) NewGroupName," | ");			        

						l2 = l1+1;

						while ((m[l2] < l1) && (l2 <= lend))
							l2++;

						if (l2 <= lend)
						{
			 				SplitHeader((char *) C[m[l2]].Header, (char *) Group, (char *) Title, (char *) Unit); 
							strcat((char *) NewGroupName,(char *) Title);			        
							strcat((char *) NewGroupName," | ");			        

							l3 = l2+1;

							while ((m[l3] < l2) && (l2 <= lend))
								l3++;

							if (l3 <= lend)
							{
			 					SplitHeader((char *) C[m[l3]].Header, (char *) Group, (char *) Title, (char *) Unit); 
								strcat((char *) NewGroupName,(char *) Title);			        
								PutText(hdc,(char *) NewGroupName,px+5*Abstand,py,xTitleHeight,LEFT);
	        			CPlotMarker(hdc,px+3*Abstand,py-xTitleHeight/2,ST[g].GColor,3,1,ST[g].GMSymbol);		
							}
							else
							{
								strcat((char *) NewGroupName,"????");			        
								PutText(hdc,(char *) NewGroupName,px+5*Abstand,py,xTitleHeight,LEFT);
							}
						}
						else
						{
							strcat((char *) NewGroupName,"???? | ????");			        
							PutText(hdc,(char *) NewGroupName,px+5*Abstand,py,xTitleHeight,LEFT);
						}
					}
				}

				l+=C[g].NumOfParametersInGroup;
			}  
			break;

		default:
			break;
	}

	if (GFontSize < 12)			
		SetFont(hdc,(char *) Font,6,NORMAL,0);
	else
		SetFont(hdc,(char *) Font,GFontSize-6,NORMAL,0);

	PutText(hdc,(char *) Copyrighttext,px+3*Abstand,C[0].P[2]+(int)((float) 3.*xTitleHeight),xTitleHeight,LEFT);
}

