/* Dr. Rainer Sieger, Universitaet Bremen   /
/  letztes Editierdatum: 11.09.2007        */

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <string.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Ezfont.h"

#include "floattostr.h"
#include "PutText.h"
#include "Font.h"
#include "Graphic.h"
#include "Plotter.h"
#include "ForeColor.h"
#include "Julday.h"

void XSkalierungH(HDC hdc, int Scale)
{
	int		PlotScale		= 1;
	int   MinorScale  = 0;
	int		length			= 0;

	int   i						= 0;
	int   j						= 0;
	int   k						= 0;
	int   l						= 0;

	int   px					= 0;
	int   py					= 0;

	int		t1          = 0;
	int   t2          = 0;

	int		vpos				= 0;

	int   P24					= 0;
	int   pyo					= 0;
	int   pyu					= 0;
				
	int		t						= 0;

	int		i_TextWidth	= 0;
	int		i_px_min		= 0;
	int		i_px_max		= 0;
	int   i_px_line   = 0;
	int		i_Distance	= 2;

	float dst					= (float) 1.;
	float dx					= (float) 0.;
	float dy					= (float) 0.;
	      
	float F						= (float) 0.;
	float Smin				= (float) 0.;
	float	f_Value			= (float) 0.;

	Str31 s_Value     = "";

	Str31 StrDate 		= "";
	Str31 StrTime 		= "";
      
// ********************************************************************
      
	F = (float) cxDpi/ScreenDpi;

	SetFont(hdc,(char *) Font,FontSize-2,NORMAL,0);

	MinorScale = Scale/2;

	vpos = C[0].P[2] + Scale + ATE + xValueHeight;

	for (j=1;j<=gNumOfParameters;j++)
	{
		if (ST[j].PlotData > 0)
		{
			if (++l > gSelectedNumOfParameters) 
				return;

			dx				= C[j].S[2] - C[j].S[1];
			Smin			= C[j].S[1];
      i_px_min	= C[j].P[1];
      i_px_max	= C[j].P[1] + C[j].P[3];

 			if (ST[0].Tick_Increment != 0)
			{
	      t			= (int) (dx/ST[0].Tick_Increment + 0.1);
				dst		= ST[0].Tick_Increment/(float) (ST[0].Minor_Ticks+1);
			}

// *****************************************
// Tick lines

			if (ST[0].Tickline > 0)
      {
        for (i=1; i<=t; i++)
        {
					f_Value	= Smin+(float) i*ST[0].Tick_Increment;
					px			= (int) xinpx( C[j].K[1], C[j].K[2], f_Value );

					if ( ( i_px_min < px ) && ( px < i_px_max ) )
						CLinie( hdc, px, C[j].P[2], px, C[j].P[2]+C[j].P[4], ST[0].LineWidth*(int) F, ST[0].Color);
				}
			}
	    
// *****************************************
// Minor tick lines

			if (ST[0].Minor_Tickline > 0)
      {
				for (i=0; i<=t; i++)
				{
					f_Value	= Smin+(float) i*ST[0].Tick_Increment;
					
					for (k=1; k<=ST[0].Minor_Ticks; k++)
					{
						px = (int) xinpx( C[j].K[1], C[j].K[2], f_Value+(float) k*dst );
						
						if ( ( i_px_min < px ) && ( px < i_px_max ) )
							CLinie( hdc, px, C[j].P[2], px, C[j].P[2]+C[j].P[4], ST[0].LineWidth*(int) F, ST[0].Color);
					}
				}
      }

// *****************************************
// Ticks

			if (ST[0].Inside > 0)
				py = C[j].P[2] - Scale;
			else   
				py = C[j].P[2] + Scale;
		    
      for (i=0; i<=t; i++)
      {
				f_Value	= Smin+(float) i*ST[0].Tick_Increment;
        px			= (int) xinpx( C[j].K[1], C[j].K[2], f_Value );

				if (abs(px-i_px_min) < 4)
          px = i_px_min;
        
				if (abs(px-i_px_max) < 4)
          px = i_px_max;

				if ( ( i_px_min <= px ) && ( px <= i_px_max ) )
					CLinie( hdc, px, C[j].P[2], px, py, ST[0].LineWidth*(int) F, BLACK );
      }

// *****************************************
// Minor ticks

      if (ST[0].Inside > 0)
        py = C[j].P[2] - (MinorScale);
      else   
        py = C[j].P[2] + (MinorScale);

      for (i=0; i<=t; i++)
      {
				f_Value	= Smin+(float) i*ST[0].Tick_Increment;
				
				for (k=1; k<=ST[0].Minor_Ticks; k++)
				{
					px = (int) xinpx( C[j].K[1], C[j].K[2], f_Value+(float) k*dst );
	
					if ( ( i_px_min <= px ) && ( px <= i_px_max ) )
						CLinie( hdc, px, C[j].P[2], px, py, ST[0].LineWidth*(int) F, BLACK );
				}
      }

// *****************************************
// Other side

			if (ST[0].BothSide > 0)
			{
				P24 = C[j].P[2] + C[j].P[4];

// Ticks
				if (ST[0].Inside > 0)
					py = P24 + Scale;
				else   
					py = P24 - Scale;

				for (i=0; i<=t; i++)
				{
					f_Value	= Smin+(float) i*ST[0].Tick_Increment;
					px			= (int) xinpx( C[j].K[1], C[j].K[2], f_Value );

					if (abs(px-i_px_min) < 4)
						px = i_px_min;
	        
					if (abs(px-i_px_max) < 4)
						px = i_px_max;

					if ( ( i_px_min <= px ) && ( px <= i_px_max ) )
						CLinie(hdc,px,py,px,P24,ST[0].LineWidth*(int) F,BLACK);
				}

// Minor ticks
				if (ST[0].Inside > 0)
					py = P24 + (MinorScale);
				else   
					py = P24 - (MinorScale);

				for (i=0; i<=t; i++)
				{
					f_Value	= Smin+(float) i*ST[0].Tick_Increment;
					
					for (k=1; k<=ST[0].Minor_Ticks; k++)
					{
						px = (int) xinpx( C[j].K[1], C[j].K[2], f_Value+(float) k*dst );
		
						if ( ( i_px_min <= px ) && ( px <= i_px_max ) )
							CLinie(hdc,px,py,px,P24,ST[0].LineWidth*(int) F,BLACK);
					}
				}
			}

// *****************************************
// Reference line

			i_px_line	= (int) xinpx(C[j].K[1],C[j].K[2],ST[0].Refline);
      
      if ( ( i_px_min < i_px_line ) && ( i_px_line < i_px_max ) )
        CLinie( hdc, i_px_line, C[j].P[2], i_px_line, C[j].P[2]+C[j].P[4], KoorLineWidth*(int) F, BLACK );

// *****************************************
// Text

			if (l == gSelectedNumOfParameters)
			{
				if ( ST[0].ReverseRange == 0 )
				{
					if ((!isDate) && (!isTime))
						floattostr(C[j].S[1],(char *) ST[0].FormatStr,(char *) s_Value);
					else
						CreateDateTimeStr(C[j].S[1], (char *) s_Value, dx);

					t1 = CalcTextWidth(hdc, (char *) s_Value, 0, (int) strlen((char *) s_Value));			
					i_px_min = C[j].P[1] + 1 + t1 + i_Distance;

					PutText(hdc,(char *) s_Value,C[j].P[1]+1,vpos,yValueHeight,LEFT);
		
					if ((!isDate) && (!isTime))
						floattostr(C[j].S[2],(char *) ST[0].FormatStr,(char *) s_Value);
					else
						CreateDateTimeStr(C[j].S[2], (char *) s_Value, dx);

					t2 = CalcTextWidth(hdc, (char *) s_Value, 0, (int) strlen((char *) s_Value));			
					i_px_max = C[j].P[1] + C[j].P[3] - 1 - t2 - i_Distance;
		
					if ( C[j].P[3] > (t1+t2+2*i_Distance) )
						PutText(hdc,(char *) s_Value,C[j].P[1]+C[j].P[3]-1,vpos,yValueHeight,RIGHT);
				}
				else
				{
					if ((!isDate) && (!isTime))
						floattostr(C[j].S[2],(char *) ST[0].FormatStr,(char *) s_Value);
					else
						CreateDateTimeStr(C[j].S[2], (char *) s_Value, dx);

					t1 = CalcTextWidth(hdc, (char *) s_Value, 0, (int) strlen((char *) s_Value));			
					i_px_min = C[j].P[1] + 1 + t1 + i_Distance;

					PutText(hdc,(char *) s_Value,C[j].P[1]+1,vpos,yValueHeight,LEFT);

					if ((!isDate) && (!isTime))
						floattostr(C[j].S[1],(char *) ST[0].FormatStr,(char *) s_Value);
					else
						CreateDateTimeStr(C[j].S[1], (char *) s_Value, dx);

					t2 = CalcTextWidth(hdc, (char *) s_Value, 0, (int) strlen((char *) s_Value));			
					i_px_max = C[j].P[1] + C[j].P[3] - 1 - t2 - i_Distance;

					if ( C[j].P[3] > (t1+t2+2*i_Distance) )
						PutText(hdc,(char *) s_Value,C[j].P[1]+C[j].P[3]-2,vpos,yValueHeight,RIGHT);
				}
      
				if ( C[j].P[3] > (i_px_max-i_px_min) )
				{
					for (i=1; i<=t-1; i++)
					{
						f_Value	= Smin+(float) i*ST[0].Tick_Increment;
						px			= (int) xinpx( C[j].K[1], C[j].K[2], f_Value );

						if ((!isDate) && (!isTime))
							floattostr(f_Value,(char *) ST[0].FormatStr,(char *) s_Value);
						else
							CreateDateTimeStr(f_Value, (char *) s_Value, dx);
						
						i_TextWidth = CalcTextWidth(hdc, (char *) s_Value, 0, (int) strlen((char *) s_Value));			
						
						if ( ( i_px_min < px-i_TextWidth/2-i_Distance ) && ( px+i_TextWidth/2+i_Distance < i_px_max ) )
						{
							if ( ST[0].ReverseRange == 0 )
								i_px_min = px + i_TextWidth/2 + i_Distance;
							else
								i_px_max = px - i_TextWidth/2 - i_Distance;

							PutText(hdc,(char *) s_Value, px, vpos, yValueHeight, CENTER);
						}
					}
				}
			}
		}
	}
}
