/* Dr. Rainer Sieger, AWI Bremerhaven       /
/  letztes Editierdatum: 07.10.2007        */

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <string.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Ezfont.h"

#include "floattostr.h"
#include "PutText.h"
#include "Graphic.h"
#include "Plotter.h"
#include "Font.h"
#include "CheckData.h"
#include "ForeColor.h"
#include "JulDay.h"

void XSkalierungV(HDC hdc, int Scale)
{
	int		PlotScale		= 1;
	int   MinorScale  = 0;
	int		length			= 0;
	int		hpos				= 0;

	int   i						= 0;
	int   j						= 0;
	int		k						= 0;
	int   l						= 0;

	int   px					= 0;
	int   py					= 0;

	int		t						= 0;
	int		i_py_min		= 0;
	int		i_py_max		= 0;
	int		i_py_line		= 0;

	int   P13					= 0;
	int   py1					= 0;
				
	float dst					= (float) 0.;
	float dx					= (float) 0.;
	float dy					= (float) 0.;

	float xmin				= (float) 0.;
	float xmax				= (float) 0.;
	            
	float F						= (float) 0.;
	float Smin				= (float) 0.;
	float	f_Value			= (float) 0.;

	Str31 s_Value     = "";

// ********************************************************************
      
	SetFont(hdc,(char *) Font,FontSize-2,NORMAL,0);

	F = (float) cxDpi/ScreenDpi;

	MinorScale = Scale/2;

	for (j=1;j<=gNumOfParameters;j++)
	{
		if (ST[j].PlotData > 0)
		{
			if (++l > gSelectedNumOfParameters)
				return;

			dx				= C[j].S[2] - C[j].S[1];
			Smin			= C[j].S[1];
			i_py_min	= C[j].P[2];
			i_py_max	= C[j].P[2] + C[j].P[4];

      if (ST[0].Tick_Increment != 0.)
			{
	      t			= (int) (dx/ST[0].Tick_Increment + 0.1);
				dst		= ST[0].Tick_Increment/(float) (ST[0].Minor_Ticks+1);
			}

// *****************************************
// Tick lines

			if (ST[0].Tickline > 0)
			{
				for (i=1; i<=t; i++)
				{
					f_Value	= Smin+(float) i*ST[0].Tick_Increment;
					py			= (int) yinpy( C[j].K[3], C[j].K[4], f_Value );

					if ( ( i_py_min < py ) && ( py < i_py_max ) )
  					CLinie( hdc, C[j].P[1], py, C[j].P[1]+C[j].P[3], py, ST[0].LineWidth*(int) F, ST[0].Color);
				}
			}

// *****************************************
// Minor tick lines

			if (ST[0].Minor_Tickline > 0)
      {
				for (i=0; i<=t; i++)
				{
					f_Value	= Smin+(float) i*ST[0].Tick_Increment;
					
					for (k=1; k<=ST[0].Minor_Ticks; k++)
					{
						py = (int) yinpy( C[j].K[3], C[j].K[4], f_Value+(float) k*dst );
	
						if ( ( i_py_min < py ) && ( py < i_py_max ) )
	  	    		CLinie(hdc, C[j].P[1], py, C[j].P[1]+C[j].P[3], py, ST[0].LineWidth*(int) F, ST[0].Color);
					}
				}
      }

// *****************************************
// Ticks

			if (ST[0].Inside > 0)
				px = C[j].P[1] + Scale;
			else   
				px = C[j].P[1] - Scale;
		    
      for (i=0; i<=t; i++)
      {
				f_Value	= Smin+(float) i*ST[0].Tick_Increment;
        py			= (int) yinpy( C[j].K[3], C[j].K[4], f_Value );

				if (abs(py-i_py_min) < 4)
          py = i_py_min;
        
				if (abs(py-i_py_max) < 4)
          py = i_py_max;

				if ( ( i_py_min <= py ) && ( py <= i_py_max ) )
					CLinie(hdc, px, py, C[j].P[1], py, ST[0].LineWidth*(int) F, BLACK);
      }

// *****************************************
// Minor ticks

			if (ST[0].Inside > 0)
				px = C[j].P[1] + (MinorScale);
			else   
				px = C[j].P[1] - (MinorScale);
		    
      for (i=0; i<=t; i++)
      {
				f_Value	= Smin+(float) i*ST[0].Tick_Increment;
				
				for (k=1; k<=ST[0].Minor_Ticks; k++)
				{
					py = (int) yinpy( C[j].K[3], C[j].K[4], f_Value+(float) k*dst );
	
					if ( ( i_py_min <= py ) && ( py <= i_py_max ) )
						CLinie(hdc, px, py, C[j].P[1], py, ST[0].LineWidth*(int) F, BLACK);
				}
      }

// *****************************************
// Other side

			if (ST[0].BothSide > 0)
			{
				P13 = C[j].P[1] + C[j].P[3];

// Ticks
				if (ST[0].Inside > 0)
					px = P13 - Scale;
				else   
					px = P13 + Scale;

				for (i=0; i<=t; i++)
        {
					f_Value	= Smin+(float) i*ST[0].Tick_Increment;
					py			= (int) yinpy( C[j].K[3], C[j].K[4], f_Value ); 

					if (abs(py-i_py_min) < 4)
						py = i_py_min;
	        
					if (abs(py-i_py_max) < 4)
						py = i_py_max;

					if ( ( i_py_min <= py ) && ( py <= i_py_max ) )
						CLinie( hdc, px, py, P13, py, ST[0].LineWidth*(int) F, BLACK);
        }

// Minor ticks
				if (ST[0].Inside > 0)
					px = P13 - (MinorScale);
				else   
					px = P13 + (MinorScale);

				for (i=0; i<=t; i++)
				{
					f_Value	= Smin+(float) i*ST[0].Tick_Increment;
					
					for (k=1; k<=ST[0].Minor_Ticks; k++)
					{
						py = (int) yinpy( C[j].K[3], C[j].K[4], f_Value+(float) k*dst );

						if ( ( i_py_min <= py ) && ( py <= i_py_max ) )
							CLinie( hdc, px, py, P13, py, ST[0].LineWidth*(int) F, BLACK );
					}
        }
			}   

// *****************************************
// Reference line

			i_py_line = (int) yinpy(C[j].K[3],C[j].K[4],ST[0].Refline);
      
      if ( ( i_py_min < i_py_line ) && ( i_py_line < i_py_max ) && ( ST[j].Colorize < 1 ) )
				CLinie( hdc, C[j].P[1], i_py_line, C[j].P[1]+C[j].P[3], i_py_line, KoorLineWidth*(int) F, BLACK );

// *****************************************
// Scale

			hpos	= C[j].P[1] - 2*ATE - Scale;

			if ( ST[0].ReverseRange == 0 )
				py1 = i_py_max + 4*HxValueHeight;
			else
				py1 = i_py_min - 3*HxValueHeight;

			for (i=0; i<=t; i++)
      {
				f_Value	= Smin+(float) i*ST[0].Tick_Increment;
        py			= (int) yinpy( C[j].K[3], C[j].K[4], f_Value );

				if ( abs( py-i_py_min ) < 4 )
          py = i_py_min;
        
				if ( abs( py-i_py_max ) < 4 )
          py = i_py_max;

				if ( ( i_py_min <= py ) && ( py <= i_py_max ) && ( PlotScale > 0) )
				{
					if ( ( !isDate ) && ( !isTime ) )
						sprintf( (char *) s_Value,(char *) ST[0].FormatStr, f_Value );
					else
						CreateDateTimeStr( f_Value, (char *) s_Value, dx );

					py = py + HxValueHeight;

					if ( ST[0].ReverseRange == 0 )
					{				
						if ( py1 >= ( py + 3*HxValueHeight ) )
						{
							PutText( hdc, (char *) s_Value, hpos, py, xValueHeight, RIGHT );
							py1 = py;
						}
					}
					else
					{				
						if ( py1 <= (py - 3*HxValueHeight) )
						{
							PutText( hdc, (char *) s_Value, hpos, py, xValueHeight, RIGHT);
							py1 = py;
						}
					}
				}
      }

			PlotScale = 0;
		}
	}
}
