/* Dr. Rainer Sieger, AWI Bremerhaven       /
/  letztes Editierdatum: 15.10.97          */

#include <windows.h>
#include <math.h>
#include <stdio.h>
#include <string.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Ezfont.h"

#include "floattostr.h"
#include "PutText.h"
#include "Graphic.h"
#include "Plotter.h"
#include "Font.h"
#include "CheckData.h"
#include "ForeColor.h"

void YSkalierungH(HDC hdc, int Scale)
{
	int   MinorScale  = 0;

	int		hpos        = 0;
	      
	int   i           = 0;
	int   j           = 0;
	int   l           = 0;
	int		k						= 0;

	int   px          = 0;
	int   py          = 0;
	int		py1					= 0;
	int   P13         = 0;
	int   pline       = 0;
	int   pmin        = 0;
	int   pmax        = 0;

	int		t						= 0;
	int		i_py_min		= 0;
	int		i_py_max		= 0;
	int		i_py_line		= 0;

	float dst					= (float) 0.;
	float dx					= (float) 0.;
	float dy					= (float) 0.;

	float xmin				= (float) 0.;
	float xmax				= (float) 0.;
	            
	float F						= (float) 0.;
	float Smin				= (float) 0.;
	float	f_Value			= (float) 0.;

	Str31 s_Value     = "";

// *********************************************************

  SetFont(hdc,(char *) Font,FontSize-2,NORMAL,0);
 	  
  MinorScale = Scale/2;

  F = (float) cxDpi/ScreenDpi;

  for (j=1;j<=gNumOfParameters;j++)
  {
		if ((ST[j].PlotData > 0) && (ST[j].PlotData < 2) && (C[j].counts > 0))
    {
	    if (++l > gSelectedNumOfParameters) 
				return;

			dy				= C[j].S[4] - C[j].S[3];
			Smin			= C[j].S[3];
      i_py_max	= C[j].P[2];
      i_py_min	= C[j].P[2] + C[j].P[4];

      if (ST[j].Tick_Increment != 0.)
			{
	      t			= (int) (dy/ST[j].Tick_Increment + 0.1);
				dst		= ST[j].Tick_Increment/(float) (ST[j].Minor_Ticks+1);
			}

// *****************************************
// Tick lines

			if (ST[j].Tickline > 0)
      {
        for (i=1; i<=t; i++)
        {
					f_Value	= Smin+(float) i*ST[j].Tick_Increment;
					py			= (int) yinpy( C[j].K[3], C[j].K[4], f_Value );

					if ( ( i_py_min < py ) && ( py < i_py_max ) )
	          CLinie( hdc, C[j].P[1], py, C[j].P[1]+C[j].P[3], py, ST[0].LineWidth*(int) F, ST[0].Color);
        }
      }

// *****************************************
// Minor tick lines

			if (ST[j].Minor_Tickline > 0)
      {
				for (i=0; i<=t; i++)
				{
					f_Value	= Smin+(float) i*ST[j].Tick_Increment;
					
					for (k=1; k<=ST[j].Minor_Ticks; k++)
					{
						py = (int) yinpy( C[j].K[3], C[j].K[4], f_Value+(float) k*dst );
	
						if ( ( i_py_min < py ) && ( py < i_py_max ) )
	  	    		CLinie(hdc, C[j].P[1], py, C[j].P[1]+C[j].P[3], py, ST[0].LineWidth*(int) F, ST[0].Color);
					}
				}
      }

// *****************************************
// Ticks

			if (ST[j].Inside > 0)
				px = C[j].P[1] + Scale;
			else   
				px = C[j].P[1] - Scale;
		    
      for (i=0; i<=t; i++)
      {
				f_Value	= Smin+(float) i*ST[j].Tick_Increment;
        py			= (int) yinpy( C[j].K[3], C[j].K[4], f_Value );

				if (abs(py-i_py_min) < 4)
          py = i_py_min;
        
				if (abs(py-i_py_max) < 4)
          py = i_py_max;

				if ( ( i_py_min <= py ) && ( py <= i_py_max ) )
					CLinie(hdc, px, py, C[j].P[1], py, ST[0].LineWidth*(int) F, BLACK);
      }

// *****************************************
// Minor ticks

			if (ST[j].Inside > 0)
				px = C[j].P[1] + (MinorScale);
			else   
				px = C[j].P[1] - (MinorScale);
		    
      for (i=0; i<=t; i++)
      {
				f_Value	= Smin+(float) i*ST[j].Tick_Increment;
				
				for (k=1; k<=ST[j].Minor_Ticks; k++)
				{
					py = (int) yinpy( C[j].K[3], C[j].K[4], f_Value+(float) k*dst );
	
					if ( ( i_py_min <= py ) && ( py <= i_py_max ) )
						CLinie(hdc, px, py, C[j].P[1], py, ST[0].LineWidth*(int) F, BLACK);
				}
      }

// *****************************************
// Other side

			if (ST[j].BothSide > 0)
			{
				P13 = C[j].P[1] + C[j].P[3];

// Ticks
				if (ST[j].Inside > 0)
					px = P13 - Scale;
				else   
					px = P13 + Scale;

				for (i=0; i<=t; i++)
        {
					f_Value	= Smin+(float) i*ST[j].Tick_Increment;
					py			= (int) yinpy( C[j].K[3], C[j].K[4], f_Value ); 

					if (abs(py-i_py_min) < 4)
						py = i_py_min;
	        
					if (abs(py-i_py_max) < 4)
						py = i_py_max;

					if ( ( i_py_min <= py ) && ( py <= i_py_max ) )
						CLinie( hdc, px, py, P13, py, ST[0].LineWidth*(int) F, BLACK);
        }

// Minor ticks
				if (ST[j].Inside > 0)
					px = P13 - (MinorScale);
				else   
					px = P13 + (MinorScale);

				for (i=0; i<=t; i++)
				{
					f_Value	= Smin+(float) i*ST[j].Tick_Increment;
					
					for (k=1; k<=ST[j].Minor_Ticks; k++)
					{
						py = (int) yinpy( C[j].K[3], C[j].K[4], f_Value+(float) k*dst );

						if ( ( i_py_min <= py ) && ( py <= i_py_max ) )
							CLinie( hdc, px, py, P13, py, ST[0].LineWidth*(int) F, BLACK );
					}
        }
			}   

// *****************************************
// Reference line

			i_py_line = (int) yinpy(C[j].K[3], C[j].K[4], ST[j].Refline);
      
			if (abs(i_py_line-i_py_min) < 4)
				i_py_line = i_py_min;
	    
			if (abs(i_py_line-i_py_max) < 4)
				i_py_line = i_py_max;

      if ( ( i_py_min < i_py_line ) && ( i_py_line < i_py_max ) && ( ST[j].Colorize < 1 ) )
				CLinie( hdc, C[j].P[1], i_py_line, C[j].P[1]+C[j].P[3], i_py_line, KoorLineWidth*(int) F, BLACK );

// *****************************************
// Scale

			hpos	= C[j].P[1] - 2*ATE - Scale;

			if ( ST[j].ReverseRange == 0 )
				py1 = i_py_max + 4*HxValueHeight;
			else
				py1 = i_py_min - 3*HxValueHeight;

			for (i=0; i<=t; i++)
      {
				f_Value	= Smin+(float) i*ST[j].Tick_Increment;
        py			= (int) yinpy( C[j].K[3], C[j].K[4], f_Value );

				if ( abs( py-i_py_min ) < 4 )
          py = i_py_min;
        
				if ( abs( py-i_py_max ) < 4 )
          py = i_py_max;

				if ( ( i_py_min <= py ) && ( py <= i_py_max ) )
				{
					sprintf( (char *) s_Value,(char *) ST[j].FormatStr, f_Value );

					if ( ( i >= 0 ) && ( i <= t ) )
						py = py + HxValueHeight;

					if ( ( WindowOffset <= HxValueHeight ) && ( i == t ) && ( j > 1 ) )
						py = 0;

					if ( ST[j].ReverseRange == 0 )
					{				
						if ( ( py1 >= ( py + 3*HxValueHeight ) ) && ( py > 0 ) )
						{
							PutText( hdc, (char *) s_Value, hpos, py, xValueHeight, RIGHT );
							py1 = py;
						}
					}
					else
					{				
						if ( ( py1 <= ( py - 3*HxValueHeight ) ) && ( py > 0 ) )
						{
							PutText( hdc, (char *) s_Value, hpos, py, xValueHeight, RIGHT);
							py1 = py;
						}
					}
				}
      }

			if (AllInOne > 0)
				return;
    }
  }
}


