/* Dr. Rainer Sieger, AWI Bremerhaven       /
/  letztes Editierdatum: 11.09.2007        */

#include <windows.h>
#include <math.h>
#include <string.h>

#include "Struct.h"
#include "Globals.h"

#include "Win_GUI.h"
#include "Ezfont.h"

#include "floattostr.h"
#include "PutText.h"
#include "Graphic.h"
#include "Plotter.h"
#include "Font.h"

void YSkalierungV(HDC hdc, int Scale)
{
	int		vpos				= 0;
	int		tpos        = 0;

	int		t1          = 0;
	int   t2          = 0;
	      
	int   i           = 0;
	int   j           = 0;
	int		k						= 0;
	int   l           = 0;

	int   MinorScale  = 0;

	int   px          = 0;
	int   py          = 0;
	int   P24         = 0;

	int		t           = 0;

	int		i_TextWidth	= 0;
	int   i_px_line   = 0;
	int		i_px_min		= 0;
	int		i_px_max		= 0;
	int		i_Distance	= 2;

	float dst					= (float) 1.;
	float dx          = (float) 0.;
	float dy          = (float) 0.;
	      
	float F         	= (float) 0.;
	float Smin        = (float) 0.;
	float	f_Value			= (float) 0.;

	Str31 s_Value     = "";

// *********************************************************

  SetFont(hdc,(char *) Font,FontSize-2,NORMAL,0);
 	  
  MinorScale = Scale/2;

  F = (float) cxDpi/ScreenDpi;

  for ( j=1; j<=gNumOfParameters; j++)
  {
		if ((ST[j].PlotData > 0) && (ST[j].PlotData < 2) && (C[j].counts > 0))
    {
	    if (++l > gSelectedNumOfParameters) 
				return;

      dy				= C[j].S[4] - C[j].S[3];
			Smin			= C[j].S[3];
      i_px_min	= C[j].P[1];
      i_px_max	= C[j].P[1] + C[j].P[3];

      if (ST[j].Tick_Increment != 0.)
			{
	      t			= (int) (dy/ST[j].Tick_Increment + 0.1);
				dst		= ST[j].Tick_Increment/(float) (ST[j].Minor_Ticks+1);
			}

// *****************************************
// Tick lines

			if (ST[j].Tickline > 0)
      {
        for (i=1; i<=t; i++)
        {
					f_Value	= Smin+(float) i*ST[j].Tick_Increment;
					px			= (int) xinpx( C[j].K[1], C[j].K[2], f_Value );

					if (abs(px-i_px_max) < 4)
						px = i_px_max;

					if ( ( i_px_min < px ) && ( px < i_px_max ) )
	          CLinie( hdc, px, C[j].P[2], px, C[j].P[2]+C[j].P[4], ST[0].LineWidth*(int) F, ST[0].Color);
        }
      }
      
// *****************************************
// Minor tick lines

			if (ST[j].Minor_Tickline > 0)
      {
				for (i=0; i<=t; i++)
				{
					f_Value	= Smin+(float) i*ST[j].Tick_Increment;
					
					for (k=1; k<=ST[j].Minor_Ticks; k++)
					{
						px = (int) xinpx( C[j].K[1], C[j].K[2], f_Value+(float) k*dst );
	
						if (abs(px-i_px_max) < 4)
							px = i_px_max;

						if ( ( i_px_min < px ) && ( px < i_px_max ) )
		          CLinie( hdc, px, C[j].P[2], px, C[j].P[2]+C[j].P[4], ST[0].LineWidth*(int) F, ST[0].Color);
					}
				}
      }

// *****************************************
// Ticks

			if (ST[j].Inside > 0)
        py = C[j].P[2] + Scale;
      else   
        py = C[j].P[2] - Scale;

      for (i=0; i<=t; i++)
      {
				f_Value	= Smin+(float) i*ST[j].Tick_Increment;
        px			= (int) xinpx( C[j].K[1], C[j].K[2], f_Value );

				if (abs(px-i_px_min) < 4)
          px = i_px_min;
        
				if (abs(px-i_px_max) < 4)
          px = i_px_max;

				if ( ( i_px_min <= px ) && ( px <= i_px_max ) )
					CLinie( hdc, px, C[j].P[2], px, py, ST[0].LineWidth*(int) F, BLACK );
      }

// *****************************************
// Minor ticks

      if (ST[j].Inside > 0)
        py = C[j].P[2] + (MinorScale);
      else   
        py = C[j].P[2] - (MinorScale);

      for (i=0; i<=t; i++)
      {
				f_Value	= Smin+(float) i*ST[j].Tick_Increment;
				
				for (k=1; k<=ST[j].Minor_Ticks; k++)
				{
					px = (int) xinpx( C[j].K[1], C[j].K[2], f_Value+(float) k*dst );
	
					if ( ( i_px_min <= px ) && ( px <= i_px_max ) )
						CLinie( hdc, px, C[j].P[2], px, py, ST[0].LineWidth*(int) F, BLACK );
				}
      }

// *****************************************
// Other side

      if (ST[j].BothSide > 0)
      {
        P24 = C[j].P[2] + C[j].P[4];

// Ticks
				if (ST[j].Inside > 0)
          py = P24 - Scale;
        else   
          py = P24 + Scale;

				for (i=0; i<=t; i++)
        {
					f_Value	= Smin+(float) i*ST[j].Tick_Increment;
					px			= (int) xinpx( C[j].K[1], C[j].K[2], f_Value );

					if (abs(px-i_px_min) < 4)
						px = i_px_min;
	        
					if (abs(px-i_px_max) < 4)
						px = i_px_max;

					if ( ( i_px_min <= px ) && ( px <= i_px_max ) )
						CLinie( hdc, px, P24, px, py, ST[0].LineWidth*(int) F, BLACK );
        }

// Minor ticks
				if (ST[j].Inside > 0)
          py = P24 - (MinorScale);
        else   
          py = P24 + (MinorScale);

				for (i=0; i<=t; i++)
				{
					f_Value	= Smin+(float) i*ST[j].Tick_Increment;
					
					for (k=1; k<=ST[j].Minor_Ticks; k++)
					{
						px = (int) xinpx( C[j].K[1], C[j].K[2], f_Value+(float) k*dst );

						if ( ( i_px_min <= px ) && ( px <= i_px_max ) )
							CLinie( hdc, px, P24, px, py, ST[0].LineWidth*(int) F, BLACK );
					}
        }
      } 

// *****************************************
// Reference line

			i_px_line	= (int) xinpx(C[j].K[1],C[j].K[2],ST[j].Refline);
      
			if (abs(i_px_line-i_px_min) < 4)
        i_px_line = i_px_min;
      
			if (abs(i_px_line-i_px_max) < 4)
        i_px_line = i_px_max;

			if ( ( i_px_min < i_px_line ) && ( i_px_line < i_px_max ) && ( ST[j].Colorize < 1 ) )
        CLinie( hdc, i_px_line, C[j].P[2], i_px_line, C[j].P[2]+C[j].P[4], KoorLineWidth*(int) F, BLACK );
        
// *****************************************
// Text

			vpos = C[j].P[2] - Scale - ATE;

			if ( ST[j].ReverseRange == 0 )
			{
				floattostr(C[j].S[3],(char *) ST[j].FormatStr,(char *) s_Value);
				t1 = CalcTextWidth(hdc, (char *) s_Value, 0, (int) strlen((char *) s_Value));			
				i_px_min = C[j].P[1] + 1 + t1 + i_Distance;

				if ( ( WindowOffset < t1 ) && ( j > 1 ) )
					PutText(hdc,(char *) s_Value,C[j].P[1]+1,vpos,yValueHeight,LEFT);
				else
					PutText(hdc,(char *) s_Value,C[j].P[1]+1,vpos,yValueHeight,CENTER);

				floattostr(C[j].S[4],(char *) ST[j].FormatStr,(char *) s_Value);
				t2 = CalcTextWidth(hdc, (char *) s_Value, 0, (int) strlen((char *) s_Value));			
				i_px_max = C[j].P[1] + C[j].P[3] - 1 - t2 - i_Distance;
	
				if ( C[j].P[3] > (t1+t2+2*i_Distance) )
					PutText(hdc,(char *) s_Value,C[j].P[1]+C[j].P[3]-1,vpos,yValueHeight,RIGHT);
			}
			else
			{
				floattostr(C[j].S[4],(char *) ST[j].FormatStr,(char *) s_Value);
				t1 = CalcTextWidth(hdc, (char *) s_Value, 0, (int) strlen((char *) s_Value));			
				i_px_min = C[j].P[1] + 1 + t1 + i_Distance;

				if ( WindowOffset < t1 )
					PutText(hdc,(char *) s_Value,C[j].P[1]+1,vpos,yValueHeight,LEFT);
				else
					PutText(hdc,(char *) s_Value,C[j].P[1]+1,vpos,yValueHeight,CENTER);

				floattostr(C[j].S[3],(char *) ST[j].FormatStr,(char *) s_Value);
				t2 = CalcTextWidth(hdc, (char *) s_Value, 0, (int) strlen((char *) s_Value));			
				i_px_max = C[j].P[1] + C[j].P[3] - 1 - t2 - i_Distance;

				if ( C[j].P[3] > (t1+t2+2*i_Distance) )
		      PutText(hdc,(char *) s_Value,C[j].P[1]+C[j].P[3]-2,vpos,yValueHeight,RIGHT);
			}

      if ( C[j].P[3] > (i_px_max-i_px_min) )
      {
        for (i=1; i<=t-1; i++)
        {
					f_Value	= Smin+(float) i*ST[j].Tick_Increment;
					px			= (int) xinpx( C[j].K[1], C[j].K[2], f_Value );
          floattostr( f_Value, (char *) ST[j].FormatStr, (char *) s_Value);
					
					i_TextWidth = CalcTextWidth(hdc, (char *) s_Value, 0, (int) strlen((char *) s_Value));			
					
					if ( ( i_px_min < px-i_TextWidth/2-i_Distance ) && ( px+i_TextWidth/2+i_Distance < i_px_max ) )
					{
						if ( ST[j].ReverseRange == 0 )
							i_px_min = px + i_TextWidth/2 + i_Distance;
						else
							i_px_max = px - i_TextWidth/2 - i_Distance;

						PutText(hdc,(char *) s_Value, px, vpos, yValueHeight, CENTER);
					}
	      }
      }

			if (AllInOne > 0)
				return;
    }
  }
}
