/*-----------------------------------------*/
/*  Definitionen fuer PanPlot              */
/*  Dr. Rainer Sieger, AWI-Bremerhaven     */
/*-----------------------------------------*/

#define  HorizontalMode        0
#define  VerticalMode          1
#define  TernaryMode           2
#define  PhaseMode             3

#define  NORMAL                0
#define  BOLD                  1

#define  NoInit                0
#define  Init                  1
#define  Export                2
#define  ExportToFile          3
#define  Print                 4

#define  CommandTaste          0
#define  Maus                  1

#define	 useParameters				 1
#define  useGroups						 2

// ------------------------------------------------------------------------------------------------
// Resource-IDs.
// ------------------------------------------------------------------------------------------------

#define rWindow						128					// Resource-ID der WIND-Resource.
#define rMenuBar					128					// Resource-ID der MBAR-Resource.
#define rOutOfMemory			129					// Resource-ID des "Out of memory"-Dialogs.
#define rOutOfPICTMemory	134					// Resource-ID des "Out of memory"-Dialogs.
#define rWrongData  			130					// Resource-ID des "Wrong format of data"-Dialogs.
#define rMaxDataOverflow	131					// Resource-ID des "maxDataOverfow"-Dialogs.
#define rMaxNumOfParametersOverflow	132 		// Resource-ID des "maxDataOverfow"-Dialogs.
#define rSaveGraphic      133
#define rPrintRecID	      128			    /* Print record resource ID in the preferences file */
#define rInfo							135 
#define rVersion					136 
#define rVInfo 						137
#define rShareware				138
#define rRoutineNo				140
#define rAboutDialog			128				// Resource-ID des "ber Programm"-Dialogs.

// Menu - IDs.

#define mApple						128					// Menu-ID des "Apple"-Mens.
#define mFile							129					// Menu-ID des "File"-Mens.
#define mEdit							130					// Menu-ID des "Edit"-Mens.
#define mOption           131         // Menu-ID des "Options"-Mens
#define mYAxis            132         // Menu-ID des "Y Axis"-Untermens
#define mTemplates        133         // Menu-ID des "Templates"-Untermens
#define mTools            134         // Menu-ID des "Tools"-Mens
#define mHelp             135         // Menu-ID des "?"-Mens
#define mSetAll           136         // Menu-ID des "Set all"-Untermens
#define mColor            137         // Menu-ID des "Color"-Untermens

// "Apple"-Menpunkte.

#define iAbout							1 				// "ber Programm".

// "File"-Menpunkte.

#define iNew                				1   // "New"
#define iOpen               				2   // "Open..."
#define iClose              				3   // "Close"
#define iOpenDataPlotWindow					5
#define iOpenDataDescriptionWindow	6	
#define iSave               				8   // "Save"
#define iSaveas             				9   // "Save as..."
#define iExportPICT         				11  // "Export (PICT)..."
#define iBatch              				12  // "Batch..."
#define iPageSetup				 					14	// "Page Setup ..."
#define iPrint             					15	// "Print..."
#define iTemplates         					17  // "Templates"
#define iPreferences       					18  // "Save Preferences"
#define iQuit							 					20	// "Beenden".

// "Edit"-Menpunkte.

#define iUndo								1					// "Widerrufen".
#define iCut								3					// "Ausschneiden".
#define iCopy								4					// "Kopieren".
#define iPaste							5					// "Einsetzen".
#define iClear							6					// "Lschen".
#define iPlotNew            8         // "Plot new"

// "Options"-Menpunkte.

#define iHorizontalMode     1         // "HorizontalMode"
#define iVerticalMode	      2         // "VerticalMode"
#define iTernaryMode        3         // "TernaryMode"
#define iPhaseMode          4         // "PhaseMode"

#define iGraphic            6         // "Graphic..."

#define iXAxis              8         // "X Axis..."
#define iYAxis              9         // "Y AXis"

// "Tools"-Menpunkte

#define iSplit              1         // "Split data file..."
#define iMacToWin           3         // "MacOS   -> Windows ..."
#define iWinToMac           4         // "Windows -> MacOS ..."

// "?"-Menpunkte

#define iInfo               1         // "Info"
#define iVersion            2         // "Version"

// Untermen "Y Axis"

#define iuPSelect           1         // "Select parameters..."
#define iuGSelect           2         // "Select groups..."
#define iuSelectAll         3         // "Plot all"
#define iuSelectNone        4         // "Plot none"

// Untermen "Templates"

#define iuLoad              1         // "Load..."
#define iuSaveas            2         // "Save as..." 

// Untermenu "Set all"

#define iuMaxAxisLength							1
#define iuAddNext           				2
#define iuParameterTextOrientation	3
#define iuRange             				4
#define iuTicks             				5
#define iuMarker            				6
#define iuOptions           				7
#define iuQualityFlags       				8
#define iuColor             				9
#define iuLineWidth         			 10
#define iuColumnWidth       			 11
#define iuEpsilon          				 12

// Untermenu "Color"
#define iuallColor									1
#define iuColorMapping							2

// Dialoge

#define  dGraphic         					139
#define  dTGraphic        					200
#define  dPGraphic        					225
#define  dXAxis           					201
#define  dSelect          					203
#define  dTernaryMode      					211
#define  dParameterAxis   					219
#define  dParameterOptions					220
#define  dPhaseMode									221
#define	 dParameterTextOrientation	224
#define	 dChangeMode								226
#define  dAddNext    								210    
#define  dOptions    								209
#define  dRange      								208
#define  dTicks      								207
#define  dMarker     								206
#define  dLineWidth  								205
#define  dTMarker    								212
#define  dEpsilon    								213
#define  dColumnWidth  							214
#define  dMaxAxisLength 						216
#define  dPhaseModeRange  					222
#define	 dColorMapping        			223
#define	 dQualityFlags        			227



// ********************************************
// Raender

#define RLT    5  // Rand links zum Text
#define RRT    5  // Rand rechts zum Text
#define ROT    5  // Rand oben zum Text
#define RUT   25  // Rand unten zum Text
#define MSL   15  // Max scale length
#define ATE    3  // Abstand zwischen Titel und Einheit

